Package: OUTRIDER
Title: OUTRIDER - OUTlier in RNA-Seq fInDER
Type: Package
Version: 1.31.0
Date: 2026-02-10
URL: https://github.com/gagneurlab/OUTRIDER
BugReports: https://github.com/gagneurlab/OUTRIDER/issues
Authors@R: c(
    person("Felix", "Brechtmann", role=c("aut"), 
            email="brechtma@in.tum.de", comment=c(ORCID="0000-0002-0110-152X")),
    person("Christian", "Mertes", role=c("aut", "cre"), 
            email="mertes@in.tum.de", comment=c(ORCID="0000-0002-1091-205X")),
    person("Agne", "Matuseviciute", role=c("aut")),
    person(c("Michaela", "Fee"), "Müller", role=c("ctb")),
    person("Andrea", "Raithel", role=c("ctb")),
    person("Vicente", "Yepez", role=c("aut"), email="yepez@in.tum.de",
            comment=c(ORCID="0000-0001-7916-3643")),
    person("Julien", "Gagneur", role=c("aut"), email="gagneur@in.tum.de",
            comment=c(ORCID="0000-0002-8924-8365")))
Description: Identification of aberrant gene expression in RNA-seq data.
    Read count expectations are modeled by an autoencoder to control for
    confounders in the data. Given these expectations, the RNA-seq read counts
    are assumed to follow a negative binomial distribution with a gene-specific
    dispersion. Outliers are then identified as read counts that significantly 
    deviate from this distribution. Furthermore, OUTRIDER provides useful 
    plotting functions to analyze and visualize the results.
VignetteBuilder: knitr
biocViews: ImmunoOncology, RNASeq, Transcriptomics, Alignment,
        Sequencing, GeneExpression, Genetics
License: file LICENSE
NeedsCompilation: yes
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 3.6), BiocParallel, GenomicFeatures,
        SummarizedExperiment, methods
Imports: BBmisc, BiocGenerics, data.table, DESeq2 (>= 1.16.1),
        generics, GenomicRanges, ggplot2, ggrepel, graphics, grDevices,
        heatmaply, IRanges, matrixStats, pcaMethods, pheatmap, plotly,
        plyr, pracma, PRROC, RColorBrewer, reshape2, RMTstat,
        S4Vectors, scales, splines, stats, txdbmaker, utils
Suggests: testthat, knitr, rmarkdown, BiocStyle,
        TxDb.Hsapiens.UCSC.hg19.knownGene, org.Hs.eg.db, RMariaDB,
        AnnotationDbi, beeswarm, covr, GenomeInfoDb, ggbio, biovizBase
LinkingTo: Rcpp, RcppArmadillo
Collate: package-OUTRIDER.R class-OutriderDataSet.R AllGenerics.R
        inputCheckerFunctions.R helperFunctions.R getNSetterFuns.R
        getNSetterFunsInternal.R autoencoder.R fitNB.R ZscoreMatrix.R
        method-evaluation.R method-counts.R method-estimateBestQ.R
        method-plot.R method-results.R pValMatrix.R filterExpression.R
        OUTRIDER.R sizeFactor.R RcppExports.R updateE.R updateD.R
        updateTheta.R PCAcorrections.R thetaMethodOfMoments.R
        controlForConfounders.R lossNGradientRVersion.R
git_url: https://git.bioconductor.org/packages/OUTRIDER
git_branch: devel
git_last_commit: f5f7a6b
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
Packaged: 2026-04-29 00:18:11 UTC; biocbuild
Author: Felix Brechtmann [aut] (ORCID: <https://orcid.org/0000-0002-0110-152X>),
  Christian Mertes [aut, cre] (ORCID:
    <https://orcid.org/0000-0002-1091-205X>),
  Agne Matuseviciute [aut],
  Michaela Fee Müller [ctb],
  Andrea Raithel [ctb],
  Vicente Yepez [aut] (ORCID: <https://orcid.org/0000-0001-7916-3643>),
  Julien Gagneur [aut] (ORCID: <https://orcid.org/0000-0002-8924-8365>)
Maintainer: Christian Mertes <mertes@in.tum.de>

# OUTRIDER #
[![Build](https://github.com/gagneurlab/OUTRIDER/actions/workflows/check-bioc.yml/badge.svg)](https://github.com/gagneurlab/OUTRIDER/actions/workflows/check-bioc.yml)
[![Version](https://img.shields.io/github/v/release/gagneurlab/OUTRIDER)](https://github.com/gagneurlab/OUTRIDER/releases)
[![Coverage status](https://codecov.io/gh/gagneurlab/OUTRIDER/branch/master/graph/badge.svg)](https://codecov.io/github/gagneurlab/OUTRIDER?branch=master)
[![License](https://img.shields.io/badge/license-CC--BY--NC%204.0-green)](https://github.com/gagneurlab/OUTRIDER/blob/master/LICENSE)

OUTRIDER is a tool to find aberrantly expressed genes in RNA-seq samples.
The method is published in the [AJHG](https://doi.org/10.1016/j.ajhg.2018.10.025)
and available through [Bioconductor](http://bioconductor.org/packages/release/bioc/html/OUTRIDER.html).
It is also part of the workflow [DROP](https://github.com/gagneurlab/drop), which is described in [Nature Protocols](https://www.nature.com/articles/s41596-020-00462-5).

Please cite our method paper if you use it in a publication:

> Brechtmann F, Mertes C, Matusevičiūtė A, *et al.* OUTRIDER: A Statistical Method for Detecting Aberrantly Expressed Genes in RNA Sequencing Data. *Am J Hum Genet. 2018;103(6):907-917*. https://doi.org/10.1016/j.ajhg.2018.10.025

Since v. 1.26.2, OUTRIDER uses the Optimal Hard Threshold algorithm to determine the optimal encoding dimension `q`. This makes the algorithm 6-10 times faster!

⚠️ Also, since this version, OUTRIDER is released under `CC-BY-NC 4.0`, meaning it requires a license for any commercial use. The commercial license is distributed by [OmicsDiscoveries](https://www.omicsdiscoveries.com). If you intend to use it for commercial purposes, please write to license@omicsdiscoveries.com.

## Installation

`OUTRIDER` is an R software package requiring a running [R 3.6 version or higher](https://cran.r-project.org/).

We will use `BiocManager` to install the package and its dependencies. For the devel version
of `OUTRIDER`, [see below](#OUTRIDER-development-installation).


```
if (!requireNamespace("BiocManager", quietly=TRUE))
    install.packages("BiocManager")
BiocManager::install('OUTRIDER')
```

If you have dependency issues while installing any package, please have a look
at the Troubleshooting section or submit an issue on [GitHub](https://github.com/gagneurlab/OUTRIDER/issues).

### OUTRIDER development installation

If you want to get the latest
development version of `OUTRIDER`, you can install it from GitHub with
`devtools`. For this, you need a working development environment to compile the
C++ code (see for details: [Windows](https://cran.r-project.org/bin/windows/Rtools/)
or [MacOS X](https://cran.r-project.org/bin/macosx/tools/)).

```
install.packages('devtools')

# latest development version
devtools::install_github('gagneurlab/OUTRIDER', dependencies=TRUE)

# installing a specific version/tag of OUTRIDER
devtools::install_github('gagneurlab/OUTRIDER@1.22.0', dependencies=TRUE)
```

To check which versions/tags are available you can check the GitHub repo
[here](https://github.com/gagneurlab/OUTRIDER/releases).

### Quick tour through OUTRIDER

To get started with `OUTRIDER`, please have a look at our
[vignette](http://bioconductor.org/packages/release/bioc/vignettes/OUTRIDER/inst/doc/OUTRIDER.pdf).
In order to get the pdf version, please type the following code in an R session:

```
library(OUTRIDER)
vignette('OUTRIDER')
```

### Toubleshooting

#### Missing libraries while compiling R packages

On some Linux distributions we need the developer libraries for compiling the R packages.

To install those packages, please run as administrator: 

For Ubuntu or debian based systems:
```
sudo apt-get install build-essential libcurl4-gnutls-dev libxml2-dev libssl-dev zlib1g-dev libmariadbd-dev
```

For centOS or RHEL based systems:
```
sudo yum install R-devel zlib-devel openssl-devel libcurl-devel libxml2-devel mariadb-devel
```

counts.replace.OutriderDataSet <- function(object, ..., value){
    mode(value) <- "integer"
    assay(object, "counts", ...) <- value

    validObject(object)
    object
}

counts.OutriderDataSet <- function(object, normalized=FALSE, minE=0.5, ...){
    cnts <- assay(object, "counts", ...)
    
    # raw counts
    if(!normalized) {
        return(cnts)
    }
    
    # normalized by normalization factors
    if(!is.null(normalizationFactors(object))) {
        if(!"expectedLogGeomMean" %in% colnames(mcols(object))){
            stop("The expectedLogGeomMean is missing in mcols(ods). ",
                    "Did you set the normaliationFactors by hand? ",
                    "Please use normalizationFactors(object) <- values.")
        }
        
        # use cached expected log geom mean values
        eMat <- pmax(normalizationFactors(object), minE)
        eLGM <- mcols(object)[["expectedLogGeomMean"]]
        return(cnts/eMat * eLGM)
    }
    
    # normalization by sizeFactors
    if(is.null(sizeFactors(object)) || any(is.na(sizeFactors(object)))) {
        stop(paste("first calculate size factors, add normalizationFactors,",
                "or set normalized=FALSE"))
    }
    return(t(t(cnts) / sizeFactors(object)))
}

#' 
#' Accessors for the 'counts' slot of an OutriderDataSet object.
#' 
#' The counts slot holds the count data as a matrix of non-negative integer
#' count values, one row for each observational unit (eg.: gene), and one
#' column for each sample. 
#'
#' By default this function returns the raw counts. If conrol factors are
#' computed or provided the normalized counts can be returned using 
#' normalized = TRUE. The offset parameter can be used to add a pseudocount
#' to the count before dividing by the normalization. This can be usefull 
#' when the log(counts) are computed and in case the controll values are in 
#' the same oder of magnited as the counts.
#'
#' @docType methods
#' @name counts
#' @rdname counts
#' @aliases counts counts,OutriderDataSet-method 
#'         counts<-,OutriderDataSet,matrix-method
#'
#' @param object An \code{\link{OutriderDataSet}} object
#' @param normalized TRUE/FALSE whether counts should be normalized
#' @param value An integer matrix containing the counts
#' @param minE The minimal expected count, defaults to 0.5, to be used in 
#'          computing the expected log geom mean.
#' @param ... Further arguments are passed on to the underlying assay function
#' @return A matrix containing the counts
#' 
#' @seealso \code{\link{sizeFactors}}, \code{\link{normalizationFactors}}
#'
#' @examples
#' 
#' ods <- makeExampleOutriderDataSet()
#' counts(ods)[1:10,1:10]
#'
#' ods <- estimateSizeFactors(ods)
#' counts(ods, normalized=TRUE)[1:10,1:10]
#'
#' @export counts
setMethod("counts", signature(object="OutriderDataSet"), counts.OutriderDataSet)


#' @rdname counts
#' @export "counts<-"
setReplaceMethod("counts", signature(object="OutriderDataSet", value="matrix"),
        counts.replace.OutriderDataSet)   


normalizationFactors.OutriderDataSet <- function(object, ...) {
    if (!"normalizationFactors" %in% assayNames(object)){
        return(NULL)
    }
    assay(object, "normalizationFactors", ...)
}

normFactors.replace.OutriderDataSet <- function(object, minE=0.5, ..., value) {
    # enforce same dimnames and matrix type
    if(!is.matrix(value)){
        value <- as.matrix(value)
    }
    dimnames(value) <- dimnames(object)
    
    # sanity checks
    stopifnot(!any(is.na(value)))
    stopifnot(all(is.finite(value)))
    stopifnot(all(value > 0))
    
    # set the values and check the object
    assay(object, "normalizationFactors", ..., withDimnames=FALSE) <- value
    
    # compute the expected log geom mean values so we can cache them
    mcols(object)[["expectedLogGeomMean"]] <- exp(
            rowMeans2(log(pmax(value, minE))))
    
    # validate and return object
    validObject(object)
    object
}

#' 
#' Accessor functions for the normalization factors in an OutriderDataSet
#' object.
#' 
#' To normalize raw count data normalization factors can be provided as
#' a matrix. When running \code{\link{controlForConfounders}} the normalization 
#' factors are stored within the OutriderDataset object. This normalization 
#' factors are then used to compute the normalized counts.
#'
#' @docType methods
#' @name normalizationFactors
#' @rdname normalizationFactors
#' @aliases normalizationFactors normalizationFactors,OutriderDataSet-method 
#'         normalizationFactors<-,OutriderDataSet,matrix-method 
#'         normalizationFactors<-,OutriderDataSet,DataFrame-method 
#'         normalizationFactors<-,OutriderDataSet,NULL-method
#' 
#' @inheritParams counts
#' @param value The matrix of normalization factors
#' @return A numeric matrix containing the normalization factors or the 
#'             OutriderDataSet object with an updated 
#'             \code{normalizationFactors} assay.
#' 
#' @seealso \code{\link{sizeFactors}} 
#'          \code{\link[DESeq2]{normalizationFactors}}
#' 
#' @examples
#'
#' ods <- makeExampleOutriderDataSet()
#'
#' normFactors <- matrix(runif(nrow(ods)*ncol(ods),0.5,1.5),
#'     ncol=ncol(ods),nrow=nrow(ods))
#'
#' # the normalization factors matrix should not have 0's in it
#' # it should have geometric mean near 1 for each row
#' normFactorsRM <- normFactors / exp(rowMeans(log(normFactors)))
#' normalizationFactors(ods) <- normFactorsRM
#' normalizationFactors(ods)[1:10,1:10]
#' 
#' normalizationFactors(ods) <- NULL
#' ods <- estimateSizeFactors(ods)
#' normalizationFactors(ods) <- normFactors
#' all(normalizationFactors(ods) == t(sizeFactors(ods) * t(normFactors)))
#' 
#' @export normalizationFactors
setMethod("normalizationFactors", signature(object="OutriderDataSet"),
        normalizationFactors.OutriderDataSet)

#' @rdname normalizationFactors
#' @export "normalizationFactors<-"
setReplaceMethod("normalizationFactors", signature(object="OutriderDataSet", 
        value="matrix"), normFactors.replace.OutriderDataSet)

#' @rdname normalizationFactors
#' @export "normalizationFactors<-"
setReplaceMethod("normalizationFactors", signature(object="OutriderDataSet", 
        value="DataFrame"), normFactors.replace.OutriderDataSet)

#' @rdname normalizationFactors
#' @export "normalizationFactors<-"
setReplaceMethod("normalizationFactors", signature(object="OutriderDataSet", 
        value="data.frame"), normFactors.replace.OutriderDataSet)

#' @rdname normalizationFactors
#' @export "normalizationFactors<-"
setReplaceMethod("normalizationFactors", signature(object="OutriderDataSet", 
        value="NULL"), function(object, value) {
                assay(object, "normalizationFactors") <- NULL
                return(object)})

#' 
#' Autoencoder function to correct for confounders.
#' 
#' This is the wrapper function for the autoencoder implementation. 
#' It can be used to call the standard R implementation or the experimental
#' Python implementation.
#'
#' @param ods An OutriderDataSet object
#' @param q The encoding dimensions
#' @param implementation "autoencoder", the default, will use the autoencoder
#'             implementation. Also 'pca' and 'peer' can be used to control
#'             for confounding effects
#' @param BPPARAM A 
#'     \code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}}
#'             instance to be used for parallel computing.
#' @param ... Further arguments passed on to the specific implementation method.
#' 
#' @return An ods object including the control factors 
#'
#' @examples
#' ods <- makeExampleOutriderDataSet()
#' implementation <- 'autoencoder'
#' \dontshow{
#'     ods <- ods[1:10,1:10]
#'     implementation <- 'pca'
#' }
#' ods <- estimateSizeFactors(ods)
#' ods <- controlForConfounders(ods, implementation=implementation)
#' 
#' plotCountCorHeatmap(ods, normalized=FALSE)
#' plotCountCorHeatmap(ods, normalized=TRUE)
#' 
#' @export
controlForConfounders <- function(ods, q,
                    implementation=c('autoencoder', 'pca'),
                    BPPARAM=bpparam(), ...){
    
    # error checking
    checkOutriderDataSet(ods)
    checkCountRequirements(ods)
    checkSizeFactors(ods)
    
    if(!missing(q)){
        if(!(is.numeric(q) & q > 1 & q <= min(dim(ods)))){
            stop("Please provide for q an integer greater than 1 and smaller ", 
                    "than number of samples or genes.")
        }
    } else {
        q <- getBestQ(ods)
        if(is.na(q)){
            ods <- estimateBestQ(ods)
            q <- getBestQ(ods)
            message('Using estimated q with: ', q)
        } else {
            message('Using provided q with: ', q)
        }
    }
    
    # pass on to the approriate implementation
    implementation <- tolower(implementation)
    implementation <- match.arg(implementation)
    aeFun <- switch(implementation,
        autoencoder = { 
                function(ods, q, ...){ fitAutoencoder(ods, q, ...) } },
        pca         = { 
                function(ods, q, BPPARAM, ...){ autoCorrectPCA(ods, q, ...) } },
        stop("Requested control implementation is unknown.")
    )
    
    message(date(), ": Using the ", implementation, 
            " implementation for controlling.")
    ans <- aeFun(ods=ods, q=q, BPPARAM=BPPARAM, ...)
    message(date(), ": Used the ", implementation, 
            " implementation for controlling.")
    
    return(ans)
}

#' 
#' Extracting the latent space
#' 
#' Extracts the latent space from the OutriderDataSet object 
#' determined by the autoencoder.
#'
#' @param ods An OutriderDataSet
#'
#' @return A matrix containing the latent space determined by the autoencoder.
#'
#' @examples 
#' ods <- makeExampleOutriderDataSet()
#' \dontshow{
#'     ods <- ods[1:10, 1:10]
#' }
#' ods <- estimateSizeFactors(ods)
#' ods <- controlForConfounders(ods, implementation="pca")
#' computeLatentSpace(ods)[,1:6]
#' 
#' @export
computeLatentSpace <- function(ods){
    stopifnot(is(ods, 'OutriderDataSet'))
    if(is.null(D(ods)) | is.null(E(ods))){
        stop('The D or E weights are not computed yet. Please fit the ',
                'autoencoder before extracting the latent space.')
    }
    if(any(metadata(ods)[['dim']] != dim(ods))){
        stop('The OutriderDataSet dimension changed and does not match with ',
                'the existing autoencoder fit. Please refit the autoencoder.')
    }
    
    return(H(ods))
}

context("Testing OUTRIDER main function")

test_that("test main OUTRIDER function", {
    maxIter <- 6
    ods <- makeExampleOutriderDataSet(30, 30)
    ods <- estimateSizeFactors(ods)
    ods <- controlForConfounders(ods, iteration=maxIter)
    ods <- computePvalues(ods)
    ods <- computeZscores(ods)
    res <- results(ods, all=TRUE)
    expect_is(res, "data.table")
    
    ods2 <- OUTRIDER(ods, iteration=maxIter, implementation="autoenc")
    ods3 <- OUTRIDER(ods, implementation="pca")
    res2 <- results(ods2, all=TRUE)
    
    expect_equal(ods, ods2)
    expect_equal(res, res2)
    expect_is(ods3, "OutriderDataSet")
    expect_is(pValue(ods3), "matrix")
    expect_equal(dim(pValue(ods3)), dim(pValue(ods2)))
})

compileResults.OUTRIDER <- function(object, padjCutoff=0.05, zScoreCutoff=0, 
                    round=2, all=FALSE, subsetName=NULL, ...){
    
    #
    # input check and parsing
    # 
    checkOutriderDataSet(object)
    checkFullAnalysis(object)
    
    if(is.null(rownames(object))){
        rownames(object) <- paste('feature', seq_len(nrow(object)), sep='_')
    }
    
    if(is.null(colnames(object))){
        colnames(object) <- paste('sample', seq_len(ncol(object)), sep='_')
    }
    
    if(isTRUE(round)){
        round <- 2
    }
    
    meanCorrectedCounts <- rowMeans(counts(object, normalized=TRUE))
    meanRawCounts       <- rowMeans(counts(object, normalized=FALSE))
    if(isFALSE(all)){
        abByGene <- aberrant(object, 
                padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff, by="gene",
                subsetName=subsetName)
        abBySample <- aberrant(object, 
                padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff, by="sample",
                subsetName=subsetName)
        object <- object[abByGene > 0, abBySample > 0]
        meanCorrectedCounts <- meanCorrectedCounts[abByGene > 0]
        meanRawCounts <- meanRawCounts[abByGene > 0]
    }
    
    # warning if no rows to return 
    if(nrow(object) == 0){
        if(isFALSE(all)){
            warning('No significant events: use all=TRUE to print all events.')
        } else {
            warning('Please provide an object with at least one feature.')
        }
        return(data.table(
            geneID=NA_character_,
            sampleID=NA_character_,
            pValue=NA_real_,
            padjust=NA_real_,
            zScore=NA_real_,
            l2fc=NA_real_,
            rawcounts=NA_integer_,
            meanRawcounts=NA_real_,
            normcounts=NA_real_,
            meanCorrected=NA_real_,
            theta=NA_real_,
            aberrant=NA,
            AberrantBySample=NA_integer_,
            AberrantByGene=NA_integer_,
            padj_rank=NA_real_,
            FDR_set=NA_character_)[0])
    }
    
    #
    # extract data
    #
    ans <- data.table(
        geneID           = rownames(object), 
        sampleID         = rep(colnames(object), each=nrow(object)),
        pValue           = c(pValue(object)),
        padjust          = c(padj(object, subsetName=subsetName)),
        zScore           = c(zScore(object)),
        l2fc             = c(assay(object, "l2fc")),
        rawcounts        = c(counts(object)),
        meanRawcounts    = meanRawCounts,
        normcounts       = c(counts(object, normalized=TRUE)),
        meanCorrected    = meanCorrectedCounts,
        theta            = theta(object),
        aberrant         = c(aberrant(object, 
                padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff,
                subsetName=subsetName)),
        AberrantBySample = rep(each=nrow(object), aberrant(object, 
                padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff, by="sample",
                subsetName=subsetName)),
        AberrantByGene   = aberrant(object, 
                padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff, by="gene",
                subsetName=subsetName),
        padj_rank        = c(apply(padj(object, subsetName=subsetName), 2, rank)),
        FDR_set          = ifelse(is.null(subsetName), "transcriptome-wide", 
                                    subsetName)
    )
    
    # round columns if requested
    if(is.numeric(round)){
        devNull <- lapply(c("normcounts", "zScore", "l2fc", "theta", 
                "meanRawcounts", "meanCorrected"),
                function(x) ans[,c(x):=round(get(x), as.integer(round))] )
    }
    
    # 
    # keep only aberrant events and sort by padj value
    # 
    if(isFALSE(all)){
        ans <- ans[aberrant == TRUE]
        
    } else{
        # if return full subset is requested, retrieve those as all non-NA padj
        ans <- ans[!is.na(padjust),]
    }
    ans <- ans[order(padjust)]
    
    return(ans)
}

compileResultsAll.OUTRIDER <- function(object, padjCutoff=0.05, zScoreCutoff=0, 
                                    round=2, all=FALSE, 
                                    returnTranscriptomewideResults=TRUE, ...){
    #
    # input check and parsing
    # 
    checkOutriderDataSet(object)
    checkFullAnalysis(object)
    
    # get all padjust assays (transcriptome-wide and on subsets)
    padjAssays <- grep('padjust', assayNames(object), value=TRUE)
    
    # dont retrieve transcriptome-wide results if requested
    if(isFALSE(returnTranscriptomewideResults)){
        if(length(padjAssays) == 1 && padjAssays == 'padjust'){
            warning("Retrieving transcriptome-wide results as no other ",
                    "padjust assays are available in the ods object.")
        } else{
            padjAssays <- padjAssays[padjAssays != 'padjust']
        }
    }
    
    # get results for all available padjust assays
    resSubsets <- lapply(padjAssays, function(padjAssay){
        if(padjAssay == 'padjust'){
            subsetName <- NULL
        } else{
            subsetName <- gsub("padjust_", "", padjAssay)
        }
        resSub <- compileResults.OUTRIDER(object=object, 
                            padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff, 
                            all=all, round=round, 
                            subsetName=subsetName, ...)
        return(resSub)
    })
    res <- rbindlist(resSubsets)
    
    # sort it if existing
    if(nrow(res) > 0){
        # get aberrant columns from transcriptome-wide results
        res_tw <- res[FDR_set == "transcriptome-wide", 
                        .(geneID, sampleID, padj_rank, aberrant, 
                            AberrantBySample, AberrantByGene)] 
        
        # dcast to have only one row per gene-sample combination
        res <- dcast(res[, !c("padj_rank", "aberrant", "AberrantBySample", 
                            "AberrantByGene"), with=FALSE], 
                    ... ~ FDR_set, value.var="padjust")
        
        # merge again with aberrant columns for transcriptome-wide results
        if(isTRUE(returnTranscriptomewideResults)){
            # rename column back to padjust for tw results after dcast
            if("transcriptome-wide" %in% colnames(res)){
                setnames(res, "transcriptome-wide", "padjust")
            } else{
                res[, padjust := NA]
            }
            
            # merge with aberrant columns
            res <- merge(res, res_tw, by=c("geneID", "sampleID"), all.x=TRUE)
            
            # set aberrant to FALSE if only significant in subset results
            res[is.na(aberrant), aberrant := FALSE]
            res[is.na(padjust), padjust := padj(object)[cbind(geneID,sampleID)]]
            
            # restore previous column order
            setcolorder(res, colnames(resSubsets[[1]][,!"FDR_set", with=FALSE]))
            
            # order rows based on transcriptome-wide FDR
            res <- res[order(padjust)]
        }
        
        # rename padjust columns for other gene sets to padjust_setname
        for(subsetAssayName in padjAssays[padjAssays != "padjust"]){
            setnames(res, gsub("padjust_", "", subsetAssayName), 
                        subsetAssayName, skip_absent=TRUE)
        }
    } else{
        res <- res[, !"FDR_set", with=FALSE]
    }
    
    return(res)
}

#' 
#' Accessor function for the 'results' object in an OutriderDataSet object. 
#' 
#' This function assembles a results table of significant outlier events based
#' on the given filter criteria. The table contains various information 
#' accumulated over the analysis pipeline. 
#' 
#' @param object An OutriderDataSet object
#' @param padjCutoff The significant threshold to be applied
#' @param zScoreCutoff If provided additionally a z score threshold is applied
#' @param round Can be TRUE, defaults to 2, or an integer used for rounding
#'             with \code{\link[base]{round}} to make the output
#'             more user friendly
#' @param all By default FALSE, only significant read counts are listed in the 
#'             results. If TRUE all results are assembled resulting in a 
#'             data.table of length samples x genes. 
#' @param returnTranscriptomewideResults If FDR corrected pvalues for subsets 
#'              of genes of interest have been calculated, this parameter 
#'              indicates whether additionally the transcriptome-wide results 
#'              should be returned as well (default), or whether only results 
#'              for those subsets should be retrieved.
#' @param ... Additional arguments, currently not used
#' @return A data.table where each row is an outlier event and the columns
#'    contain additional information about this event. In details the 
#'    table contains: 
#'    \item{sampleID/geneID}{The gene or sample ID as provided by the 
#'          user, e.g. \code{rowData(ods)} and \code{colData(ods)},
#'          respectively.}
#'    \item{pValue/padjust}{The nominal P-value and the FDR corrected
#'          P-value (transcriptome-wide) indicating the outlier status.}
#'    \item{zScore/l2fc}{The z score and log\eqn{_2}{[2]} fold change 
#'        as computed by \code{\link[OUTRIDER]{computeZscores}}.}
#'    \item{rawcounts}{The observed read counts.}
#'    \item{normcounts}{The expected count given the fitted 
#'          autoencoder model for the given gene-sample combination.}
#'    \item{meanRawcounts/meanCorrected}{For this gene, the mean of the 
#'         observed or expected counts, respectively, given the fitted 
#'         autoencoder model.}
#'    \item{theta}{The dispersion parameter of the NB distribution 
#'          for the given gene.}
#'    \item{aberrant}{The transcriptome-wide outlier status of this event: 
#'          \code{TRUE} or \code{FALSE}.}
#'    \item{AberrantBySample/AberrantByGene}{Number of outliers for the 
#'          given sample or gene (transcriptome-wide), respectively.}
#'    \item{padj_rank}{Rank of this outlier event within the given sample.}
#'    \item{padjust_FDRset}{The FDR corrected P-value with respect to the 
#'          gene subset called 'FDRset', if gene subsets were specified 
#'          during the P-value computation. Find more details at 
#'          \code{\link[OUTRIDER]{computePvalues}}.}
#' 
#' @examples
#' 
#' ods <- makeExampleOutriderDataSet()
#' \dontshow{
#'     ods <- ods[1:10,1:10]
#' }
#' ods <- OUTRIDER(ods)
#' 
#' res <- results(ods, all=TRUE)
#' res
#' 
#' # example of retrieving results with FDR correction limited to a 
#' # set of genes of interest
#' genesOfInterest <- list("sample_1"=sample(rownames(ods), 3), 
#'                          "sample_2"=sample(rownames(ods), 8), 
#'                          "sample_6"=sample(rownames(ods), 5))
#' genesOfInterest
#' ods <- computePvalues(ods, subsets=list("exampleSubset"=genesOfInterest))
#' res <- results(ods, all=TRUE, returnTranscriptomewideResults=FALSE)
#' res
#' 
#' @name results
#' @rdname results
#' @aliases results results,OutriderDataSet-method
#' 
#' @export
setMethod("results", "OutriderDataSet", compileResultsAll.OUTRIDER)

#' 
#' Find the optimal encoding dimension
#' 
#' Finds the optimal encoding dimension by either Optimal Hard Thresholding 
#' or injecting artificial splicing outlier ratios while maximizing the 
#' precision-recall curve.
#'
#' @param ods An OutriderDataSet object
#' @param zScoresOHT A z-score matrix
#' @param useOHT If \code{TRUE} (default), Optimal Hard Thresholding is 
#'              used to estimate the optimal encoding dimension.
#' @param params,encDimParams Set of possible q values.
#' @param freq Frequency of outlier, defaults to 1E-2
#' @param zScore,zScoreParams Set of possible injection Z-score, defaults to 3.
#' @param sdlog Standard deviation of the sitribution on the log scale.
#' @param lnorm If TRUE, the default, Z-scores are drawn from a log normal 
#'             distribution with a mean of \code{log(zScore)} in log-scale.
#' @param inj Injection strategy, by default 'both'.
#' @param ... Further arguments passed on to the \code{controlForConfounders}
#'             function.
#' @param BPPARAM BPPARAM object by default bpparam().
#' 
#' @import RMTstat
#' @import pracma
#' @return The OutriderDataSet object with the optimal encoding dimension saved 
#'        in the metadata
#' 
#' @examples
#' ods <- makeExampleOutriderDataSet()
#' 
#' # run OHT (default)
#' estimateBestQ(ods)
#' 
#' # run hyperparameter optimization (grid-search)
#' encDimSearchParams <- c(5, 8, 10, 12, 15)
#' zScoreParams <- c(2, 3, 5, 'lnorm')
#' implementation <- 'autoencoder'
#' register(MulticoreParam(4))
#' \dontshow{
#'     ods <- ods[1:12,1:12]
#'     encDimSearchParams <- c(2)
#'     zScoreParams <- c('lnorm')
#'     register(SerialParam())
#'     implementation <- 'pca'
#' }
#' ods1 <- estimateBestQ(ods, useOHT=FALSE, params=encDimSearchParams, 
#'         implementation=implementation)
#' plotEncDimSearch(ods1)
#' 
#' ods2 <- findInjectZscore(ods, zScoreParams=zScoreParams,
#'         encDimParams=encDimSearchParams, implementation=implementation)
#' plotEncDimSearch(ods2) 
#' 
#' @rdname estimateBestQ
#' @aliases estimateBestQ, findInjectZscore
#' @export
estimateBestQ <- function(ods=NULL, zScoresOHT=NULL, useOHT=TRUE, 
                          params=seq(2, min(100, ncol(ods) - 1, nrow(ods) - 1), 2),
                          freq=1E-2, zScore=3, sdlog=log(1.6), lnorm=TRUE,
                          inj='both', ..., BPPARAM=bpparam()){
  # Optimal Hard Thresholding (default)
  if (isTRUE(useOHT)){
    if (is.null(ods) & is.null(zScoresOHT)){
      stop("Please provide an OutriderDataSet or a z-score matrix.")
    }
    else if (!is.null(ods)){
      OUTRIDER:::checkOutriderDataSet(ods)
      if (!is.null(zScoresOHT)){
        warning("Provided z-scores are ignored and recalculated from ods.")
      }
      
      # Control for sequencing depth
      if (is.null(sizeFactors(ods))){
        ods <- estimateSizeFactors(ods)
      }
      controlledCounts <- t(t(counts(ods, normalized=FALSE)) / sizeFactors(ods)) 
      
      # Log-transform controlled counts
      logControlCounts <- log2((controlledCounts +1) / (rowMeans2(controlledCounts) +1))
      
      # Compute Z-scores and control for large values
      zScoresOHT <- (logControlCounts - rowMeans2(logControlCounts)) / rowSds(logControlCounts)
    }
    else if (!is.matrix(zScoresOHT)){
      stop("Provided zScoresOHT are not a matrix.")
    }
    if (any(is.infinite(zScoresOHT))) {
      # Check for infinite values (should be impossible!)
      stop("Z-score matrix contains infinite values.")
    }
    
    # Transpose zScoresOHT if aspect ratio larger than 1
    if (ncol(zScoresOHT)/nrow(zScoresOHT) > 1){
      zScoresOHT <- t(zScoresOHT)
    } 
    
    # Perform Singular Value Decomposition (SVD) on the matrix of Z-scores 
    # and extract singular values
    sv <- svd(zScoresOHT)$d
    
    # Aspect ratio of the (transposed) count matrix
    numRows <- nrow(zScoresOHT)
    numCols <- ncol(zScoresOHT)
    beta <- numCols / numRows
    
    # Compute the optimal w(beta)
    coef <- (optimalSVHTCoef(beta) / sqrt(medianMarchenkoPastur(numCols, numRows)))
    
    # compute cutoff
    cutoff <- coef * median(sv)
    
    # compute and return rank
    if (any(sv > cutoff)){
      latentDim <- max(which(sv > cutoff))
    } else {
      warning(paste("Optimal latent space dimension is smaller than 2. Check your count matrix and",
                    "verify that all samples have the expected number of counts",
                    "(hist(colSums(counts(ods)))).",
                    "For now, the latent space dimension is set to 2.", collapse = "\n"))
      latentDim <- 2} 
    cat("Optimal encoding dimension:", latentDim, "\n")
    
    if (!is.null(ods)){
      data <- data.table(singular_values=sv)
      data <- data[, q:=.I]
      data <- data[-.N] # remove last entry (close to zero, impedes visualization)
      data <- data[, oht:=FALSE]
      data <- data[q==latentDim, oht:=TRUE] # set optimal latent dimension
      data <- data[order(-oht)]
      
      metadata(ods)[['encDimTable']] <- NULL
      metadata(ods)[['encDimTable']] <- data
      metadata(ods)[['optimalEncDim']] <- latentDim
      
      validateOutriderDataSet(ods)
      return(ods)
    } else{
      return(latentDim)
    }
    
  } else{ 
    # Hyperparamter optimization (grid-search)
    
    # compute auto Correction
    ods <- estimateSizeFactors(ods)
    ods <- injectOutliers(ods, freq=freq, zScore=zScore, inj=inj, lnorm=lnorm,
                          sdlog=sdlog)
    
    # TODO Please check if this is still correct
    # ods <- getLossBounderyCases(ods)
    
    eval <- bplapply(X=params, ..., BPPARAM=BPPARAM, 
                     FUN=function(i, ..., evalAucPRLoss=NA){
                       evalAutoCorrection(ods, encoding_dim=i, BPPARAM=SerialParam(), ...)}
    )
    
    metadata(ods)[['encDimTable']] <- data.table(
      encodingDimension= params,
      evaluationLoss= unlist(eval), 
      evalMethod='aucPR')
    metadata(ods)[['optimalEncDim']] <- getBestQ(ods)
    
    counts(ods) <- assay(ods, 'trueCounts')
    validateOutriderDataSet(ods)
    return(ods)
  }
}

getLossBounderyCases <- function(ods){
    
    ## Check limits of loss:
    # Check min and max of loss by substituting
    # counts and true Counts for the normalization Factors.
    
    # Max overfitting loss:
    normalizationFactors(ods) <- pmax(counts(ods), 1E-9)
    overfit <- evalLoss(ods)
    
    # Best possible loss:
    normalizationFactors(ods) <- pmax(assay(ods, 'trueCounts'), 1E-9)
    bestloss <- evalLoss(ods)
    
    # Max underfitting loss (only taking the means of the data):
    normalizationFactors(ods) <- matrix(
                rep(pmax(rowMeans(counts(ods)), 1E-9), ncol(ods)),
            ncol=ncol(ods))
    underfit <- evalLoss(ods)
    
    metadata(ods)[['boundaryCases']] = c(
            'Best possible loss (c=k)' = bestloss,
            'Max overfitting loss (c=kcorr)' = overfit,
            'Max underfitting loss (c=colMeans(kcorr)' = underfit)
    
    return(ods)
}

#' @rdname estimateBestQ
#' @export
findInjectZscore <- function(ods, freq=1E-2,
                    zScoreParams=c(seq(1.5, 4, 0.5), 'lnorm'),
                    encDimParams=c(seq(3, 40, 3), seq(45,70, 5), 100, 130, 160),
                    inj='both', ..., BPPARAM=bpparam()){
    encDimParams <- encDimParams[encDimParams < min(dim(ods), nrow(ods))]
    
    FUN <- function(idx, grid, ods, RNGseed, ...){
        z <- grid[idx,"z"]
        enc <- grid[idx,"enc"]
        lnorm <- FALSE
        if(z == 'lnorm'){
            z <- 3
            lnorm=TRUE
        } else {
            z <- as.integer(z)
        }
        message(date(), ": run Z-score: ", z, " and enc: ", enc)
        set.seed(RNGseed)
        estimateBestQ(ods, useOHT=FALSE, lnorm=lnorm, zScore=z, params=enc, 
                BPPARAM=SerialParam(), ...)
    }
    
    RNGseed <- .Random.seed
    parGrid <- expand.grid(z=zScoreParams, enc=encDimParams)
    odsres <- bplapply(seq_row(parGrid), FUN, ods=ods, freq=freq,
            inj=inj, grid=parGrid, RNGseed=RNGseed, BPPARAM=BPPARAM)
    
    res <- rbindlist(lapply(seq_along(odsres), function(i){
            metadata(odsres[[i]])$encDimTable[,.(
                    encodingDimension, zScore=parGrid[i,"z"], evaluationLoss)]
    }))
    res <- rbindlist(lapply(zScoreParams, function(z){
        tmpdt <- res[zScore==z]
        tmpdt[,opt:=getBestQDT(tmpdt)]
        tmpdt
    }))
    metadata(ods)[['encDimTable']] <- res
    return(ods)
}

## Helper functions called within estimateBestQ ##


#' injectOutliers
#'
#' @param ods OutriderDataSet
#' @param freq frequency of injected counts.
#' @param zScore injection Z-score.
#' @param inj injection strategy.
#'
#' @return and OutriderDataSet with artificially corrupted counts.
#' @noRd
injectOutliers <- function(ods, freq, zScore, inj, lnorm, sdlog){
    # copy true counts to be able to acces them in the loss later
    assay(ods, 'trueCounts', withDimnames=FALSE) <- counts(ods)
    
    # generate index of injected counts
    size <- prod(dim(ods))
    index <- sample(c(0,1,-1), size, prob = c(1 - freq, freq/2, freq/2), 
            replace = TRUE)
    index <- matrix(index, nrow = nrow(ods))
    switch(inj,
        low = { index <- -abs(index) },
        high = { index <- abs(index) }
    )
    
    tmpzScore <- matrix(0, ncol=ncol(ods), nrow=nrow(ods))
    if(isTRUE(lnorm)){
        tmpzScore[index!=0] <- rlnorm(sum(index!=0), log(zScore), sdlog=sdlog)
    } else {
        tmpzScore[index!=0] <- zScore
    }
    zScore <- tmpzScore
    
    #inject counts
    max_out <- min(10*max(counts(ods), na.rm=TRUE), .Machine$integer.max)
    
    # compute size factor normalized counts.
    # don't use it on the ods to not influence the later calculation.
    sf <- estimateSizeFactorsForMatrix(counts(ods))
    normtable <- t(t(counts(ods))/sf)
    counts <- counts(ods)
    
    list_index <- which(index != 0, arr.ind = TRUE)
    for(i in seq_len(nrow(list_index))){
        idxCol <- list_index[i,'col']
        idxRow <- list_index[i,'row']
        
        cts <- as.numeric(normtable[idxRow,])
        fc <- zScore[idxRow, idxCol] * sd(log2(1 + cts))
        clcount <- index[idxRow, idxCol] * fc + log2(1 + cts[idxCol])
        
        #multiply size factor again
        art_out <- round(sf[idxCol] * 2^clcount)
        
        # only insert outliers if they are different from before 
        # and not too large
        if(art_out < max_out & counts[idxRow, idxCol] != art_out){

          # do not introduce outlier such that all samples have 0 counts for that gene.
          # if all other samples (excluding idxCol) are 0 and art_out is 0 do not inject that outlier.
          if(all(counts[idxRow,-idxCol] == 0) & art_out == 0){
              index[idxRow, idxCol] <- 0
          }else{
              counts[idxRow, idxCol] <- art_out
          }
        }else{
            index[idxRow, idxCol] <- 0
            zScore
        }
    }
    # save coruppted counts and index of corruption into ods
    assay(ods, 'counts', withDimnames=FALSE) <- matrix(as.integer(counts), 
            nrow=nrow(ods))
    assay(ods, 'trueCorruptions', withDimnames=FALSE) <- index
    assay(ods, 'injectedZscore', withDimnames=FALSE) <- zScore
    return(ods)
}


#' 
#' evaluate loss = 1/n * Sum(log-likelihood(k | c))
#' 
#' @noRd
evalLoss <- function(ods, theta=25){
    N_corrupted <- sum(abs(assay(ods, 'trueCorruptions')))
    kTrue <- assay(ods, 'trueCounts')[assay(ods, 'trueCorruptions')!=0]
    c <- assay(ods, 'normalizationFactors')[assay(ods, 'trueCorruptions')!=0]
    eval <- sum(-dnbinom(kTrue, mu=c , size=theta, log=TRUE))/N_corrupted
    return(eval)
}

evalAucPRLoss <- function(ods){
    scores <- -as.vector(assay(ods, 'pValue'))
    labels <- as.vector(assay(ods, 'trueCorruptions') != 0) + 0
    
    if(any(is.na(scores))){
        warning(sum(is.na(scores)), " P-values where NAs.")
        scores[is.na(scores)] <- min(scores, na.rm=TRUE)-1
    }
    pr <- pr.curve(scores, weights.class0=labels)
    return(max(0, pr$auc.integral, na.rm=TRUE))
}

evalAutoCorrection <- function(ods, encoding_dim, BPPARAM=bpparam(), ...){
    
    ods <- OUTRIDER(ods, controlData=TRUE,q=encoding_dim, BPPARAM=BPPARAM, ...)
    eloss <- evalAucPRLoss(ods)
    
    print(paste0('Evaluation loss: ', eloss,' for q=',encoding_dim))
    return(eloss)
}

#'
#' Calculate the OHT coefficient 
#' 
#' @noRd
optimalSVHTCoef <- function(beta){ 
  # Calculate lambda(beta)
  sqrt(2 * (beta + 1) + (8 * beta) / (beta + 1 + sqrt(beta^2 + 14 * beta + 1)))
}

#'
#' Calculate the median of the Marchenko-Pastur distribution
#' 
#' Formulas are derived from a robust estimator for the noise 
#' parameter gamma in the model Z~ = Z + gamma * E.
#' Gamma(Z~) = sigma / sqrt(n * mu)) with mu: median of the Marcenko-Pastur distribution.
#' More detailed explanations can be found in Gavish and Donoho 2014.
#' 
#' @noRd
medianMarchenkoPastur <- function(ncol, nrow){ 
  # Compute median of Marchenko-Pastur distribution
  beta <- ncol / nrow
  betaMinus <- (1 - sqrt(beta))^2
  betaPlus <- (1 + sqrt(beta))^2
  
  # Initialize range for upper integral boundary
  lobnd <- copy(betaMinus) 
  hibnd <- copy(betaPlus)
  
  
  while ((hibnd - lobnd) > 0.001){ # Iterate until convergence
    x <- seq(lobnd, hibnd, length.out = 10) # Set range of values for upper integral boundary
    y <- rep(0, length(x))
    for (numCols in 1:length(x)){
      # Approximate integral using Gauss-Kronrod Quadrature
      y[numCols] <- quadgk(dmp, a=betaMinus, b=x[numCols], ndf=nrow, pdim=ncol)
    }  
    
    # Set new boundaries for x that yield the closest results to 0.5
    if (any(y < 0.5)){
      lobnd = max(x[y < 0.5])
    }
    
    if (any(y > 0.5)){
      hibnd = min(x[y > 0.5])
    }
  }
  # If hibnd and lobnd are similar enough, return their mean
  return((hibnd + lobnd) / 2.0)
}

context("Testing the estimateBestQ function")

# Hyperparameter optimization (grid-search)
test_that("Test hyperparameter optimization", {
  
  ods <- makeExampleOutriderDataSet(dataset = 'Kremer')
  ods <- ods[1:40, 1:40]
  ods <- filterExpression(ods, filterGenes=TRUE, minCounts=TRUE)
  countsbefore <- counts(ods)
  expect_equal(getBestQ(ods), NA_integer_)
  ods <- estimateBestQ(ods, useOHT=FALSE, params=3:5, iteration=2)
  
  expect_equal(countsbefore, counts(ods))
  expect_is(ods, 'OutriderDataSet')
  expect_equal(metadata(ods)[['optimalEncDim']], getBestQ(ods))
  expect_is(getBestQ(ods), "integer")
  expect_is(metadata(ods)[['encDimTable']], 'data.table')
  
})

test_that('In silico outliers',{
  ods <- makeExampleOutriderDataSet()
  freq <- 1E-2
  ods <- injectOutliers(ods, freq=freq, zScore=3, lnorm=TRUE, sdlog=3,
                        inj='both')
  
  tCor <- assay(ods, 'trueCorruptions')
  tCts <- assay(ods, 'trueCounts')
  numExpect <- nrow(ods) * ncol(ods) * freq
  
  expect_equal(counts(ods)[tCor == 0], tCts[tCor == 0])
  expect_true(all(counts(ods)[tCor != 0] != tCts[tCor != 0]))
})

# Optimal Hard Thresholding

test_that("Input validation handles NULL and non-matrix inputs", {
  expect_error(estimateBestQ(), 
               "Please provide an OutriderDataSet or a z-score matrix.")
  expect_error(estimateBestQ(NULL, NULL), 
               "Please provide an OutriderDataSet or a z-score matrix.")
  expect_error(estimateBestQ(zScoresOHT = "not a matrix"), 
               "Provided zScoresOHT are not a matrix.")
  expect_error(estimateBestQ(ods = "not an ods"), 
               "Please provide an OutriderDataSet.")
  
  ctsFile <- system.file('extdata', 'GTExSkinSmall.tsv',
                         package='OUTRIDER')
  ctsTable <- read.table(ctsFile, check.names=FALSE)
  ods <- OutriderDataSet(countData=ctsTable)
  # filter out non expressed genes
  ods <- filterExpression(ods, minCounts=TRUE, filterGenes=TRUE)
  ods <- estimateSizeFactors(ods)
  
  expect_warning(estimateBestQ(ods = ods, zScoresOHT = matrix(c(1, 2, 3, 4, 5, 6), nrow = 3, ncol = 2)),
                 "Provided z-scores are ignored and recalculated from ods.")
})

test_that("User is notified about invalid matrix values", {
  expect_error(estimateBestQ(zScoresOHT = matrix(c(1, 2, 3, 4, 5, Inf), nrow = 3, ncol = 2)), 
               "Z-score matrix contains infinite values.")
})

test_that("optimalSVHTCoef works correctly", {
  expect_equal(optimalSVHTCoef(0.5),
               1.98, tolerance = 0.01)
  expect_equal(optimalSVHTCoef(0.1),
               1.58, tolerance = 0.01)
})

test_that("medianMarchenkoPastur works correctly", {
  # Expected outputs are derived from Table IV in Gavish and Donoho (2014)
  expect_equal(optimalSVHTCoef(0.5) / sqrt(medianMarchenkoPastur(100, 200)),
               2.1711, tolerance = 0.0001)
  expect_equal(optimalSVHTCoef(0.1) / sqrt(medianMarchenkoPastur(100, 1000)),
               1.6089, tolerance = 0.0001)
})

test_that("Encoding dimensions are properly calculated for simulated z-scores", {
  # Simulate zScore matrix consisting of signal and noise
  set.seed(42)
  numGenes <- 10000
  numSamples <- 200
  latentDim <- 50
  signalNoiseRatio <- 5
  zTilde <- .LRsim(numGenes, numSamples, latentDim, signalNoiseRatio)$X * 1000
  
  expect_equal(estimateBestQ(zScoresOHT = zTilde),
               latentDim)
  
  # Simulate zScore matrix with beta > 1
  set.seed(42)
  numGenes <- 50
  numSamples <- 200
  latentDim <- 20
  signalNoiseRatio <- 5
  zTilde <- .LRsim(numGenes, numSamples, latentDim, signalNoiseRatio)$X * 1000
  
  expect_equal(estimateBestQ(zScoresOHT = zTilde),
               latentDim)
  
  # Simulate zScore matrix consisting of noise only
  set.seed(42)
  latentDim <- 0
  zTilde <- matrix(rnorm(numGenes * numSamples), nrow = numGenes, ncol = numSamples)
  expect_warning(expect_equal(estimateBestQ(zScoresOHT = zTilde), 2),
               paste("Optimal latent space dimension is smaller than 2\\. Check your count matrix and",
                 "verify that all samples have the expected number of counts",
                 "\\(hist\\(colSums\\(counts\\(ods\\)\\)\\)\\)\\.",
                 "For now\\, the latent space dimension is set to 2\\.", collapse = "\n"))
})

test_that("Encoding dimensions are properly calculated for real ODS", {
  ctsFile <- system.file('extdata', 'GTExSkinSmall.tsv',
                         package='OUTRIDER')
  ctsTable <- read.table(ctsFile, check.names=FALSE)
  ods <- OutriderDataSet(countData=ctsTable)
  ods <- filterExpression(ods, minCounts=TRUE, filterGenes=TRUE)
  ods <- estimateSizeFactors(ods)
  
  outsingleResult <- 5 # Expected value was calculated with OutSingle
  ods <- estimateBestQ(ods=ods, useOHT=TRUE)
  
  expect_equal(metadata(ods)[['optimalEncDim']], getBestQ(ods))
  expect_equal(metadata(ods)[['optimalEncDim']], outsingleResult,
               tolerance = 1)
})

aberrant.OUTRIDER <- function(object, padjCutoff=0.05, zScoreCutoff=0, 
                    by=c("none", "sample", "gene"), subsetName=NULL, ...){
    checkFullAnalysis(object)
    
    aberrantEvents <- padj(object, subsetName=subsetName) <= padjCutoff
    
    if(isScalarNumeric(zScoreCutoff, na.ok=FALSE)){
        aberrantEvents <- aberrantEvents & abs(zScore(object)) >= zScoreCutoff
    }
    
    return(switch(match.arg(by),
            none = aberrantEvents,
            sample = colSums(aberrantEvents, na.rm=TRUE),
            gene = rowSums(aberrantEvents, na.rm=TRUE)
    ))
}

#' 
#' Number of aberrant events
#' 
#' Identifies the aberrant events and returns the number of aberrant counts per
#' gene or sample or returns a matrix indicating aberrant events.
#' 
#' @param object An OutriderDataSet object
#' @param padjCutoff The padjust cutoff 
#' @param zScoreCutoff The absolute Z-score cutoff, 
#'             if NA or NULL no Z-score cutoff is used
#' @param by if the results should be summarized by 'sample', 
#'             'gene' or not at all (default).
#' @param subsetName The name of a subset of genes of interest for which FDR 
#'             corected pvalues were previously computed. Those FDR values 
#'             on the subset will then be used to determine aberrant status. 
#'             Default is NULL (using transcriptome-wide FDR corrected pvalues).
#' @param ... Currently not in use.
#'
#' @return The number of aberrent events by gene or sample or a TRUE/FALSE 
#'             matrix of the size sample x gene of aberrent events.
#' 
#' @examples
#' ods <- makeExampleOutriderDataSet()
#' ods <- OUTRIDER(ods, implementation='pca')
#' 
#' aberrant(ods)[1:10,1:10]
#' tail(sort(aberrant(ods, by="sample")))
#' tail(sort(aberrant(ods, by="gene")))
#' 
#' @rdname aberrant
#' @export
setMethod("aberrant", signature="OutriderDataSet", aberrant.OUTRIDER)

#' 
#' Update theta step for autoencoder
#' 
#' @noRd
updateTheta <- function(ods, thetaRange, BPPARAM, verbose){
    normalizationFactors(ods) <- t(predictC(ods))
    mu <- normalizationFactors(ods)
    cts <- counts(ods)
    H <- H(ods)
    thetaC <- thetaCorrection(ods)
    sMask <- sampleExclusionMask(ods, aeMatrix=TRUE)
    
    fitparameters <- bplapply(seq_along(ods), estTheta, mu=mu, H=H,
            cts=cts, exclusionMask=sMask, thetaRange=thetaRange,
            BPPARAM=BPPARAM, nll=negLogLikelihoodTheta, thetaC=thetaC)
    
    theta(ods) <- vapply(fitparameters, "[[", double(1), "minimum")
    
    if(isTRUE(verbose)){
        print(summary(theta(ods)))
    }
    
    validObject(ods)
    return(ods)
}

estTheta <- function(index, cts, mu, H, thetaC, thetaRange, exclusionMask, nll){
    sMaski  <- as.logical(exclusionMask[index,])
    ctsi    <- cts[index, sMaski]
    mui     <- mu[index, sMaski]
    thetaCi <- thetaC[sMaski]
    
    est <- optimize(f=nll, 
            interval=thetaRange, k=ctsi, mu=mui, thetaC=thetaCi)
} 

negLogLikelihoodTheta <- function(theta, k, mu, thetaC){
    theta <- theta * thetaC
    -sum(dnbinom(x=k, size=theta, mu=mu, log=TRUE))
}

#'
#' Update E step for the autoencoder fit
#' 
#' @noRd
updateE <- function(ods, control, BPPARAM, verbose){
    e <- as.vector(E(ods))
    D <- D(ods)
    k <- t(counts(ods))
    sf <- sizeFactors(ods)
    x <- x(ods)
    b <- b(ods)
    theta <- theta(ods)
    sMask <- t(sampleExclusionMask(ods, aeMatrix=TRUE))
    thetaC <- thetaCorrection(ods)
    
    fit <- optim(e, fn=truncLogLiklihoodE, gr=gradientE, k=k, x=x,
            sf=sf, D=D, b=b, theta=theta, exclusionMask=sMask, thetaC=thetaC,
            method="L-BFGS-B", lower=-100, upper=100, control=control)
    
    # Check that fit converged
    if(isTRUE(verbose) & fit$convergence != 0){
        print(paste('Update E did not converge: ', fit$message))
    }
    
    # update ods
    E(ods) <- fit$par
    
    return(ods)
}

filterExpression.OUTRIDER <- function(object, gtfFile, fpkmCutoff=1, 
                    percentile=0.95, filterGenes=TRUE, savefpkm=FALSE, 
                    minCounts=FALSE, addExpressedGenes=TRUE, ...){
    object <- filterMinCounts(object, filterGenes=filterGenes, 
            verbose=minCounts)
    if(isTRUE(minCounts)){
        return(object)
    }
    if(!missing(gtfFile)){
        object <- computeGeneLength(object, gtfFile=gtfFile, ...)
    }
    filterExp(object, fpkmCutoff=fpkmCutoff, percentile=percentile,
            filterGenes=filterGenes, savefpkm=savefpkm, 
            addExpressedGenes=addExpressedGenes)
}

#' 
#' Filter expression
#' 
#' To filter out non expressed genes this method uses the FPKM values to 
#' get a comparable value over genes. For each gene, if the pth-
#' \code{percentile} is greater than the \code{fpkmCutoff} value, it passes the
#' filter. To calcute the FPKM values the user needs to provide a GTF file or 
#' the basepair parameter as described in \code{\link[DESeq2]{fpkm}}.
#' 
#' @rdname filterExpression
#' @param object An OutriderDataSet object
#' @param filterGenes If TRUE, the default, the object is subseted.
#' @param minCounts If TRUE, only genes with 0 counts in all samples are 
#'             filtered
#' @param gtfFile A txDb object or a GTF/GFF file to be used as annotation
#' @param fpkmCutoff The threshold for filtering based on the FPKM value
#' @param percentile a numeric indicating the percentile FPKM value to compare
#'             against the \code{fpkmCutoff}
#' @param savefpkm If TRUE, the FPKM values are saved as assay
#' @param addExpressedGenes If TRUE (default), adds 5 columns to the
#'             \code{colData} with information regarding the number of 
#'             expressed genes per sample
#' @param ... Additional arguments passed to \code{computeGeneLength}
#' @return An OutriderDataSet containing the \code{passedFilter} column, which
#'             indicates if the given gene passed the filtering threshold. If
#'             \code{filterGenes} is TRUE the object is already subsetted.
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
#' annotationFile <- system.file("extdata", 
#'     "gencode.v19.genes.small.gtf.gz", package="OUTRIDER")
#' ods <- filterExpression(ods, annotationFile, filterGenes=FALSE)
#' 
#' mcols(ods)['passedFilter']
#' fpkm(ods)[1:10,1:10]
#' dim(ods)
#' 
#' ods <- ods[mcols(ods)[['passedFilter']]]
#' dim(ods)
#' 
#' @export
setMethod("filterExpression", "OutriderDataSet", filterExpression.OUTRIDER)

filterExp <- function(ods, fpkmCutoff, percentile, filterGenes, savefpkm, 
                    addExpressedGenes){
    fpkm <- fpkm(ods)
    if(savefpkm){
        assay(ods, 'fpkm', withDimnames=FALSE) <- fpkm
    }
    passed <- rowQuantiles(fpkm, probs=percentile) > fpkmCutoff
    mcols(ods)['passedFilter'] <- passed
    
    if(addExpressedGenes == TRUE){
        dt <- computeExpressedGenes(fpkm, cutoff=fpkmCutoff, 
                percentile=percentile)
        goodCols <- !colnames(colData(ods)) %in% colnames(dt[,-1])
        colData(ods) <- DataFrame(row.names=colData(ods)$sampleID,
                merge(colData(ods)[,goodCols, drop=FALSE], 
                        dt, by="sampleID", sort=FALSE))
    }
    
    message(paste0(sum(!passed), ifelse(filterGenes,
            " genes are filtered out. ", " genes did not pass the filter. "),
            "This is ", signif(sum(!passed)/length(passed)*100, 3), 
            "% of the genes."))
    if(filterGenes==TRUE){
        ods <- ods[passed == TRUE,]
    }
    
    validObject(ods)
    return(ods)
}

#' 
#' Extracting the gene length from annotations
#' 
#' Computes the length for each gene based on the given GTF file or annotation.
#' Here the length of a gene is defind by the total number of bases covered
#' by exons.
#' 
#' @param ods An OutriderDataSet for which the gene length should be computed.
#' @param gtfFile Can be a GTF file or an txDb object with annotation.
#' @param format The format parameter from \code{makeTxDbFromGFF}
#' @param mapping If set, it is used to map gene names between the GFT and the
#'             ods object. This should be a 2 column data.frame: 
#'             1. column GTF names and 2. column ods names.
#' @param ... further arguments to \code{makeTxDbFromGFF}
#' 
#' @return An OutriderDataSet containing a \code{basepairs} column with the 
#'             calculated gene length. Accessable through 
#'             \code{mcols(ods)['baisepairs']}
#' 
#' @examples 
#' 
#' ods <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
#' annotationFile <- system.file("extdata", "gencode.v19.genes.small.gtf.gz",
#'         package="OUTRIDER")
#' ods <- computeGeneLength(ods, annotationFile)
#' 
#' mcols(ods)['basepairs']
#' fpkm(ods)[1:10,1:10]
#' 
#' @export
computeGeneLength <- function(ods, gtfFile, format='gtf', mapping=NULL, ...){
    checkOutriderDataSet(ods)
    
    if(!is(gtfFile, "TxDb")){
        #created txdb object
        txdb <- makeTxDbFromGFF(gtfFile, format=format, ...)
    } else {
        txdb <- gtfFile
    }
    
    # collect the exons per gene id
    exons_list_per_gene <- exonsBy(txdb,by="gene")
    
    # for each gene, reduce all the exons to a set of non overlapping exons,
    # calculate their lengths (widths) and sum then
    widths <- width(reduce(exons_list_per_gene))
    totalexonlength <- vapply(widths, sum, numeric(1))
    if(!is.null(mapping)){
        if(is.data.table(mapping)){
            mapping <- as.data.frame(mapping)
        }
        if(is.data.frame(mapping)){
            tmpmapping <- mapping[,2]
            names(tmpmapping) <- mapping[,1]
            mapping <- tmpmapping
        }
        names(totalexonlength) <- mapping[names(totalexonlength)]
    }
    mcols(ods)['basepairs'] <- totalexonlength[rownames(ods)]
    
    # checking for NAs in basepair annotation
    if(any(is.na(mcols(ods)['basepairs']))){
        missingNames <- rownames(ods)[is.na(mcols(ods)['basepairs'])]
        warning(paste0("Some genes (n=", length(missingNames), 
                ") are not found in the annotation. Setting 'basepairs' == 1. ",
                "The first 6 names are:\n", paste(collapse=", ",
                        missingNames[seq_len(min(6, length(missingNames)))])))
        mcols(ods[is.na(mcols(ods)['basepairs'])[,1]])['basepairs'] <- 1
    }
    
    validObject(ods)
    return(ods)
}


#' 
#' Calculate FPM and FPKM values
#' 
#' This is the fpm and fpkm function from DESeq2. For more details see: 
#' \code{\link[DESeq2]{fpkm}} and \code{\link[DESeq2]{fpm}}
#' 
#' @name fpkm
#' @rdname fpkm
#' @aliases fpkm fpm
#' @seealso \code{\link[DESeq2]{fpkm}} \code{\link[DESeq2]{fpm}}
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet()
#' mcols(ods)['basepairs'] <- round(rnorm(nrow(ods), 1000, 500))
#' 
#' mcols(ods)['basepairs']
#' fpkm(ods)[1:10,1:10]
#' fpm(ods)[1:10,1:10]
#' 
#' @export fpkm
#' @export fpm
NULL

#'
#' Filter zero counts
#' 
#' @noRd
filterMinCounts <- function(x, filterGenes=FALSE, verbose=TRUE){
    passed <- !checkCountRequirements(x, test=TRUE)
    mcols(x)['passedFilter'] <- passed
    
    if(isTRUE(verbose)){
        message(paste0(sum(!passed), " genes did not pass the filter due to ", 
                "zero counts. This is ", 
                signif(sum(!passed)/length(passed)*100, 3), "% of the genes."))
    }
    
    if(isTRUE(filterGenes)){
        x <- x[passed,]
    }
    return(x)
}


#'
#' Returns a data.table with summary statistics per sample on number of genes
#' 
#' @noRd
computeExpressedGenes <- function(fpkm, cutoff=1, percentile=0.95){
    
    # Get cells that passed cutoff
    cutoffPassedMatrix <- fpkm > cutoff
    
    # Remove rows where no genes passed the cutoff
    cutoffPassedMatrix <- cutoffPassedMatrix[rowSums(cutoffPassedMatrix) > 0,]
    
    # Make a data.table with the expressed genes
    expGenesDt <- data.table(sampleID = colnames(cutoffPassedMatrix), 
            expressedGenes = colSums(cutoffPassedMatrix))
    
    # order by sample rank
    setorder(expGenesDt, "expressedGenes")
    cutoffPassedMatrix <- cutoffPassedMatrix[, expGenesDt$sample]
    
    # Get the cummulative sum of expressed genes
    cumSumMatrix <- rowCumsums(cutoffPassedMatrix + 0)
    
    # Get the genes that appear in at least 1 sample
    expGenesDt$unionExpressedGenes <- colSums(cumSumMatrix > 0)
    
    # Get the genes common in all samples
    expGenesDt$intersectionExpressedGenes <- rowSums(
            t(cumSumMatrix) == seq_col(cumSumMatrix))
    
    # Get number of genes passing the filtering
    expGenesDt$passedFilterGenes <- colSums(
            t(t(cumSumMatrix)/seq_col(cumSumMatrix)) >= 1-percentile)
    
    # Rank for plotting
    expGenesDt[, c("expressedGenesRank"):=list(.I)]
    
    return(expGenesDt)
}

#' 
#' Main autoencoder fit function
#' 
#' @noRd
fitAutoencoder <- function(ods, q, thetaRange=c(1e-2, 1e3), 
                    convergence=1e-5, iterations=15, initialize=TRUE,
                    control=list(), BPPARAM=bpparam(), verbose=FALSE){
    
    # Check input
    checkOutriderDataSet(ods)
    checkCountRequirements(ods)
    checkSizeFactors(ods)
    checkThetaRange(thetaRange)
    
    if(!bpisup(BPPARAM)){
        bpstart(BPPARAM)
    }
    
    # initialize W using PCA and bias as zeros.
    if(isTRUE(initialize) | is.null(E(ods)) | is.null(D(ods))){
        ods <- initAutoencoder(ods, q, thetaRange)
    }
    
    # initial loss
    lossList <- c(init_pca=lossED(ods))
    print(paste0(date(), ': Initial PCA loss: ', lossList[1]))
    
    # initialize D 
    ods <- updateD(ods, control=control, BPPARAM=BPPARAM, verbose=verbose)
    lossList <- updateLossList(ods, lossList, 'init', 'D', verbose=verbose)
    
    # initialize theta step
    ods <- updateTheta(ods, thetaRange, BPPARAM=BPPARAM, verbose=verbose)
    lossList <- updateLossList(ods, lossList, 'init', 'Theta', verbose=verbose)
    
    # optimize log likelihood
    t1 <- Sys.time()
    currentLoss <- lossED(ods)
    for(i in seq_len(iterations)){
        t2 <- Sys.time()
        
        # update E step
        ods <- updateE(ods, control=control, BPPARAM=BPPARAM, verbose=verbose)
        lossList <- updateLossList(ods, lossList, i, 'E', verbose=verbose)
        
        # update D step
        ods <- updateD(ods, control=control, BPPARAM=BPPARAM, verbose=verbose)
        lossList <- updateLossList(ods, lossList, i, 'D', verbose=verbose)
    
        # update theta step
        ods <- updateTheta(ods, thetaRange, BPPARAM=BPPARAM, verbose=verbose)
        lossList <- updateLossList(ods, lossList, i, 'theta', verbose=verbose)
        
        if(isTRUE(verbose)){
            print(paste('Time for one autoencoder loop:', Sys.time() - t2))
        } else {
            print(paste0(date(), ': Iteration: ', i, ' loss: ', 
                    lossList[length(lossList)]))
        }
        
        # check 
        curLossDiff <- abs(currentLoss - lossList[length(lossList) - 2:0])
        if(all(curLossDiff < convergence)){
            message(date(), ': the AE correction converged with:',
                    lossList[length(lossList)])
            break
        }
        currentLoss <- lossList[length(lossList)]
    }
    
    bpstop(BPPARAM)
    print(Sys.time() - t1)
    
    print(paste0(date(), ': ', i, ' Final nb-AE loss: ', 
            lossList[length(lossList)]))
    
    # add correction factors
    correctionFactors <- t(predictC(ods))
    stopifnot(identical(dim(counts(ods)), dim(correctionFactors)))
    normalizationFactors(ods) <- correctionFactors
    
    # add additional values for the user to the object
    metadata(ods)[['dim']] <- dim(ods)
    metadata(ods)[['loss']] <- lossList
    metadata(ods)[['convList']] <- lossList
    
    validObject(ods)
    return(ods)
}

initAutoencoder <- function(ods, q, thetaRange){
    
    pca <- pca(x(ods), nPcs=q)
    pc  <- loadings(pca)
    
    # Set initial values from PCA
    D(ods) <- pc
    E(ods) <- pc
    b(ods) <- rowMeans(log(counts(ods) + 1))
    
    # initialize theta
    theta(ods) <- robustMethodOfMomentsOfTheta(counts(ods), 
            minTheta=thetaRange[1], maxTheta=thetaRange[2])
    thetaCorrection(ods) <- 1
    
    # reset counters 
    mcols(ods)['NumConvergedD'] <- 0
    
    return(ods)
}

updateLossList <- function(ods, lossList, i, stepText, verbose){
    currLoss <- lossED(ods)
    lossList <- c(lossList, currLoss)
    names(lossList)[length(lossList)] <- paste0(i, '_', stepText)
    if(isTRUE(verbose)){
        print(paste0(date(), ': Iteration: ', i, ' ', 
                stepText, ' loss: ', currLoss))
    }
    return(lossList)
}

lossED <- function(ods, step=c('none', 'E', 'D', 'Theta')){
    k <- t(counts(ods))
    y_exp <- predictC(ods)
    theta <- outer(thetaCorrection(ods), theta(ods))
    
    ## log likelihood 
    ll <- dnbinom(t(k), mu=t(y_exp), size=t(theta), log=TRUE)
    
    return( - mean(ll) )
}

#' 
#' Z score computation
#' 
#' Computes the z scores for every count in the matrix.
#' The z score is defined in the log\eqn{_2}{[2]} space as follows:
#' \eqn{z_{ij} = \frac{l_{ij} - \mu_j^l}{
#'      \sigma_j^l}}{z_ij = (l[ij] - mu[j]^l)/sigma[ij]}
#' where \code{l} is the log\eqn{_2}{[2]} transformed normalized count and 
#' \eqn{\mu}{mu} and \eqn{\sigma}{sigma} the mean and standard deviation 
#' for gene \code{j} and sample \code{i}, respectively.
#' 
#' @param ods OutriderDataSet
#' @param ... Further arguments passed on to \code{ZscoreMatrix}.
#' @param peerResiduals If TRUE, PEER residuals are used to compute Z scores
#' @return An OutriderDataSet containing the Z score matrix "zScore" and
#'     the log2 fold changes "l2fc" as asasys.
#' 
#' @docType methods
#' @name computeZscores
#' @rdname computeZscores
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet()
#' ods <- estimateSizeFactors(ods)
#' 
#' ods <- controlForConfounders(ods, implementation="pca")
#' ods <- computeZscores(ods)
#' 
#' zScore(ods)[1:10,1:10]
#' assay(ods, "l2fc")[1:10,1:10]
#' 
#' @exportMethod computeZscores
setGeneric("computeZscores", 
        function(ods, ...) standardGeneric("computeZscores"))

#' @rdname computeZscores
#' @export
setMethod("computeZscores", "OutriderDataSet", 
    function(ods, peerResiduals=FALSE, ...){ 
        ZscoreMatrix(ods, peerResiduals=peerResiduals) })

ZscoreMatrix <- function(ods, peerResiduals){
    if(length(normalizationFactors(ods)) == 0){
        stop("Please fit the autoencoder first befor computing Z scores.")
    }
    
    # default Zscore calculation
    log2fc <- log2fc(ods)
    Zscore <- (log2fc - rowMeans(log2fc)) / rowSds(log2fc)
    
    # Use residuals from PEER if present
    if(isTRUE(peerResiduals)){
        if(!"PEER_model" %in% names(metadata(ods)) && 
                    !"residuals" %in% names(metadata(ods)[['PEER_model']])){
            stop("Please fit the data with 'peer' first.")
        }
        residuals <- metadata(ods)[['PEER_model']][['residuals']]
        Zscore <- (residuals - rowMeans(residuals)) / rowSds(residuals)
    }
    
    assay(ods, "l2fc", withDimnames=FALSE) <- log2fc
    zScore(ods) <- Zscore
    validObject(ods)
    return(ods)
}


log2fc <- function(object){
    log2(counts(object) + 1) - log2(normalizationFactors(object) + 1)
}

#'
#' SizeFactors accessor and estimation function
#' 
#' Accessor functions for the 'sizeFactors' information in a OutriderDataSet
#' object. 
#' 
#' The estimation of the size factors can also make use of the existing 
#' log geometric means in the object. Those can be loaded from an 
#' existing model.
#'    
#' @docType methods
#' @name sizeFactors
#' @rdname sizeFactors
#' @aliases sizeFactors sizeFactors,OutriderDataSet-method 
#'         sizeFactors<- sizeFactors<-,OutriderDataSet,numeric-method
#'         estimateSizeFactors estimateSizeFactors,OutriderDataSet-method
#'         
#' @param object OutriderDataSet
#' @param value A numberic vector of sizeFactors
#' @return An OutriderDatasSet with the estimated sizeFactors, or with the 
#'             getter function it returns a numeric vector containing the 
#'             sizeFactors.
#' 
#' @seealso \code{\link[DESeq2]{estimateSizeFactors}}
#' 
#' @examples
#' 
#' ods <- makeExampleOutriderDataSet()
#' ods <- estimateSizeFactors(ods)
#' head(sizeFactors(ods))
#' 
#' sizeFactors(ods) <- runif(dim(ods)[2], 0.5, 1.5)
#' sizeFactors(ods)
#' counts(ods, normalized=TRUE)[1:10,1:10]
#'         
NULL

#' 
#' Getter function for the size factors
#' @noRd
sizeFactors.OutriderDataSet <- function(object){
    if (!"sizeFactor" %in% names(colData(object))){
        return(NULL)
    }
    sf <- colData(object)$sizeFactor
    names(sf) <- colnames(object)
    sf
}

#' @rdname sizeFactors
#' @export sizeFactors
setMethod("sizeFactors", signature(object="OutriderDataSet"), 
        sizeFactors.OutriderDataSet)


#'
#' Replace function for the size factors
#' @noRd
sizeFactors.replace.OutriderDataSet <- function(object, value){
    stopifnot(all(!is.na(value)))
    stopifnot(all(is.finite(value)))
    stopifnot(all(value > 0))
    
    colData(object)[['sizeFactor']] <- value
    validObject( object )
    object
}

#' @rdname sizeFactors
#' @export "sizeFactors<-"
setReplaceMethod("sizeFactors", signature(object="OutriderDataSet", 
        value="numeric"), sizeFactors.replace.OutriderDataSet)

#' @rdname sizeFactors
#' @export "sizeFactors<-"
setReplaceMethod("sizeFactors", signature(object="OutriderDataSet", 
        value="NULL"), sizeFactors.replace.OutriderDataSet)


#'
#' OUTRIDER size Factor method which stores the log geom means.
#' @noRd
estimateSizeFactors.OUTRIDER <- function(object){
    if(!'loggeomeans' %in% names(mcols(object))){
        mcols(object)[['loggeomeans']] <- rowMeans(log(counts(object)))
    }
    loggeomeans <- mcols(object)[['loggeomeans']]
    
    if(all(is.infinite(loggeomeans))){
        stop(paste("Every gene contains at least one zero,",
                "cannot compute log geometric means"))
    }
    
    sf <- apply(counts(object), 2, function(cnts) {
        exp(median((log(cnts) - loggeomeans)[
            is.finite(loggeomeans) & cnts > 0]))
    })
    
    sizeFactors(object) <- sf
    validObject(object)
    return(object)
}

#' @rdname sizeFactors
#' @export estimateSizeFactors
setMethod("estimateSizeFactors", "OutriderDataSet", 
        estimateSizeFactors.OUTRIDER)

#' 
#' OUTRIDER - Finding expression outlier events
#' 
#' @description The OUTRIDER function runs the default OUTRIDER pipeline 
#' combinig the fit, the computation of Z scores and P-values.
#' All computed values are returned as an OutriderDataSet object.
#' 
#' To have more control over each analysis step, one can call each 
#' function separately.
#' 
#' \enumerate{
#'     \item \code{\link{estimateSizeFactors}} to calculate the sizeFactors
#'     \item \code{\link{controlForConfounders}} to control for 
#'               confounding effects
#'     \item \code{\link{fit}} to fit the negative binomial model 
#'               (only needed if the autoencoder is not used)
#'     \item \code{\link{computePvalues}} to calculate the nominal and 
#'               adjusted P-values
#'     \item \code{\link{computeZscores}} to calculate the Z scores
#' }
#' 
#' @inheritParams controlForConfounders
#' @param controlData If TRUE, the default, the raw counts are controled 
#'             for confounders by the autoencoder
#' @param subsets A named list of named lists specifying any number of gene 
#'             subsets (can differ per sample). For each subset, FDR correction
#'             will be limited to genes in the subset, and the FDR corrected 
#'             pvalues stored as an assay in the ods object in addition to the 
#'             transcriptome-wide FDR corrected pvalues. See the examples for 
#'             how to use this argument. 
#' @param ... Further arguments passed on to \code{controlForConfounders}
#' @return OutriderDataSet with all the computed values. The values are stored
#'             as assays and can be accessed by: \code{assay(ods, 'value')}.
#'             To get a full list of calculated values run:
#'             \code{assayNames(ods)}
#'
#' @examples
#' ods <- makeExampleOutriderDataSet()
#' implementation <- 'autoencoder'
#' \dontshow{
#'     ods <- ods[1:10,1:10]
#'     implementation <- 'pca'
#' }
#' ods <- OUTRIDER(ods, implementation=implementation)
#' 
#' pValue(ods)[1:10,1:10]
#' res <- results(ods, all=TRUE)
#' res
#' 
#' plotAberrantPerSample(ods)
#' plotVolcano(ods, 1)
#' 
#' # example of restricting FDR correction to subsets of genes of interest 
#' genesOfInterest <- list("sample_1"=sample(rownames(ods), 3), 
#'                          "sample_2"=sample(rownames(ods), 8), 
#'                          "sample_6"=sample(rownames(ods), 5))
#' genesOfInterest
#' ods <- OUTRIDER(ods, subsets=list("exampleSubset"=genesOfInterest))
#' padj(ods, subsetName="exampleSubset")[1:10,1:10]
#' res <- results(ods, all=TRUE)
#' res
#' 
#' @export
OUTRIDER <- function(ods, q, controlData=TRUE, implementation='autoencoder', 
                     subsets=NULL, BPPARAM=bpparam(), ...){
    checkOutriderDataSet(ods)
    implementation <- tolower(implementation)
    
    message(date(), ": SizeFactor estimation ...")
    ods <- estimateSizeFactors(ods)
    
    if(isTRUE(controlData)){
        message(date(), ": Controlling for confounders ...")
        ods <- controlForConfounders(ods, q=q, 
                implementation=implementation, BPPARAM=BPPARAM, ...)
    }
    
    if(isFALSE(controlData) | grepl("^(peer|pca)$", implementation)){
        message(date(), ": Fitting the data ...")
        ods <- fit(ods, BPPARAM=BPPARAM)
    }
    
    message(date(), ": P-value calculation ...")
    ods <- computePvalues(ods, subsets=subsets, BPPARAM=BPPARAM)
    
    message(date(), ": Zscore calculation ...")
    ods <- computeZscores(ods, 
            peerResiduals=grepl('^peer$', implementation))
    
    validObject(ods)
    return(ods)
}

context("Testing computational functions")

test_that("filter expression", {
    ods <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
    annotationFile <- system.file("extdata", "gencode.v19.genes.small.gtf.gz",
                                  package="OUTRIDER")
    ods <- filterExpression(ods, annotationFile, filterGenes=TRUE,
                               fpkmCutoff=0)
    
    expect_true(all(mcols(ods)[,"passedFilter"]))
    expect_equal(dim(ods), c(82, 50))
    expect_true("basepairs" %in% colnames(mcols(ods)))
})

test_that("fitting method", {
    ods <- makeExampleOutriderDataSet()
    expect_error(fit(ods), "Please provide sizeFactors or normal.*")
})

test_that("pvalue calculation", {
    ods <- makeExampleOutriderDataSet()
    expect_error(computePvalues(ods), "Please fit the models first to .*")
})

test_that("result method", {
    ods <- makeExampleOutriderDataSet(150, 50)
    expect_error(results(ods), "Please calculate..*")
    ods <- OUTRIDER(ods, q=2, iteration=2)
    
    expect_warning(res <- results(ods, padj=1e-15), "No significant events:")
    expect_equal(colnames(res), colnames(results(ods)))
    res_all <- results(ods, all=TRUE)
    expect_equal(nrow(res_all), nrow(ods)*ncol(ods))
    expect_true(all(results(ods)$aberrant))
    expect_equal(nrow(results(ods, padjCutoff=0.05, zScoreCutoff=0, round=TRUE)), 
        nrow(res_all[padjust <= 0.05 & abs(zScore) >= 0])
    )
})

test_that("normalization method", {
    ods <- makeExampleOutriderDataSet(5, 5)
    counts(ods) <- matrix(1:5, ncol=5, nrow=5, dimnames=dimnames(ods))
    expect_null(normalizationFactors(ods))
    nMat <- matrix(6:10, ncol=5, nrow=5)
    normalizationFactors(ods) <- nMat
    expect_equivalent(normalizationFactors(ods), nMat)
    expect_error(results(ods), "Please calculate..*")
})

test_that("fit method", {
    ods <- makeExampleOutriderDataSet(30, 30)
    ods <- estimateSizeFactors(ods)
    ods <- fit(ods)
    expect_is(mcols(ods)[,"mu"], "numeric")
    expect_equal(length(mcols(ods)[,"mu"]), nrow(ods))
    expect_is(theta(ods), "numeric")
    expect_equal(length(theta(ods)), nrow(ods))
})

#' 
#' This file contains all r implementations of the loss functions.
#' They are only here for debug perpose and are not used within the package.
#' 
#' @noRd 
NULL

lossD <- function(par, k, H, sf, theta){
    b <- par[1]
    d <- par[-1]
    
    y <- H %*% d + b
    yexp <- sf * exp(y)
    
    ll <- mean(dnbinom(k, mu=yexp, size=theta, log=TRUE))
    return(-ll)
}

lossDtrunc <- function(par, k, H, sf, theta, thetaC){
    b <- par[1]
    d <- par[-1]
    theta <- thetaC * theta
    
    y <- H %*% d + b
    yexp <- sf * exp(y)
    
    #ll = mean(k * log(yexp) - (k + theta)*log(yexp + theta))
    
    t1 <- k * (log(sf) + y) 
    t2 <- (k + theta) * (log(sf) + y + log(1+theta/(sf * exp(y))))
    ll <- mean(t1 - t2)
    
    return(-ll)
}

gradD <- function(par, k, H, sf=1, theta, thetaC){
    b <- par[1]
    d <- par[-1]
    
    theta <- thetaC * theta
    
    y <- c(H %*% d + b)
    yexp <- sf * exp(y)
    
    t1 <- colMeans(k * H)
    kt <- (k + theta) / (1 + theta/(sf*exp(y)))
    t2 <- colMeans(kt * H) 
    
    dd <- t2 - t1
    db <- mean(kt - k)
    
    return(c(db, dd))
}

lossE <- function(e, D, k, b, x, sf, theta, thetaC){
    E <- matrix(e, nrow=ncol(k))
    thetaMat <- outer(thetaC, theta)
    
    y <- t(t(x %*% E %*% t(D)) + b)
    y_exp <- sf * exp(y)
    
    ## log likelihood 
    ll <- dnbinom(t(k), mu=t(y_exp), size=t(thetaMat), log=TRUE)
    - mean( ll )
}

lossEtruncNonOutlier <- function(e, D, k, b, x, sf, theta, thetaC, 
                    exclusionMask){
    E <-matrix(e, nrow=ncol(k))
    thetaMat <- outer(thetaC, theta)
    
    y <- t(t(x %*% E %*% t(D)) + b)
    y <- apply(y, 2, pmax, -700)
    
    t1 <- k * (log(sf) + y)
    t2 <- (k + thetaMat) * (log(sf) + y + log(1+thetaMat/(sf * exp(y))))
    
    ll <- mean((t1 - t2) * exclusionMask)
    return(-ll)
}

lossGradENonOutlier <- function(e, D, k, b, x, sf, theta, thetaC, 
                    exclusionMask){
    E <-matrix(e, nrow=ncol(k))
    thetaMat <- outer(thetaC, theta)
    
    # dW:
    y <- t(t(x %*% E %*% t(D)) + b)
    y <- apply(y, 2, pmax, -700)
    
    kt <- (k + thetaMat) / ( 1 + thetaMat/(sf*exp(y)) )
    
    t1 <- t(x) %*% ((k  * exclusionMask) %*% D)
    t3 <- t(x) %*% ((kt * exclusionMask) %*% D)
    
    # answers dE 
    dE <- (-t1 + t3)/sum(exclusionMask)
    
    return(dE)
}

#'
#' This is the import mapping for the OUTRIDER package
#' 
#' @noRd
#' 
#' @name OUTRIDER
#'
#' @rawNamespace import(data.table, except=melt)
#' 
#' @import methods
#' 
#' @importFrom BiocGenerics estimateSizeFactors plotDispEsts
#' 
#' @importFrom DESeq2 normalizationFactors normalizationFactors<-
#'          sizeFactors sizeFactors<- counts counts<-
#'          DESeqDataSetFromMatrix DESeqDataSet
#'          makeExampleDESeqDataSet show fpkm fpm
#'          estimateSizeFactorsForMatrix replaceOutliers dispersions
#' 
#' @importFrom SummarizedExperiment colData colData<- rowData rowData<-
#'          assays assays<- assayNames mcols mcols<- assay assay<- rowRanges
#' 
#' @importFrom BBmisc isScalarLogical isScalarNumeric isScalarCharacter isFALSE
#'          isScalarValue isScalarNA chunk seq_col seq_row
#' 
#' @importFrom BiocParallel bplapply bpparam SerialParam bpisup bpstart bpstop
#'          bpmapply
#' 
#' @importFrom GenomicFeatures exonsBy
#' 
#' @importFrom txdbmaker makeTxDbFromGFF
#' 
#' @importFrom GenomicRanges GRanges reduce width start end findOverlaps 
#' 
#' @importFrom ggplot2 ggplot aes annotate geom_bar geom_histogram 
#'          geom_hline geom_smooth geom_point labs scale_x_log10 
#'          scale_y_log10 scale_fill_manual scale_color_manual 
#'          scale_fill_brewer scale_color_brewer theme ylim 
#'          ggtitle geom_vline geom_text scale_linetype_manual geom_line 
#'          geom_abline theme_bw element_blank xlab ylab scale_color_identity 
#'          facet_grid facet_wrap quo_name
#' 
#' @importFrom ggrepel geom_text_repel
#' 
#' @importFrom grDevices colorRampPalette
#' 
#' @importFrom pheatmap pheatmap
#' 
#' @importFrom heatmaply heatmaply
#' 
#' @importFrom graphics plot abline axis box grid legend lines mtext par points 
#'          polygon text title
#'
#' @importFrom IRanges IRanges
#' 
#' @importFrom matrixStats rowSds rowMedians rowQuantiles rowMeans2 rowCumsums
#' 
#' @importFrom pcaMethods pca loadings
#' 
#' @importFrom plotly %>% ggplotly layout plotly_build plot_ly
#' 
#' @importFrom plyr .
#' 
#' @importFrom RColorBrewer brewer.pal
#' 
#' @importFrom reshape2 melt
#' 
#' @importFrom S4Vectors DataFrame metadata metadata<- endoapply queryHits
#'          subjectHits values values<-
#' 
#' @importFrom scales math_format trans_format
#' 
#' @importFrom splines bs
#' 
#' @importFrom stats cor coefficients cutree dist dnbinom hclust p.adjust 
#'          setNames sd optimize rlnorm
#'          quantile optim var pnbinom  median ppoints qbeta runif 
#'            lm predict rnorm glm Gamma rnbinom
#' 
#' @importFrom utils read.table head compareVersion packageVersion
#' 
#' @importFrom PRROC pr.curve
#' 
#' @useDynLib OUTRIDER
#' 
NULL

#' 
#' TODO This is to get rid of the warnings of undefined variables
#'     due to the nature of data.table and ggplot/plotly
#' For reference:
#' https://www.r-bloggers.com/no-visible-binding-for-global-variable/
#' @noRd
globalVariables(package="OUTRIDER", c(
        "color",
        "enc",
        "encodingDimension", 
        "eva",
        "evalMethod", 
        "evaluationLoss",
        "expected",
        "expRank",
        "ExprType", 
        "feature_id",
        "fill",
        "frac",
        "Fraction",
        "GENE_ID",
        "group",
        "lty", 
        "lwd", 
        "medianCts", 
        "negLog10pVal",
        "normcounts",
        "normCts",
        "norm_rank", 
        "opt",
        "padj_rank", 
        "padjust", 
        "obs",
        "observed",
        "onlyFull",
        "passedFilter",
        "Rank",
        "rawcounts",
        "sampleID",
        "sizeFactor",
        "value",
        "variable",
        "V1",
        "Var1",
        "Var2",
        ".x",
        "y",
        "z",
        "AberrantByGene",
        "AberrantBySample",
        "FDR_set",
        "aberrantLabel",
        "geneID"))

#' 
#' Calculate P-values
#' 
#' This function computes the P-values based on the fitted negative binomial
#' model being an outlier for the given sample gene combination. It computes
#' two matrices with the same dimension as the count matrix (samples x genes),
#' which contain the corresponding P-values and adjusted P-values of every 
#' count. The adjusted P-values are computed across all genes per sample.
#' 
#' @param object An OutriderDataSet
#' @param alternative Can be one of "two.sided", "greater" or "less" to specify
#'             the alternative hypothesis used to calculate the P-values,
#'             defaults to "two.sided"
#' @param method Method used for multiple testing
#' @param subsets A named list of named lists specifying any number of gene 
#'             subsets (can differ per sample). For each subset, FDR correction
#'             will be limited to genes in the subset, and the FDR corrected 
#'             pvalues stored as an assay in the ods object in addition to the 
#'             transcriptome-wide FDR corrected pvalues. See the examples for 
#'             how to use this argument. 
#' @param BPPARAM Can be used to parallelize the computation, defaults to
#'             bpparam()
#' @param ... additional params, currently not used.
#' 
#' @return An OutriderDataSet object with computed nominal and adjusted P-values
#' 
#' @seealso p.adjust
#' 
#' @docType methods
#' @name computePvalues
#' @rdname computePvalues
#' @aliases computePvalues computePvalues,OutriderDataSet-method
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet()
#' \dontshow{
#'     ods <- ods[1:10,1:10]
#' }
#' ods <- estimateSizeFactors(ods)
#' ods <- fit(ods)
#' 
#' ods <- computePvalues(ods)
#' 
#' assays(ods)[['pValue']][1:10,1:10]
#' 
#' # example of restricting FDR correction to subsets of genes of interest
#' genesOfInterest <- list("sample_1"=sample(rownames(ods), 3), 
#'                          "sample_2"=sample(rownames(ods), 8), 
#'                          "sample_6"=sample(rownames(ods), 5))
#' ods <- computePvalues(ods, subsets=list("exampleSubset"=genesOfInterest))
#' padj(ods, subsetName="exampleSubset")[1:10,1:10]
#' ods <- computePvalues(ods, 
#'                  subsets=list("anotherExampleSubset"=rownames(ods)[1:5]))
#' padj(ods, subsetName="anotherExampleSubset")[1:10,1:10]
#' 
#' @exportMethod computePvalues
setGeneric("computePvalues", 
        function(object, ...) standardGeneric("computePvalues"))

#' @rdname computePvalues
#' @export
setMethod("computePvalues", "OutriderDataSet", function(object, 
            alternative=c("two.sided", "greater", "less"), method='BY', 
            subsets=NULL, BPPARAM=bpparam()){
    
    alternative <- match.arg(alternative)
    object <- pValMatrix(object, alternative, BPPARAM=BPPARAM)
    
    if(method != 'None'){
        object <- padjMatrix(object, method)
        
        # calculate FDR for each provided subset and assign to ods
        if(!is.null(subsets)){
            stopifnot(is.list(subsets))
            stopifnot(!is.null(names(subsets)))
            for(setName in names(subsets)){
                geneListSubset <- subsets[[setName]]
                object <- padjOnSubset(ods=object, method=method, 
                                    BPPARAM=BPPARAM,
                                    genesToTest=geneListSubset,
                                    subsetName=setName)
            }
        }
    }
    object
})

pValMatrix <- function(ods, alternative, BPPARAM){ 
    if(!all(c("theta") %in% colnames(mcols(ods)))){
        stop(paste("Please fit the models first to estimate theta and",
                "mu by running:\n\tods <- fit(ods)"))
    }
    ctsData <- counts(ods)
    mu <- rep(1, nrow(ods))
    if('mu' %in% names(mcols(ods))){
        mu <- mcols(ods)[,"mu"]
    }
    normF <- normalizationFactors(ods)
    if(is.null(normF)){
        normF <- sizeFactors(ods)
    }
    thetaMat <- outer(theta(ods), thetaCorrection(ods))
    
    pValMat <- bplapply(seq_along(ods), pVal, ctsData=ctsData, theta=thetaMat,
            mu=mu, normF=normF, alternative=alternative, BPPARAM=BPPARAM)
    
    pValue(ods) <- matrix(unlist(pValMat), nrow=length(ods), 
            byrow=TRUE, dimnames=dimnames(ods))
    validObject(ods)
    return(ods)
}


#' 
#' Internal P-value calculation
#' 
#' Since the distribution has an integer support one needs to take care of 
#' summing over the x bin on both sides. Further need to take care, that 
#' P-values do not become larger then one.
#'
#' \deqn{
#' p_{ij} = 2 \cdot min \left\{
#'         \frac{1}{2},  
#'         \sum_{0}^{k_{ij}} NB(\mu_i\cdot c_{ij} ,\theta_i),
#'         1 - \sum_{0}^{k_{ij-1}} NB(\mu_i\cdot c_{ij} ,\theta_i)
#'     \right\}
#' }
#' 
#' @param x count 
#' @param size fitted theta (size) for the neg. binomial dist
#' @param mu fitted mean for the neg. binomial dist
#' @param s sizeFactor or normalizationFactor
#'
#' @return p Value
#' @noRd
pVal <- function(index, ctsData, theta, mu, normFact, alternative){
    x    <- ctsData[index,]
    mu   <- mu[index]
    
    # check if you did not get only sizeFactors
    if(is.matrix(normFact)){
        normFact <- normFact[index,]
    }
    size <- theta[index,]
    
    pless <- pnbinom(x, size=size, mu=normFact*mu)
    if(alternative == "less"){
        return(pless)
    }
    
    dval <- dnbinom(x, size=size, mu=normFact*mu)
    if(alternative ==  "greater"){
        return(1 - pless + dval)
    }
    
    return(2 * pmin(0.5, pless, 1 - pless + dval))
}


#' 
#' FDR correction
#' 
#' Function to correct the computed pValues using BY FDR correction.
#' This function is called by the computePvalues method.
#'
#' @param ods OutriderDataSet
#' @param method adjustment method, by default 'BH'
#' @return OutriderDataSet containing adjusted pValues
#' 
#' @noRd
padjMatrix <- function(ods, method='BH'){
    padj(ods) <- apply(pValue(ods), 2, p.adjust, method=method)
    
    validObject(ods)
    return(ods)
}

#' 
#' FDR correction on subset of genes
#' 
#' Function to correct the computed pValues using BY FDR correction, limited to 
#' a subset of genes.
#'
#' @param ods OutriderDataSet
#' @param method adjustment method, by default 'BY'
#' @param genesToTest A named list with the subset of genes to test per sample.
#'     The names must correspond to the sampleIDs in the ods object.
#' @param subsetName The name under which the resulting FDR corrected pvalues 
#'     will be stored as an assay with name 'padjust_'+subsetName.
#' @return OutriderDataSet containing adjusted pValues
#' 
#' @noRd
padjOnSubset <- function(ods, genesToTest, subsetName, method='BY', 
                            BPPARAM=bpparam()){
    
    # check input
    stopifnot(!is.null(genesToTest))
    stopifnot(is.list(genesToTest) || is.vector(genesToTest))
    
    # replicate subset genes for each sample if given as vector
    if(!is.list(genesToTest)){
        genesToTest <- rep(list(genesToTest), ncol(ods))
        names(genesToTest) <- colnames(ods)
    }
    
    # check that names are present and correspond to samples in ods
    stopifnot(!is.null(names(genesToTest)))
    if(!all(names(genesToTest) %in% colnames(ods))){
        stop("names(genesToTest) need to be sampleIDs in the given ods object.")
    }
    
    # compute FDR on the given subsets of genes
    fdrSubset <- bpmapply(colnames(ods), FUN=function(sampleId){
                                         
            # get genes to test for this sample
            genesToTestSample <- genesToTest[[sampleId]]
            padj <- rep(NA, nrow(ods))
            
            # if no genes present in the subset for this sample, return NAs
            if(is.null(genesToTestSample)){
                return(padj)
            }
            
            # get idx of junctions corresponding to genes to test
            if(is.character(genesToTestSample)){
                rowIdx <- sort(which(rownames(ods) %in% genesToTestSample))
            } else{
                stop("Genes in the list to test must be a character vector ",
                    "of geneIDs.")
            }
                             
            # check that rowIdx is not empty vector
            if(length(rowIdx) == 0){
                warning("No genes from the given subset found in the ods ",
                            "object for sample: ", sampleId)
                return(padj)
            }
                                         
            # retrieve pvalues of genes to test
            p <- pValue(ods)[rowIdx, sampleId]
                     
            # FDR correction on subset
            padjSub <- p.adjust(p, method=method)
                                         
            # return FDR on subset, filled with NA for all other genes
            padj[rowIdx] <- padjSub
            return(padj)
            
        }, SIMPLIFY=TRUE, BPPARAM=BPPARAM)
    rownames(fdrSubset) <- rownames(ods)
    colnames(fdrSubset) <- colnames(ods)
    
    # add FDR subset info to ods object and return
    padj(ods, subsetName=subsetName) <- fdrSubset
    validObject(ods)
    return(ods)
}

#' Getter/Setter functions
#' 
#' This is a collection of small accessor/setter functions for easy access to
#' the values within the OUTRIDER model.
#' 
#' @param ods,object An OutriderDataSet object.
#' @param subsetName Name of a gene subset for which to store or retrieve 
#'              FDR corrected p values 
#' @param ... Further arguments passed on to the underlying assay function.
#' @return A matrix or vector dependent on the type of data retrieved.
#' 
#' @name getter_setter_functions
#' @rdname getter_setter_functions
#' @aliases zScore, pValue, padj, theta, dispersion, getBestQ
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet(10, 10)
#' ods <- OUTRIDER(ods)
#' 
#' zScore(ods)
#' pValue(ods)
#' padj(ods)
#' theta(ods)
#' theta(ods) == 1/dispersions(ods)
#' getBestQ(ods)
#' 
NULL

#' @rdname getter_setter_functions
#' @export
zScore <- function(ods){
    if(!'zScore' %in% assayNames(ods)){
        stop('Please compute first the Z-scores before retrieving them.')
    }
    assay(ods, 'zScore')
}

`zScore<-` <- function(ods, ..., value){
    stopifnot(is.matrix(value))
    stopifnot(dim(ods) == dim(value))
    assay(ods, 'zScore', ...) <- value
    return(ods)
}

#' @rdname getter_setter_functions
#' @export
pValue <- function(ods){
    if(!'pValue' %in% assayNames(ods)){
        stop('Please compute first the P-values before retrieving them.')
    }
    assay(ods, 'pValue')
}

`pValue<-` <- function(ods, ..., value){
    stopifnot(is.matrix(value))
    stopifnot(dim(ods) == dim(value))
    assay(ods, 'pValue', ...) <- value
    return(ods)
}

#' @rdname getter_setter_functions
#' @export padj
padj <- function(ods, subsetName=NULL){
    assayName <- 'padjust'
    if(!is.null(subsetName)){
        assayName <- paste0(assayName, "_", subsetName)
    }
    if(!assayName %in% assayNames(ods)){
        stop('Please compute first the P-values before retrieving', '
                the adjusted ones.')
    }
    assay(ods, assayName)
}

`padj<-` <- function(ods, subsetName=NULL, ..., value){
    stopifnot(is.matrix(value))
    stopifnot(dim(ods) == dim(value))
    assayName <- 'padjust'
    if(!is.null(subsetName)){
        assayName <- paste0(assayName, "_", subsetName)
    }
    assay(ods, assayName, ...) <- value
    return(ods)
}


#' @rdname getter_setter_functions
#' @aliases dispersions dispersions,OutriderDataSet-method
#' @seealso \code{\link[DESeq2]{estimateDispersions}}
#' @export
setMethod("dispersions", signature(object="OutriderDataSet"),
    function(object, ...){ 1/theta(object) })


#' @rdname getter_setter_functions
#' @export theta
theta <- function(ods){
    if(!'theta' %in% colnames(mcols(ods))){
        stop('Please fit first the autoencoder before retrieving thetas.')
    }
    mcols(ods)[['theta']]
}

`theta<-` <- function(ods, value){
    mcols(ods)[['theta']] <- value
    return(ods)
}

context("Testing against old version: ")

test_that("test against old version", {
    odsOld <- get_test_outrider_dataset()
    
    ods <- OutriderDataSet(countData=counts(odsOld))
    sizeFactors(ods) <- sizeFactors(odsOld)
    normalizationFactors(ods) <- normalizationFactors(odsOld)
    
    ods <- fit(ods)
    expect_equal(round(mcols(ods)[['mu']], 4), mcols(odsOld)[['mu']])
    expect_equal(round(theta(ods), 4), mcols(odsOld)[['disp']])
    
    ods <- computeZscores(ods)
    #expect_equal(round(zScore(ods), 1), round(zScore(odsOld), 1))
    
    ods <- computePvalues(ods, method='BH')
    expect_equal(round(pValue(ods), 4), assay(odsOld, 'pValue'))
    expect_equal(round(padj(ods), 4), assay(odsOld, 'padjust'))
})

#' Sample exclusion
#' 
#' To exclude a sample from the fit process, one can use this function to mask 
#' specific samples. This can be used if replicates are present.
#' 
#' @param ods An OutriderDataSet object
#' @param value A logical vector of the length of the samples. If \code{TRUE},
#'             the corresponding sample will be excluded from the autoencoder
#'             fit.
#' @param aeMatrix If \code{TRUE}, it returns a 0/1 matrix for the 
#'             internal autoencoder functions in the form of feature x sample
#' @return The exclusion vector/matrix.
#' 
#' @name sampleExclusionMask
#' @rdname sampleExclusionMask
#' @aliases sampleExclusionMask, `sampleExclusionMask<-`
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet()
#' sampleExclusionMask(ods) <- sample(c(FALSE, TRUE), ncol(ods), replace=TRUE)
#' 
#' sampleExclusionMask(ods)
#' 
#' @export sampleExclusionMask
sampleExclusionMask <- function(ods, aeMatrix=FALSE){
    if('exclude' %in% colnames(colData(ods))){
        ans <- colData(ods)[['exclude']]
    } else {
        ans <- rep(FALSE, ncol(ods))
    }
    names(ans) <- colnames(ods)
    
    if(isTRUE(aeMatrix)){
        ans <- as.integer(vapply(ans, isFALSE, FALSE))
        ans <- matrix(ans, ncol=ncol(ods), nrow=nrow(ods), byrow=TRUE)
        colnames(ans) <- colnames(ods)
        rownames(ans) <- rownames(ods)
    }
    
    return(ans)
}

#' @rdname sampleExclusionMask
#' @export "sampleExclusionMask<-"
`sampleExclusionMask<-` <- function(ods, value){
    if(isScalarLogical(value)){
        value <- rep(value, ncol(ods))
    }
    colData(ods)[['exclude']] <- value
    return(ods)
}

x <- function(ods){
    k <- t(counts(ods, normalized=FALSE))
    s <- sizeFactors(ods)
    
    # compute log of per gene centered counts 
    x0 <- log((1+k)/s)
    b <- colMeans(x0)
    x <- t(t(x0) - b)
    
    return(x)
}

H <- function(ods){
    x(ods) %*% E(ods)
}

`D<-` <- function(ods, value){
    if(!is.matrix(value)){
        value <- matrix(value, nrow=nrow(ods))
    }
    metadata(ods)[['D']] <- value
    return(ods)
}

D <- function(ods){
    return(metadata(ods)[['D']])
}

`E<-` <- function(ods, value){
    if(!is.matrix(value)){
        value <- matrix(value, nrow=nrow(ods))
    }
    metadata(ods)[['E']] <- value
    return(ods)
}

E <- function(ods){
    return(metadata(ods)[['E']])
}

`b<-` <- function(ods, value){
    mcols(ods)[['b']] <- value
    return(ods)
}

b <- function(ods){
    return(mcols(ods)[['b']])
}

predictC <- function(ods){
    predictMatC(x(ods), E(ods), D(ods), b(ods), sizeFactors(ods))
}

predictY <- function(ods){
    predictMatY(x(ods), E(ods), D(ods), b(ods))
}

trueCounts <- function(ods){
    if('replacedTrueCounts' %in% assayNames(ods)){
        return(assay(ods, 'replacedTrueCounts'))
    }
    return(counts(ods))
}

`trueCounts<-` <- function(ods, value){
    if(!'replacedTrueCounts' %in% assayNames(ods)){
        assay(ods, 'replacedTrueCounts', withDimnames=FALSE) <- value
    }
    return(ods)
}

thetaCorrection <- function(ods){
    if(!"thetaCorrection" %in% colnames(colData(ods))){
        #warning('thetaFactors are not computed. If this intended you can ', 
        #        'ignore this message by setting them to 1. Otherwise please ',
        #        'fit the autoencoder first.')
        return(rep(1, ncol(ods)))
    }
    return(colData(ods)[,'thetaCorrection'])
}

`thetaCorrection<-` <- function(ods, value){
    if(isScalarNumeric(value)){
        value <- rep(value, ncol(ods))
    }
    colData(ods)[['thetaCorrection']] <- value
    return(ods)
}

#'
#' This is a helper function to generate a nice color pallet for plotting
#' 
#' @examples
#'   x <- 10
#'   getXColors(x)
#'   
#'   x <- letters[1:10]
#'   getXColors(x)
#' @noRd  
getXColors <- function(x, set="Set2"){
    if(all(is.na(set))){
        return(NULL)
    }
    
    n <- x
    if(!isScalarNumeric(x)){
        if(is.numeric(x)){
            set <- tryCatch({
                    colorRampPalette(set)
                    set
                }, error = function(e){
                    warning("Please specify correct color for ", 
                            "colorRampPalette. Using default. ",
                            "\n  Error was:\n    ", e)
                    NULL
            })
            return(set)
        }
        x <- factor(x)
        n <- length(levels(x))
    }
    
    if(length(set) == 1){
        cols <- suppressWarnings(brewer.pal(n=n, name=set))
    } else {
        cols <- set
    }
    
    if(length(cols) > n){
        cols <- cols[seq_len(n)]
    }
    
    if(length(x) > 0){
        ans <- cols[x]
        names(ans) <- as.character(x)
        return(ans)
    }
    
    return(cols)
}

#' 
#' Creates a color mapping for the given annotation or return NULL
#' 
#' @noRd
getAnnoColors <- function(colorSet, annotation){
    if(!is.character(colorSet) & is.null(annotation)){
        return(NULL)
    }
    mapply(grp=annotation, set=colorSet, SIMPLIFY=FALSE, 
            FUN=function(grp, set) getXColors(grp[!duplicated(grp)], set))
}

#'
#' Ignore warning of the text aestethics in ggplot for plotly since it is 
#' inofficial till now
#' 
#' @noRd
ignoreAesTextWarning <- function(expr){
    withCallingHandlers(expr, 
            warning = function(w){
                if(endsWith(conditionMessage(w), "unknown aesthetics: text")){
                    invokeRestart("muffleWarning")
                }
    })
}

#' 
#' Get annotation for row/col dependent on input
#' @noRd
getAnnoHeatmap <- function(x, matrix, groups, nClust, extractFun=colData){
    
    # select annotations based on metadata (colData/mcols)
    if(!isScalarNA(groups)){
        ans <- as.data.frame(extractFun(x)[, groups])
        colnames(ans) <- groups
    } else {
        ans <- as.data.frame(extractFun(x)[,character()])
    }
    
    # add clustering
    if(isScalarNumeric(nClust) & isScalarNA(groups)){
        clusters <- cutree(hclust(dist(matrix)), nClust)
        ans[["nClust"]] <- as.character(clusters)
    }
    
    # return NULL if no annotation is requested
    if(ncol(ans) == 0){
        return(NULL)
    }
    
    # due to not propagating rownames correctly in mcols/rowData in R < 3.5.0
    # check if rownames is null and then retrive from object
    rownames(ans) <- rownames(extractFun(x))
    if(is.null(rownames(extractFun(x)))){
        if(ncol(x) == nrow(ans)){
            rownames(ans) <- colnames(x)
        } else {
            rownames(ans) <- rownames(x)
        }
    }
    return(ans)
}

getNiceName <- function(x, maxChar=12){
    stopifnot(maxChar > 2)
    ifelse(nchar(x) > maxChar, 
            paste0(substr(x, 0, maxChar - 2), ".."),
            x)
}

#' 
#' This function is used by the plotDispEsts function.
#' 
#' TODO
#' 
#' @noRd
getDispEstsData <- function(ods, mu=NULL){
    if(is.null(theta(ods))){
        stop('Please fit the ods first. ods <- fit(ods)')
    }
    odsMu <- rowMeans(counts(ods, normalized=TRUE))
    if(is.null(mu)){
        mu <- odsMu
    }
    theta <- theta(ods)
    xidx <- 10^(seq.int(max(-5,log10(min(mu))-1), log10(max(mu))+0.1, 
            length.out = 500))
    
    # fit DESeq2 parametric Disp Fit
    fit <- parametricDispersionFit(mu, 1/theta)
    pred <- fit(xidx)
    return(list(
        mu=mu,
        disp=theta,
        xpred=xidx,
        ypred=pred,
        fit=fit
    ))
}

#'
#' This function is not exported from DESeq2. Therefore we copied it over to
#' here. If DESeq2 will export this function we can use it instead.
#' 
#' TODO
#' 
#' @noRd
parametricDispersionFit <- function (means, disps){
    coefs <- c(0.1, 1)
    iter <- 0
    while (TRUE) {
        residuals <- disps/(coefs[1] + coefs[2]/means)
        good <- which((residuals > 1e-04) & (residuals < 15))
        suppressWarnings({
            fit <- glm(disps[good] ~ I(1/means[good]), 
                    family=Gamma(link="identity"), start=coefs)
        })
        oldcoefs <- coefs
        coefs <- coefficients(fit)
        if (!all(coefs > 0)){
            warning("Parametric dispersion fit failed.", 
                    " Using last working coefficients:", 
                    paste0(round(oldcoefs, 3), sep=", "))
            coefs <- oldcoefs
            break
        }
        if ((sum(log(coefs/oldcoefs)^2) < 1e-06) & fit$converged) 
            break
        iter <- iter + 1
        if (iter > 100) {
            warning("Dispersion fit did not converge after 100 ",
                    "iterations. We stopped here.")
            break
        }
    }
    names(coefs) <- c("asymptDisp", "extraPois")
    ans <- function(q) coefs[1] + coefs[2]/q
    attr(ans, "coefficients") <- coefs
    ans
}

#'
#' Get the gene name or index 
#' 
#' @noRd
getGeneIndex <- function(geneIdx, ods){
    if(is.null(geneIdx)){
        stop('Please provide a geneID')
    }
    if(is.logical(geneIdx)){
        geneIdx <- which(geneIdx)
    }
    if(is.numeric(geneIdx)){
        if(!(is.numeric(geneIdx) && max(geneIdx) <= nrow(ods))){
            stop('Gene index is out of bounds:', paste(geneIdx, collapse=", "))
        }
        if(!is.null(rownames(ods))){
            geneIdx <- rownames(ods)[geneIdx]
        }
    }
    if(is.character(geneIdx) & any(!geneIdx %in% rownames(ods))){
        stop("Gene ID is not in the data set.")
    }
    return(geneIdx)
}

#' @rdname getter_setter_functions
#' @export
getBestQ <- function(ods){
    if('optimalEncDim' %in% names(metadata(ods))){
        return(metadata(ods)[['optimalEncDim']])
    }
    
    if('encDimTable' %in% names(metadata(ods))){
        encTable <- metadata(ods)[['encDimTable']]
        return(getBestQDT(encTable, 'aucPR'))
    }
    # warning('Please find the optimal encoding dimension by running. ')
    return(NA_integer_)
}

getBestQDT <- function(dt, usedEvalMethod='aucPR', digits=10){
    if('evalMethod' %in% colnames(dt)){
        testFun <- ifelse(all(dt[,evalMethod == usedEvalMethod]), 
                which.max, which.min)
    } else {
        testFun <- which.max
    }
    
    dt[,encodingDimension[
            seq_len(.N) == testFun(round(evaluationLoss, digits))]]
}

#'
#' Fit the negative binomial distribution
#' 
#' Fit a negative binomial (NB) distribution to the counts per gene
#' over all samples using, if available, the precomputed control factors.
#' If no normalization factors are provided only the sizeFactors are used.
#' 
#' @param object An OutriderDataSet
#' @param BPPARAM by default bpparam()
#' @param ... Currently not used.
#' @return An OutriderDataSet object with the fitted model. Accessible through:
#'             \code{mcols(ods)[,c('mu', 'theta')]}.
#' 
#' @name fit
#' @rdname fit
#' 
#' @examples 
#' ods <- makeExampleOutriderDataSet()
#' ods <- estimateSizeFactors(ods)
#' ods <- fit(ods)
#' 
#' mcols(ods)[1:10,c('mu', 'theta')]
#' 
#' @export
fit.OutriderDataSet <- function(object, BPPARAM=bpparam(), ...){
    if(length(list(...))){
        stop("... is currently not used. Please remove the ", 
             "additional arguments: ", 
             paste(names(list(...)), collapse=", "))
    }
    fitTheta(object, BPPARAM=BPPARAM)
}

fitTheta <- function(ods, BPPARAM){
    checkOutriderDataSet(ods)
    checkCountRequirements(ods)
    
    ctsData <- counts(ods)
    normF <- normalizationFactors(ods)
    if(is.null(normF)){
        normF <- sizeFactors(ods)
    }
    if(is.null(normF)){
        stop("Please provide sizeFactors or normalizationFactors for better ",
                "estimates!\n  To compute the sizeFactors please run at least:",
                " ods <- estimateSizeFactors(ods).")
    }
    
    excludeMask <- sampleExclusionMask(ods, aeMatrix=TRUE)
    
    fitparameters <- bplapply(seq_along(ods), fitNegBinom, normF=normF,
            ctsData=ctsData, excludeMask=excludeMask, BPPARAM=BPPARAM)
    
    mcols(ods)['mu'] <- vapply(fitparameters, "[[", double(1), "mu")
    theta(ods) <- vapply(fitparameters, "[[", double(1), "size")
    
    assay(ods)

    validObject(ods)
    return(ods)
}


## functions called inside the fit

#initial value estimation. 
initialSizeMu <- function(data, norm){
    m <- mean(data/norm)
    v <- var(as.vector(data/norm)) # inserted as.vector
    size <- if(v > m){
        m^2/(v - m)
    } else {
        1  
    }  
    c("size"=c(size), "mu"=c(m))
}

# log likelihood
loglikelihood <- function(sizemu, x, SizeF){
    -sum(dnbinom(x, size=sizemu[1], mu=sizemu[2]*SizeF, log=TRUE))
}

# gradient of log likelihood
gradloglikelihood <- function(sizemu, x, SizeF){
    r <- sizemu[1]
    m <- sizemu[2]
    s <- SizeF
    c(gradTheta(r, x, m*s),
        -r/m * sum((x-m*s)/(r+m*s)))
}

gradTheta <- function(theta, k, mu){
    ll <- log(mu+theta)-log(theta)-1 + (k+theta)/(theta+mu) - 
        digamma(k+theta) + digamma(theta)
    sum(ll)
}

#fit for individual gene
fitNegBinom <- function(index, ctsData, normF, excludeMask){
    data <- ctsData[index,]
    if(is.matrix(normF)){
        normF <- normF[index,]
    }
    stopifnot(!is.null(normF))
    
    data  <- data[ excludeMask[index,] == 1]
    normF <- normF[excludeMask[index,] == 1]
    
    ##correct s factor
    par <- initialSizeMu(data, normF)
    est <- list(par=c(mu=NA_real_, size=NA_real_))
    # try 3 times to find the optimum and change init values slightly each time
    for(i in seq_len(3)){
        est <- tryCatch(
                optim(par=par, fn=loglikelihood, gr=gradloglikelihood, x=data,
                        SizeF=normF, method="L-BFGS-B", lower=c(0.01,0.01)),
                error = function(e){
                        warning('Fit (', index, ') resulted in error using ', 
                                'init values: ', e$message)})
        if(is.character(est)){
            par <- abs(par + rnorm(2, 0.2))
            next
        }
        break
    }
    if(is.character(est) | is.na(est$par["mu"])){
        # this is currently only happening on windows 32 bit. Probably due to
        # the lower precision compared to 64 bit.
        warning("Fit (", index, ") returned NA's. Using init values instead.")
        return(initialSizeMu(data, normF))
    }
    c(est$par["mu"], est$par["size"])
}

#'
#' @title Visualization functions for OUTRIDER
#' 
#' @name plotFunction
#' 
#' @description The OUTRIDER package provides mutliple functions to visualize
#' the data and the results of a full data set analysis.
#'
#' This is the list of all plotting function provided by OUTRIDER:
#' \itemize{
#'   \item plotAberrantPerSample()
#'   \item plotVolcano()
#'   \item plotExpressionRank()
#'   \item plotQQ()
#'   \item plotExpectedVsObservedCounts()
#'   \item plotCountCorHeatmap()
#'   \item plotCountGeneSampleHeatmap()
#'   \item plotSizeFactors()
#'   \item plotFPKM()
#'   \item plotExpressedGenes()
#'   \item plotDispEsts()
#'   \item plotPowerAnalysis()
#'   \item plotEncDimSearch()
#' }
#'
#' For a detailed description of each plot function please see the details.
#' Most of the functions share the same parameters.
#'
#### Data specific parameters
#' @param ods,object An OutriderDataSet object.
#' @param sampleID,geneID A sample or gene ID, which should be plotted.
#'             Can also be a vector. Integers are treated as indices.
#' @param padjCutoff,zScoreCutoff Significance or Z-score cutoff
#'             to mark outliers
#' @param label Indicates which genes or samples should be labeled. By default 
#'             all aberrant genes/samples are labelled. Can be set to NULL for 
#'             no labels. Provide a vector of geneIDs/sampleIDs to label 
#'             specific genes/samples.
#' @param global Flag to plot a global Q-Q plot, default FALSE
#' @param outlierRatio The fraction to be used for the outlier sample filtering
#' @param normalized If TRUE, the normalized counts are used, the default,
#'             otherwise the raw counts
#' @param compareDisp If TRUE, the default, and if the autoCorrect normalization
#'             was used it computes the dispersion without autoCorrect and
#'             plots it for comparison.
#' @param xaxis Indicates which assay should be shown on the x-axis of the 
#'             volcano plot. Defaults to 'zscore'. Other options are 'fc' and 
#'             'log2fc' for the fold-change or log2 fold-change.
#' @param value Indicates which assay is shown in the manhattan plot. Defaults 
#'             to 'pvalue'. Other options are 'zScore' and 'log2fc'.
#' @param featureRanges A GRanges object of the same length as the 
#'             OutriderDataSet object that contains the genomic positions of 
#'             features that are shown in the manhattan plot.
#' @param subsetName The name of a subset of genes of interest for which FDR 
#'             corrected pvalues were previously computed. Those FDR values 
#'             on the subset will then be used to determine aberrant status. 
#'             Default is NULL (using transcriptome-wide FDR corrected pvalues).
#' @param chr The chromosomes to be displayed in the \code{plotManhattan} 
#'             function. Default is \code{NULL}, i.e. all chromosomes are shown. 
#' @param highlight.label.size Size of the label of the highlighted genes to be 
#'             displayed in the \code{plotManhattan}. Default value is 5.
#### Graphical parameters
#' @param main Title for the plot, if missing a default title will be used.
#' @param groups A character vector containing either group assignments of
#'             samples or sample IDs. Is empty by default. If group assignments
#'             are given, the vector must have the same length as the number of
#'             samples. If sample IDs are provided the assignment will result
#'             in a binary group assignemt.
#' @param groupColSet A color set from RColorBrewer or a manual vector of
#'             colors, which length must match the number of categories
#'             from groups.
#' @param pch Integer or character to be used for plotting the points
#' @param col Set color for the points. If set, it must be a character vector
#'             of length 2. (1. normal point; 2. outlier point) or a single 
#'             character referring to a color palette from \code{RColorBrewer}.
#' @param basePlot if \code{TRUE}, use the R base plot version, else use the
#'             plotly framework, which is the default
#' @param legendPos Set legendpos, by default topleft.
#' @param conf.alpha If set, a confidence interval is plotted, defaults to 0.05
#' @param samplePoints Sample points for Q-Q plot, defaults to max 30k points
#' @param xlim,ylim The x/y limits for the plot or NULL to use
#'             the full data range
#' @param log If TRUE, the default, counts are plotted in log10.
#' @param rowCentered If TRUE, the counts are row-wise (gene-wise) centered
#' @param rowGroups,colGroups A vector of co-factors (colnames of colData)
#'             for color coding the rows. It also accepts a data.frame of
#'             dim = (#samples, #groups). Must have more than 2 groups.
#' @param rowColSet,colColSet A color set from RColorBrewer/colorRampPalette
#' @param nRowCluster,nColCluster Number of clusters to show in the row and
#'             column dendrograms. If this argument is set the resulting
#'             cluster assignments are added to the OutriderDataSet.
#' @param show_names character string indicating whether to show 'none', 'row',
#'             'col', or 'both' names on the heatmap axes.
#' @param bcvQuantile quantile for choosing the cutoff for the biological 
#'             coefficient of variation (BCV)
#' @param nGenes upper limit of number of genes (defaults to 500). Subsets the
#'             top n genes based on the BCV.
#' @param nBreaks number of breaks for the heatmap color scheme. Default to 50.
#' @param bins Number of bins used in the histogram. Defaults to 100.
#' @param yadjust Option to adjust position of Median and 90 percentile labels.
#' @param ylab The y axis label
#' @param chrColor A vector of length 2 giving the two colors used for 
#'             coloring alternating chromosomes in the manhattan plot. Default 
#'             colors are 'black' and 'darkgrey'.
#'
#### Additional ... parameter
#' @param ... Additional parameters passed to plot() or plot_ly() if not stated
#'             otherwise in the details for each plot function
#'
#' @details
#'
#' \code{plotAberrantPerSample}: The number of aberrant events per sample are
#' plotted sorted by rank. The ... parameters are passed on to the
#' \code{\link{aberrant}} function.
#'
#' \code{plotVolcano}: the volcano plot is sample-centric. It plots for a given
#' sample the negative log10 nominal P-values against the Z-scores for all
#' genes.
#'
#' \code{plotExpressionRank}: This function plots for a given gene the
#' expression level against the expression rank for all samples. This can
#' be used with normalized and unnormalized expression values.
#'
#' \code{plotQQ}: the quantile-quantile plot for a given gene or if
#' \code{global} is set to \code{TRUE} over the full data set. Here the
#' observed P-values are plotted against the expected ones in the negative
#' log10 space.
#'
#' \code{plotExpectedVsObservedCounts}: A scatter plot of the observed counts
#' against the predicted expression for a given gene. 
#'  
#' \code{plotCountCorHeatmap}: The correlation heatmap of the count data
#' of the full data set. Default the values are log transformed and
#' row centered. This function returns an OutriderDataSet with annotated
#' clusters if requested. The ... arguments are passed to the
#' \code{\link[pheatmap]{pheatmap}} function.
#'
#' \code{plotCountGeneSampleHeatmap}: A gene x sample heatmap of the raw or
#' normalized counts. By default they are log transformed and row centered.
#' Only the top 500 viable genes based on the BCV (biological coefficient 
#' of variation) is used by default. 
#' 
#' \code{plotSizeFactors}: The sizefactor distribution within the dataset. 
#' 
#' \code{plotFPKM}: The distribution of FPKM values. If the OutriderDataSet
#' object contains the \code{passedFilter} column, it will plot both FPKM
#' distributions for the expressed genes and for the filtered genes.
#'
#' \code{plotExpressedGenes}: A summary statistic plot on the number of genes
#' expressed within this dataset. It plots the sample rank (based on the 
#' number of expressed genes) against the accumulated statistics up to the 
#' given sample. 
#' 
#' \code{plotDispEsts}: Plots the dispersion of the OutriderDataSet
#' model against the normalized mean count. If autoCorrect is used it will also
#' estimate the dispersion without normalization for comparison.
#'
#' \code{plotPowerAnalysis}: The power analysis plot should give the user a
#' ruff estimate of the events one can be detected with OUTRIDER. Based on
#' the dispersion of the provided OUTRIDER data set the theoretical P-value
#' over the mean expression is plotted. This is done for different expression
#' levels. The curves are smooths to make the reading of the plot easier.
#' 
#' \code{plotEncDimSearch}: Visualization of the estimation of the optimal
#' encoding dimension. If Optimal Hard Thresholding was used, the singular values
#' are plotted against their rank. If a hyperparameter optimization was performed, 
#' the encoding dimension against the achieved loss (area under the 
#' precision-recall curve) is plotted. 
#' 
#' \code{plotManhattan}: Visualizes different metrics for each gene (pvalue, 
#' log2 fold-change, z-score) along with the genomic coordinates of the 
#' respective gene as a manhattan plot. Detected outlier genes are highlighted 
#' in red. 
#' 
#' @return If base R graphics are used nothing is returned else the plotly or
#'             the gplot object is returned.
#'
#' @examples
#' ods <- makeExampleOutriderDataSet(dataset="Kremer")
#' implementation <- 'autoencoder'
#' \dontshow{
#'     # reduce the object size to speed up the calculations
#'     ods <- ods[1:400,1:80]
#'     implementation <- 'pca'
#' }
#'
#' mcols(ods)$basepairs <- 300 # assign pseudo gene length for filtering
#' ods <- filterExpression(ods)
#' # restrict FDR correction to set of genes of interest per sample
#' genesOfInterest <- list(MUC1372 = c("ATPIF1", "UROD", "YBX1", 
#'                                      sample(rownames(ods), 25)),
#'                         MUC1360 = sample(rownames(ods), 50),
#'                         MUC1350 = sample(rownames(ods), 75),
#'                         X76619 = sample(rownames(ods), 20),
#'                         X74172 = sample(rownames(ods), 150))
#' ods <- OUTRIDER(ods, implementation=implementation, subsets=list("exampleGenes"=genesOfInterest))
#' 
#' plotAberrantPerSample(ods)
#' plotAberrantPerSample(ods, subsetName="exampleGenes")
#'
#' plotVolcano(ods, 49)
#' plotVolcano(ods, 'MUC1365', basePlot=TRUE)
#' plotVolcano(ods, 'MUC1351', basePlot=TRUE, xaxis="log2fc", label=c("NBPF16"))
#' plotVolcano(ods, 'MUC1372', basePlot=TRUE, subsetName="exampleGenes")
#'
#' plotExpressionRank(ods, 35)
#' plotExpressionRank(ods, 35, subsetName="exampleGenes")
#' plotExpressionRank(ods, "NDUFS5", normalized=FALSE, label="MUC1372",
#'     log=FALSE, main="Over expression outlier", basePlot=TRUE)
#'
#' plotQQ(ods, 149)
#' plotQQ(ods, 149, subsetName="exampleGenes")
#' plotQQ(ods, global=TRUE, outlierRatio=0.001)
#' 
#' plotExpectedVsObservedCounts(ods, 149)
#' plotExpectedVsObservedCounts(ods, "ATAD3C", basePlot=TRUE)
#' plotExpectedVsObservedCounts(ods, "UROD", subsetName="exampleGenes")
#' 
#' plotExpressedGenes(ods)
#' 
#' sex <- sample(c("female", "male"), dim(ods)[2], replace=TRUE)
#' colData(ods)$Sex <- sex
#' ods <- plotCountCorHeatmap(ods, nColCluster=4, normalized=FALSE)
#' ods <- plotCountCorHeatmap(ods, colGroup="Sex", colColSet="Set1")
#' table(colData(ods)$clusterNumber_4)
#' 
#' plotCountGeneSampleHeatmap(ods, normalized=FALSE)
#' plotCountGeneSampleHeatmap(ods, rowGroups="theta", 
#'         rowColSet=list(c("white", "darkgreen")))
#' 
#' plotSizeFactors(ods)
#' 
#' mcols(ods)$basepairs <- 1
#' mcols(ods)$passedFilter <- rowMeans(counts(ods)) > 10
#' plotFPKM(ods)
#'
#' plotDispEsts(ods, compareDisp=FALSE)
#'
#' plotPowerAnalysis(ods)
#'
#' \dontrun{
#' # for speed reasons we only search for 5 different dimensions
#' ods <- estimateBestQ(ods, useOHT=FALSE, params=c(3, 10, 20, 35, 50), 
#'         implementation=implementation)
#' plotEncDimSearch(ods)
#' }
#' 
#' # To show the pvalues of a sample in a manhattan plot, rowRanges(ods) must 
#' # contain the genomic position of each feature or a GRanges object must 
#' # be provided 
#' \dontrun{
#' # in case rowRanges(ods) is a GRangesList, run this first once to speed up:
#' rowRanges(ods) <- unlist(endoapply(rowRanges(ods), range))
#' }
#' gr <- GRanges(
#'          seqnames=sample(paste0("chr", 1:22), nrow(ods), replace=TRUE),
#'          ranges=IRanges(start=runif(nrow(ods), min=0, max=1e5), width=100))
#' plotManhattan(ods, "MUC1350", value="pvalue", featureRanges=gr)
#' plotManhattan(ods, "MUC1350", value="l2fc", featureRanges=gr)
#' plotManhattan(ods, "MUC1372", featureRanges=gr, subsetName="exampleGenes")
#'
#' @rdname plotFunctions
#' @aliases plotFunctions plotVolcano plotQQ plotExpectedVsObservedCounts 
#'       plotExpressionRank plotCountCorHeatmap plotCountGeneSampleHeatmap
#'       plotAberrantPerSample plotFPKM plotDispEsts plotPowerAnalysis
#'       plotEncDimSearch plotExpressedGenes plotSizeFactors plotManhattan
#'
NULL


plotVolcano.OUTRIDER <- function(object, sampleID, main, padjCutoff=0.05,
                    zScoreCutoff=0, label="aberrant",
                    xaxis=c("zscore", "log2fc", "fc"),
                    pch=16, basePlot=FALSE, 
                    col=c("gray", "firebrick"), subsetName=NULL){
    if(missing(sampleID)){
        stop("specify which sample should be plotted, sampleID = 'sample5'")
    }
    if(!all(c('padjust', 'zScore') %in% assayNames(object))){
        stop('Calculate Z-scores and P-values first.')
    }
    if(is.logical(sampleID)){
        sampleID <- which(sampleID)
    }
    if(is.numeric(sampleID)){
        if(!(is.numeric(sampleID) && max(sampleID) <= ncol(object))){
            stop('Sample index is out of bounds:',
                    paste(sampleID, collapse=", "))
        }
        sampleID <- colnames(object)[sampleID]
    }
    if(!all(sampleID %in% colnames(object))){
        stop("Sample ID is not in the data set.")
    }
    if(length(sampleID) > 1){
        ans <- lapply(sampleID, plotVolcano, object=object, 
                padjCutoff=padjCutoff,
                zScoreCutoff=zScoreCutoff, basePlot=basePlot,
                subsetName=subsetName)
        return(ans)
    }
    if(missing(main)){
        main <- paste0("Volcano plot: ", sampleID)
    }

    if(is.null(rownames(object))){
        rownames(object) <- paste("feature", seq_len(nrow(object)), sep="_")
    }
    
    xaxis <- match.arg(xaxis)
    if(xaxis == "zscore"){
        if("zScore" %in% assayNames(object)){
            xaxis <- zScore(object)
            xaxis_name <- "Z-Score"
            base_x_lab <- xaxis_name
        } else{
            stop("Calculate zScores first or choose other xaxis type.")
        }
        
    } else if(xaxis == "fc"){
        if("l2fc" %in% assayNames(object)){
            xaxis <- 2^assay(object, "l2fc")
            xaxis_name <- "Fold change"
            base_x_lab <- xaxis_name
        } else{
            stop("Calculate log2fc first or choose other xaxis type.")
        } 
    } else if(xaxis == "log2fc"){
        if("l2fc" %in% assayNames(object)){
            xaxis <- assay(object, "l2fc")
            xaxis_name <- expression(paste(log[2], "(fold-change)"))
            base_x_lab <- paste("log<sub>2</sub>(fold-change)")
        } else{
            stop("Calculate log2fc first or choose other xaxis type.")
        } 
    } else {
        stop("Unknown xaxis type, choose one of zscore, fc, log2fc.")
    }

    dt <- data.table(
        GENE_ID   = rownames(object),
        pValue    = pValue(object)[,sampleID],
        padjust   = padj(object, subsetName=subsetName)[,sampleID],
        # zScore    = zScore(object)[,sampleID],
        xaxis        = xaxis[,sampleID],
        normCts   = counts(object, normalized=TRUE)[,sampleID],
        medianCts = rowMedians(counts(object, normalized=TRUE)),
        expRank   = apply(
                counts(object, normalized=TRUE), 2, rank)[,sampleID],
        aberrant  = aberrant(object, padjCutoff=padjCutoff,
                zScoreCutoff=zScoreCutoff, subsetName=subsetName)[,sampleID],
        color     = col[1])
    dt[aberrant == TRUE, color:=col[2]]
    dt[is.na(padjust), color:=col[3]]
    dt[aberrant == TRUE, aberrantLabel:="aberrant"]
    dt[aberrant == FALSE, aberrantLabel:="not aberrant"]
    dt[is.na(aberrant), aberrantLabel:="not in tested group"]

    # remove the NAs from the zScores for plotting
    dt[is.na(xaxis),xaxis:=0]

    p <- ggplot(dt, aes(xaxis, -log10(pValue), color=aberrantLabel, 
                        label=GENE_ID, text=paste0(
                "Gene ID: ", GENE_ID,
                "<br>Sample ID: ", sampleID,
                "<br>Median normcount: ", round(medianCts, 2),
                "<br>normcount: ", round(normCts, 2),
                "<br>expression rank: ", as.integer(expRank),
                "<br>nominal P-value: ", signif(pValue,3),
                "<br>adj. P-value: ", signif(padjust,3),
                "<br>", xaxis_name, ": ", signif(xaxis,2)))) + 
        geom_point() + 
        theme_bw() + 
        xlab(xaxis_name) + 
        ylab(expression(paste(-log[10], "(", italic(P), "-value)"))) + 
        ggtitle(main) + 
        scale_color_manual(values=c("not aberrant"=col[1], "aberrant"=col[2], 
                                    "not in tested group"="gray90")) + 
        theme(legend.position = 'bottom',
              legend.title=element_blank())
    
    if(!is.null(subsetName)){
        p <- p + labs(subtitle=paste0("FDR across genes in the ", subsetName, 
                                " group (N=", dt[!is.na(padjust), .N], ")"))
    }
    
    # Log scale if fold change is plotted
    if(isTRUE(basePlot)){
        if(!is(xaxis_name, "expression") && xaxis_name == 'Fold change'){
            p <- p + scale_x_log10(labels = scales::trans_format(
                "log10", scales::math_format(10^.x)))
        }
        if(!is.null(label)){
            if(isScalarCharacter(label) && label == "aberrant"){
                if(nrow(dt[aberrant == TRUE,]) > 0){
                    p <- p + 
                        geom_text_repel(data=dt[aberrant == TRUE,], 
                                        aes(col=aberrantLabel), fontface='bold', 
                                        hjust=-.2, vjust=.2)
                }
            }
            else{
                if(nrow(dt[GENE_ID %in% label]) > 0){
                    p <- p + 
                        geom_text_repel(data=subset(dt, GENE_ID %in% label), 
                                        aes(col=aberrantLabel), fontface='bold', 
                                        hjust=-.2, vjust=.2)
                }
                if(any(!(label %in% dt[,GENE_ID]))){
                    warning("Did not find gene(s) ", 
                            paste(label[!(label %in% dt[,GENE_ID])], 
                                    collapse=", "), " to label.")
                }
            }
        }
    }
    
    if(isFALSE(basePlot)){
        p <- p + ylab(paste("-log<sub>10</sub>(<i>P</i>-value)"))
        return(ggplotly(p, tooltip="text"))        
    }
    p
}

#' @rdname plotFunctions
#' @export
setMethod("plotVolcano", signature(object="OutriderDataSet"),
        plotVolcano.OUTRIDER)


plotQQ.OUTRIDER <- function(object, geneID, main, global=FALSE, padjCutoff=0.05,
                    zScoreCutoff=0, samplePoints=TRUE, legendPos="topleft",
                    outlierRatio=0.001, conf.alpha=0.05, subsetName=NULL,
                    pch=16, xlim=NULL, ylim=NULL, col=NULL){
    checkOutriderDataSet(object)
    stopifnot(isScalarLogical(global))
    if(missing(geneID) & isFALSE(global)){
        stop('Please provide a geneID or set global to TRUE')
    }
    # Singel gene QQplot.
    if(isFALSE(global)){
        geneID <- getGeneIndex(geneID, object)

        # Produce multiple qqplot if geneID is a vector.
        if(length(geneID)>1L){
            lapply(geneID, plotQQ, object=object, main=main, 
                    legendPos=legendPos, col=col, global=FALSE)
            return(invisible())
        }
        #Plot QQplot for single gene.
        if(missing(main)){
            main <- paste0('Q-Q plot for gene: ', geneID)
        }
        if(!is.null(subsetName)){
            main <- paste0(main, "\nFDR across genes in the ", subsetName, 
                            " group")
        } 
        if(is.null(col)){
            col <- c('black', 'firebrick')
        }
        pVal <- as.numeric(assay(object[geneID,], 'pValue'))
        #plot all points with cex=1 for single gene.
        pointCex <- 1
        #data table with expected and observerd log10(pValues)
        aberrantEvent <- aberrant(object[geneID,], padjCutoff=padjCutoff,
                zScoreCutoff=zScoreCutoff, subsetName=subsetName, by='sample')
        df <- data.table(obs= -log10(pVal), pch=pch, subset=FALSE,
                col=ifelse(aberrantEvent, col[2], col[1]))

    # global QQplot
    } else {
        if(missing(main)){
            main <- 'Global Q-Q plot'
        }
        if(is.null(col)){
            col <- c('#d95f02', '#1b9e77')
        }
        pVal <- as.numeric(assay(object, 'pValue'))

        # Reducing Point size for global QQplot.
        pointCex <- .5

        #data table with expected and observerd log10(pValues)
        df <- data.table(obs= -log10(pVal), col=col[1], pch=pch, subset=FALSE)

        if(!is.null(outlierRatio)){
            odssub <- object[,aberrant(object, by='s', padjCutoff=padjCutoff,
                    zScoreCutoff=zScoreCutoff) < outlierRatio*length(object)]
            if(ncol(odssub) > 0){
                pVal <- as.numeric(assay(odssub, 'pValue'))
                dfsub <- data.table(obs=-log10(pVal), col=col[2], pch=pch,
                        subset=TRUE)
                df <- rbind(df, dfsub)
            }
        }
    }

    # compute expected pValues.
    df <- df[order(subset, -obs)]

    # Correct p value if needed
    df[is.na(obs) | is.infinite(obs), obs:=1]
    minNonZeroP <- min(df[obs!=0, obs]) * 1e-2
    df[obs==0, obs:=minNonZeroP]

    df[,exp:=-log10(ppoints(.N)), by='subset']
    if(is.null(xlim)){
        xlim=range(df[,exp])
    }
    if(is.null(ylim)){
        ylim=range(df[,obs], na.rm=TRUE)
    }
    plot(NA, xlim=xlim, ylim=ylim, main=main, 
            xlab=expression(
                    paste(-log[10], " (expected ", italic(P), "-value)")),
            ylab=expression(
                    paste(-log[10], " (observed ", italic(P), "-value)")))


    # confidence band
    # http://genome.sph.umich.edu/wiki/Code_Sample:_Generating_QQ_Plots_in_R
    if(isTRUE(conf.alpha)){
        conf.alpha <- 0.05
    }
    if(is.numeric(conf.alpha)){
        exp <- df[subset==FALSE,exp]
        len <- length(exp)
        slen <- seq_len(len)
        getY <- function(x, exp){
            x1 <- exp[2]
            x2 <- exp[1]
            y1 <- -log10(x[2])
            y2 <- -log10(x[1])
            m <- (y2-y1)/(x2-x1)
            return(10^-(y1 + m*((x2+1)-x1)))
        }
        upper <- qbeta(    conf.alpha/2, slen, rev(slen))
        lower <- qbeta(1 - conf.alpha/2, slen, rev(slen))
        polygon(col="gray", border="gray", x=c(rev(exp), max(exp)+c(1,1), exp),
                y=-log10(c(
                        rev(upper), getY(upper, exp), getY(lower, exp), lower)))
    }

    #Add points to plot.
    if(isTRUE(samplePoints)){
        samplePoints <- c(5000, 30000)
    }
    if(is.numeric(samplePoints) & length(samplePoints) == 2){
        plotPoint <- df[,seq_len(.N) %in% c(seq_len(min(.N, samplePoints[1])),
                sample(seq_len(.N), size=min(.N, samplePoints[2]))),
                by='subset'][,V1]
        df <- df[plotPoint]
    }
    df[,points(exp, obs, pch=pch, col=col, cex=pointCex)]

    # diagonal and grid
    abline(0,1,col="firebrick")
    grid()

    #Add legend
    if(isTRUE(global)){
        legenddt <- data.table(onlyFull=c(TRUE, FALSE, TRUE),
                text=c("Full data set", "Filtered data set",
                        paste0("CI (\u03B1 = ", signif(conf.alpha, 2), ")")),
                lty=1, lwd=6, col=c(col, "gray"))
        if(length(unique(df[,subset])) == 1){
            legenddt <- legenddt[onlyFull == TRUE]
        }
        legenddt[,legend(legendPos, text, lty=lty, lwd=lwd, col=col)]
    } else {
        if(is.numeric(conf.alpha)){
            legend(legendPos, lty=1, lwd=7, col="gray",
                    paste0("CI (\u03B1 = ", signif(conf.alpha, 2), ")"))
        }
    }

    return(invisible())
}


#' @rdname plotFunctions
#' @export
setMethod("plotQQ", signature(object="OutriderDataSet"), plotQQ.OUTRIDER)


#' @rdname plotFunctions
#' @export
plotExpectedVsObservedCounts <- function(ods, geneID, main, basePlot=FALSE,
                    log=TRUE, groups=c(), groupColSet='Set1', label="aberrant", 
                    subsetName=NULL, ...){

    # check user input
    checkOutriderDataSet(ods)
    if(is.null(normalizationFactors(ods))) {
        stop('Normalized counts missing')
    }
    if(missing(geneID)){
        stop("Please Specify which gene should be plotted, geneID = 'geneA'")
    }
    geneID <- getGeneIndex(geneID, ods)
    if (missing(main)) {
        main <- paste("Predicted expression plot:", geneID)
    }
    if(is.null(subsetName)){
        subtitle <- NULL
    } else{
        subtitle <- paste0("FDR across genes in the ", subsetName, " group")
    }

    ods <- ods[geneID]
    cnts <- data.table(
            feature_id = geneID,
            sampleID   = colnames(ods),
            observed   = as.vector(counts(ods)) + isTRUE(log),
            expected   = as.vector(normalizationFactors(ods)) + isTRUE(log),
            aberrant   = as.vector(aberrant(ods, subsetName=subsetName)))
    cnts[is.na(aberrant), aberrant:=FALSE]

    # group assignment
    if(length(groups) != ncol(ods)) {
        tmp_group <- logical(nrow(cnts))
        tmp_group[cnts$sampleID %in% groups] <- TRUE
        groups <- tmp_group
    }

    # rename NA groups
    groups[is.na(groups)] <- 'NA'
    cnts[, group := groups]

    g <- ggplot(cnts, aes(expected, observed, label=sampleID, 
                            text=paste0(
                "Gene ID: ", feature_id, "<br>", 
                "Sample ID: ", sampleID, "<br>",
                "Raw count: ", observed, "<br>",
                "Expected count: ", round(expected, 2), "<br>"))) +
        theme_bw() +
        geom_abline(slope = 1, intercept = 0) +
        labs(title = main, subtitle=subtitle,
                x=paste('Expected counts', ifelse(isTRUE(log), '+ 1', '')),
                y=paste('Raw counts', ifelse(isTRUE(log), '+ 1', '')))

    if(isTRUE(log)) {
        g <- g + scale_x_log10() + scale_y_log10()
    }

    point_mapping <- aes()
    # distinguish whether groups are given or not
    if(uniqueN(cnts$group) > 1 ) { # more than 1 group given
        # set color of groups
        if (is.character(groupColSet)) {
            g  <- g + scale_color_brewer(palette = groupColSet)
        } else {
            g <- g + scale_color_manual(values = groupColSet)
        }
        point_mapping$colour <- substitute(group)
        g <- g + geom_point(point_mapping)
    } else { # no grouping given
        point_mapping$colour <- substitute(aberrant)
        g <- g + geom_point(point_mapping) +
            scale_color_manual(values = c("FALSE"="gray", 
                                          "TRUE"="firebrick")) +
            theme(legend.position = 'none')
    }

    if (isTRUE(basePlot)) {
        if(!is.null(label)){
            if(isScalarCharacter(label) && label == "aberrant"){
                if(nrow(cnts[aberrant == TRUE,]) > 0){
                    g <- g + 
                        geom_text_repel(data=cnts[aberrant == TRUE,], 
                                        aes(col=aberrant), fontface='bold', 
                                        hjust=-.2, vjust=.5)
                }
            }
            else{
                if(nrow(cnts[sampleID %in% label]) > 0){
                    g <- g + 
                        geom_text_repel(data=subset(cnts, sampleID %in% label), 
                                        aes(col=aberrant), fontface='bold', 
                                        hjust=-.2, vjust=.5)
                }
                if(any(!(label %in% cnts[,sampleID]))){
                    warning("Did not find sample(s) ", 
                            paste(label[!(label %in% cnts[,sampleID])], 
                                    collapse=", "), " to label.")
                }
            }
        }
        return(g)
    }
    ggplotly(g, tooltip="text")
}


#' @rdname plotFunctions
#' @export
plotExpressionRank <- function(ods, geneID, main, padjCutoff=0.05,
                    zScoreCutoff=0, normalized=TRUE, basePlot=FALSE, log=TRUE,
                    col=c("gray", "firebrick"), groups=c(),
                    groupColSet='Accent', label="aberrant", 
                    subsetName=NULL){
    # check user input
    checkOutriderDataSet(ods)
    if(isTRUE(normalized) & is.null(sizeFactors(ods))){
        stop("Please calculate the sizeFactors or normalization factors ",
                "before plotting normlized counts.")
    }
    if(missing(geneID)){
        stop("Please Specify which gene should be plotted, geneID = 'geneA'")
    }
    geneID <- getGeneIndex(geneID, ods)

    if(length(col) != 2){
        stop("Please provide two colors as a vector.")
    }
    if(length(groups) == 0){
        groups <- logical(ncol(ods))
    } else if(all(groups %in% colData(ods)[,'sampleID'])){
        group <- colData(ods)[,'sampleID'] %in% groups
    } else if(length(groups) == ncol(ods)){
        groups[is.na(groups)] <- 'NA'
    } else {
        stop("Please provide meaningfull input for 'groups'.")
    }

    # apply over each gene if vector
    if(length(geneID) > 1){
        ans <- lapply(geneID, plotExpressionRank, ods=ods,
                padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff,
                basePlot=basePlot, normalized=normalized, subsetName=subsetName)
        return(ans)
    }
    stopifnot(isScalarValue(geneID))

    # subset ods
    ods <- ods[geneID,]

    dt <- data.table(
        sampleID  = colnames(ods),
        counts    = as.vector(counts(ods, normalized=normalized)) + isTRUE(log),
        rawcounts = as.vector(counts(ods)),
        group     = groups)

    dt[, medianCts:= median(counts)]
    dt[, norm_rank:= rank(counts, ties.method = 'first')]
    if(all(c('pValue', 'padjust', 'zScore') %in% assayNames(ods))){
        dt[, pValue   := assay(ods, 'pValue')[1,]]
        dt[, padjust  := padj(ods, subsetName=subsetName)[1,]]
        dt[, zScore   := assay(ods, 'zScore')[1,]]
        dt[, aberrant := aberrant(ods, padjCutoff=padjCutoff,
                zScoreCutoff=zScoreCutoff, subsetName=subsetName)[1,]]
        dt[is.na(aberrant), aberrant:=FALSE]
    } else {
        dt[,aberrant:=FALSE]
    }
    ylab <- paste0(ifelse(isTRUE(normalized), "Normalized", "Raw"),
            " counts", ifelse(isTRUE(log), " + 1", ""))
    if(missing(main)){
        main <- paste("Expression rank plot:", geneID)
    }
    if(is.null(subsetName)){
        subtitle <- NULL
    } else{
        subtitle <- paste0("FDR across genes in the ", subsetName, " group")
    }

    # create ggplot object
    g <- ggplot(data=dt, aes(x = norm_rank, y = counts, label = sampleID, 
                            text = paste0(
        "Gene ID: ", geneID, "<br>",
        "Sample ID: ", sampleID, "<br>",
        ifelse(uniqueN(groups) == 1, "", paste0("Group: ", group, "<br>")),
        "Median normcount: ", round(medianCts, digits = 1), "<br>", 
        "rawcount: ", rawcounts, "<br>", 
        "expression rank: ", round(norm_rank, digits = 1), "<br>",
        if('padjust' %in% colnames(dt))
             paste0("adj. P-value: ", sprintf("%1.1E", padjust), "<br>", 
                    "nominal P-value: ", sprintf("%1.1E", pValue), "<br>",
                    "Z-score: ", round(zScore, digits = 1), "<br>")
    ))) +
        labs(title = main, subtitle=subtitle, x = 'Sample rank', y = ylab) +
        theme_bw()

    if(isTRUE(log)){
        g <- g + scale_y_log10()
    }
    
    point_mapping <- aes(col = aberrant)

    # switch color mode
    if(uniqueN(groups) > 1){
        point_mapping$fill <- substitute(group)
        ignoreAesTextWarning({
            g <- g + 
                geom_point(size=3, stroke=0.5, pch=21, mapping=point_mapping) +
                scale_fill_brewer(palette=groupColSet) +
                scale_color_manual(values= c('grey30', col[2]))
        })
    } else {
        ignoreAesTextWarning({
            g <- g + geom_point(size = 2, point_mapping) +
                scale_color_manual(values = col) +
                theme(legend.position = 'none')
        })
    }

    if(isTRUE(basePlot)){
        if(!is.null(label)){
            if(isScalarCharacter(label) && label == "aberrant"){
                if(nrow(dt[aberrant == TRUE,]) > 0){
                    g <- g + 
                        geom_text_repel(data=dt[aberrant == TRUE,], 
                                        aes(col=aberrant), fontface='bold', 
                                        hjust=-.2, vjust=.5)
                }
            }
            else{
                if(nrow(dt[sampleID %in% label]) > 0){
                    g <- g + 
                        geom_text_repel(data=subset(dt, sampleID %in% label), 
                                        aes(col=aberrant), fontface='bold', 
                                        hjust=-.2, vjust=.5)
                }
                if(any(!(label %in% dt[,sampleID]))){
                    warning("Did not find sample(s) ", 
                            paste(label[!(label %in% dt[,sampleID])], 
                                    collapse=", "), " to label.")
                }
            }
        }
        return(g)
    }
    return(ggplotly(g))
}


plotCountCorHeatmap.OUTRIDER <- function(object, normalized=TRUE,
                    rowCentered=TRUE, rowGroups=NA, rowColSet=NA, colGroups=NA,
                    colColSet=NA, nRowCluster=4, nColCluster=4,
                    main="Count correlation heatmap", basePlot=TRUE, nBreaks=50,
                    show_names=c("none", "row", "col", "both"), ...) {
    
    checkDeprication(names2check=c("rowGroups"="rowCoFactor", 
            "colGroups"="colCoFactor", "nRow/nCol-Cluster"="nCluster", 
            "not used anymore"="dendrogram", "show_names"="names"), ...)
    
    if(!isTRUE(basePlot)){
        return(plotCountCorHeatmapPlotly(
            object, normalized=normalized, rowCentered=rowCentered,
            rowGroups=rowGroups, rowColSet=rowColSet,
            colGroups=colGroups, colColSet=colColSet,
            nRowCluster=nRowCluster, nColCluster=nColCluster,
            main=main, ...))
    }

    # correlation
    fcMat <- as.matrix(log2(counts(object, normalized=normalized) + 1))
    if(isTRUE(rowCentered)){
        fcMat <- fcMat - rowMeans(fcMat)
    }
    ctscor <- cor(fcMat, method="spearman")

    # extract annotation and set clustering if requested
    annotation_row <- getAnnoHeatmap(x=object, matrix=ctscor, groups=rowGroups,
            nClust=nRowCluster, extractFun=colData)
    annotation_col <- getAnnoHeatmap(x=object, matrix=ctscor, groups=colGroups,
            nClust=nColCluster, extractFun=colData)
    if(!is.null(annotation_row) & "nClust" %in% colnames(annotation_row)){
        colData(object)[[paste0('clusterNumber_', nRowCluster)]] <- 
                annotation_row[,'nClust']
    }
    if(!is.null(annotation_col) & "nClust" %in% colnames(annotation_col)){
        colData(object)[[paste0('clusterNumber_', nColCluster)]] <- 
            annotation_col[,'nClust']
    }
    
    show_names <- match.arg(show_names, several.ok=FALSE)

    plotHeatmap(
        object, ctscor,
        annotation_row = annotation_row,
        annotation_col = annotation_col,
        rowColSet = rowColSet,
        colColSet = colColSet,
        main = main,
        show_names = show_names,
        breaks=seq(-1, 1, length.out = nBreaks),
        ...
    )
}

plotCountCorHeatmapPlotly <- function(x, normalized=TRUE, rowCentered=TRUE,
                    rowGroups=NA, rowColSet=NA, 
                    colGroups=NA, colColSet=NA, 
                    nCluster=4, main="Count correlation heatmap", ...){
    # correlation
    fcMat <- as.matrix(log2(counts(x, normalized=normalized) + 1))
    if(isTRUE(rowCentered)){
        fcMat <- fcMat - rowMeans(fcMat)
    }
    ctscor <- cor(fcMat, method="spearman")

    # dendogram and clusters
    clusters <- cutree(hclust(dist(ctscor)), nCluster)
    clustCol <- getXColors(factor(clusters), "Dark2")
    if(is.numeric(nCluster)){
        colData(x)$clusterNumber <- names(clustCol)
    }

    if(is.na(rowGroups) & is.na(colGroups)){
        rowColSet <- colColSet
    }
    if(!is.na(colGroups)){
        if(is.na(colColSet)){
            colColSet <- "Dark2"
        }
        colCols <- getXColors(colData(x)[,colGroups], colColSet)
    } else {
        colCols <- clustCol
    }
    if(!is.na(rowGroups)){
        if(is.na(rowColSet)){
            rowColSet <- "Dark2"
        }
        colRows <- getXColors(colData(x)[,rowGroups], rowColSet)
    } else {
        colRows <- clustCol
    }

    p <- heatmaply(ctscor, col_side_colors=colCols, 
            row_side_colors=colRows, ...)
    
    return(p)
}

#' @rdname plotFunctions
#' @export
setMethod("plotCountCorHeatmap", signature="OutriderDataSet", 
        plotCountCorHeatmap.OUTRIDER)


##### plotCountGeneSampleHeatmap #####
#' @rdname plotFunctions
#' @export
plotCountGeneSampleHeatmap <- function(ods, normalized=TRUE, rowCentered=TRUE,
                    rowGroups=NA, rowColSet=NA, colGroups=NA,
                    colColSet=NA, nRowCluster=4, nColCluster=4,
                    main="Count Gene vs Sample Heatmap", bcvQuantile=0.9,
                    show_names=c("none", "col", "row", "both"),
                    nGenes=500, nBreaks=50, ...){

    if (is.null(rownames(ods))) {
        message("Missing row names, using row numbers.")
        rownames(ods) <- paste0('row', seq_row(ods))
    } else if (is.null(colnames(ods))) {
        message("Missing column names, using column numbers.")
        colnames(ods) <- paste0('col', seq_col(ods))
    }

    ## Take top nGenes variable genes
    bcv <- 1/sqrt(robustMethodOfMomentsOfTheta(counts(ods), 1e4, 1e-2))
    if("theta" %in% colnames(mcols(ods))){
        bcv <- 1/sqrt(theta(ods))
    }
    rowData(ods)$BCV <- bcv
    ods_sub <- ods[!is.na(bcv) & 
            bcv > quantile(bcv, probs=bcvQuantile, na.rm=TRUE),]

    # take the top n genes if specified
    if(!is.null(nGenes)){
        ods_sub <- ods_sub[rank(rowData(ods_sub)$BCV) <= nGenes,]
        main = paste0(main, "\n", nrow(ods_sub), " most variable genes")
    }

    # count matrix
    if(isTRUE(normalized)){
        # autoencoder normalised values
        fcMat <- as.matrix(log2(counts(ods_sub, normalized=TRUE) + 1))
    } else {
        # normalize using sizeFactors
        fcMat <- as.matrix(log2(counts(ods_sub, normalized=FALSE) + 1))
        fcMat <- t(t(fcMat)/estimateSizeFactorsForMatrix(fcMat))
    }

    # center matrix
    if(isTRUE(rowCentered)) {
        fcMat <- fcMat - rowMeans(fcMat)
    }

    # row annotations
    annotation_row <- getAnnoHeatmap(x=ods_sub, matrix=fcMat, 
            groups=rowGroups, nClust=nRowCluster, extractFun=rowData)
    annotation_col <- getAnnoHeatmap(x=ods_sub, matrix=t(fcMat), 
            groups=colGroups, nClust=nColCluster, extractFun=colData)

    show_names <- match.arg(show_names, several.ok=FALSE)

    plotHeatmap(
        ods, fcMat,
        annotation_row = annotation_row,
        annotation_col = annotation_col,
        rowColSet = rowColSet,
        colColSet = colColSet,
        main = main,
        show_names = show_names,
        breaks=seq(-10, 10, length.out = nBreaks),
        ...
    )
}

plotHeatmap <- function(ods, mtx, annotation_row=NULL, annotation_col=NULL,
                    rowColSet=NA, colColSet=NA, main = "Heatmap",
                    show_names = c("none", "col", "row", "both"),
                    annotation_colors=NA, breaks=NA, ...){

    if (is.null(rownames(ods))) {
        message("Missing row names, using row numbers.")
        rownames(ods) <- paste0('row', seq_row(ods))
    } else if (is.null(colnames(ods))) {
        message("Missing column names, using column numbers.")
        colnames(ods) <- paste0('col', seq_col(ods))
    }

    # collect colours
    row_colors <- getAnnoColors(colorSet=rowColSet, annotation=annotation_row)
    col_colors <- getAnnoColors(colorSet=colColSet, annotation=annotation_col)
    tmp_anno_colors <- c(row_colors, col_colors)
    
    # use user defined colors and override autogenerated once if needed
    if(!missing(annotation_colors) & !isScalarNA(annotation_colors)){
        tmp_anno_colors <- c(annotation_colors, tmp_anno_colors)
    }
    
    # remove duplicates and NULL colors
    annotation_colors <- tmp_anno_colors[!duplicated(names(tmp_anno_colors))]
    annotation_colors <- annotation_colors[
            !vapply(annotation_colors, is.null, logical(1))]
    if(length(annotation_colors) == 0){
        annotation_colors <- NA
    }

    # option to show names in heatmap
    show_names <- match.arg(show_names, several.ok=FALSE)

    print(pheatmap(
        mat = mtx,
        breaks = breaks,
        color = colorRampPalette(c("blue", "white", "red"))(length(breaks)),
        main = main,
        border_color = NA,
        show_rownames = (show_names == 'row' | show_names == 'both'),
        show_colnames = (show_names == 'col' | show_names == 'both'),
        annotation_row = annotation_row,
        annotation_col = annotation_col,
        annotation_colors = annotation_colors,
        labels_row = getNiceName(rownames(mtx), 12),
        labels_col = getNiceName(colnames(mtx), 12),
        ...
    ))

    return(invisible(ods))
}


plotAberrantPerSample.OUTRIDER <- function(object, 
                    main='Aberrant Genes per Sample',
                    outlierRatio=0.001, col='Dark2', yadjust=1.2,
                    ylab="Aberrantly expressed genes", 
                    subsetName=NULL, ...){
    oneOffset <- 0.8
    count_vector <- aberrant(object, by="sample", 
                                    subsetName=subsetName, ...)
    testedSamples <- colnames(object)[which(
        colSums(is.na(padj(object, subsetName=subsetName))) != nrow(object))]
    count_vector <- sort(count_vector[testedSamples])
    
    hlines = quantile(count_vector, c(0.5, 0.9))
    hlines[hlines == 0] <- oneOffset
    
    dt2p <- data.table(
            x=seq_along(count_vector),
            y=c(count_vector, c(1, oneOffset)[(count_vector != 0) + 1]),
            fill=!count_vector <= max(1, length(object)*outlierRatio))
    
    if(is.null(subsetName)){
        subtitle <- NULL
    } else{
        subtitle <- paste0("FDR across genes in the ", subsetName, " group")
    }
    
    g <- ggplot(dt2p, aes(x=x, y=y, fill=fill)) + 
        geom_bar(stat = "Identity") + 
        theme_bw() + 
        scale_y_log10(limits=c(oneOffset, NA)) + 
        ylab(ylab) + 
        xlab("Sample rank") + 
        ggtitle(main, subtitle=subtitle) + 
        theme(legend.position="none") + 
        geom_hline(yintercept=hlines) + 
        annotate("text", label=c("Median", "90^th ~ percentile"), 
                x=1, y=hlines*yadjust, hjust=0, parse=TRUE)
    
    if(isScalarCharacter(col)){
        g <- g + scale_fill_brewer(palette=col)
    } else {
        g <- g + scale_fill_manual(values=col)
    }
    
    g
}

#' @rdname plotFunctions
#' @export
setMethod("plotAberrantPerSample", signature="OutriderDataSet", 
        plotAberrantPerSample.OUTRIDER)


#' @rdname plotFunctions
#' @export
plotFPKM <- function(ods, bins=100){
    fpkm <- fpkm(ods)
    colors <- c("grey60","darkgreen")
    if(!'passedFilter' %in% colnames(mcols(ods))){
        message(paste0('To see the difference between the filtering ',
                'run first the filterExpression() function.'))
        passed <- rep(TRUE, nrow(ods))
        colors <- c("darkgreen")
    } else {
        passed <- mcols(ods)[['passedFilter']]
    }

    histdata <- data.table(melt(fpkm, value.name = 'fpkm'),
            'passedFilter'=rep(passed, dim(fpkm)[2]))

    if(any(histdata$fpkm == 0)){
        numZero <- sum(histdata$fpkm == 0)
        message(paste0(numZero, " sample-gene combinations are zero. This is ",
                signif(numZero/nrow(histdata)*100, 3), "% of the data"))
        histdata <- histdata[fpkm != 0]
    }

    p <- ggplot(histdata, aes(fpkm, fill=passedFilter), alpha=0.5) +
        geom_histogram(bins=bins) +
        scale_fill_manual(values=colors) + 
        theme_bw() +
        theme(legend.position = c(0.1, 0.9)) +
        scale_x_log10(labels = trans_format("log10", math_format(10^.x))) +
        labs(x='FPKM', y='Frequency') + 
        ggtitle("FPKM distribution")
    p
}


plotDispEsts.OUTRIDER <- function(object, compareDisp, xlim, ylim,
                    main="Dispersion estimates versus mean expression", ...){
    # validate input
    if(!'theta' %in% names(mcols(object))){
        stop('Fit OUTRIDER first by executing ods <- OUTRIDER(ods) ',
                'or ods <- fit(ods)')
    }
    if(missing(compareDisp)){
        compareDisp <- !is.null(E(object))
    }

    # disp from OUTRIDER
    odsVals <- getDispEstsData(object)
    legText <- c("OUTRIDER fit")
    legCol <- c("firebrick")
    nonAutoVals <- NULL

    if(isTRUE(compareDisp)){
        #fit OUTRIDER without AutoCorrect
        ods2 <- OutriderDataSet(countData = counts(object))
        ods2 <- estimateSizeFactors(ods2)
        ods2 <- fit(ods2)
        nonAutoVals <- getDispEstsData(ods2, odsVals$mu)
    }
    if(missing(xlim)){
        xlim=range(odsVals$xpred)
    }
    if(missing(ylim)){
        ylim=range(1/odsVals$disp)
    }
    # plot dispersion
    plot(NA, xlim=xlim, ylim=ylim, pch='.', log="yx", xlab='Mean expression',
            ylab='Dispersion', main=main)
    if(!is.null(nonAutoVals)){
        points(odsVals$mu, 1/nonAutoVals$disp, pch='.', col="black")
    }
    points(odsVals$mu, 1/odsVals$disp, pch='.', col='firebrick')

    # plot fit
    lines(odsVals$xpred, odsVals$ypred, lwd=2, col="firebrick")
    if(isTRUE(compareDisp)){
        lines(odsVals$xpred, nonAutoVals$ypred, lwd=2, col="black")
        legText <- c("before correction fit", "OUTRIDER fit")
        legCol <- c('black', 'firebrick')
    }

    legend("bottomleft", legText, col=legCol, pch=20, lty=1, lwd=3)
}


#' @rdname plotFunctions
#' @export
setMethod("plotDispEsts", signature(object="OutriderDataSet"),
        plotDispEsts.OUTRIDER)


#' @rdname plotFunctions
#' @export
plotPowerAnalysis <- function(ods){
    dispfit <-getDispEstsData(ods)
    m <- 10^seq.int(0,4,length.out = 1E4)
    d <- 1/dispfit$fit(m)
    dt<-rbindlist(lapply(c(0,0.1,0.2,0.3,0.5, 2,5,10), function(frac)
        data.table(mean=m, disp=d, frac=frac,
                pVal=pmin(0.5, pnbinom(round(frac * m), mu = m, size=d),
                        1 - pnbinom(round(frac * m), mu = m, size=d) +
                                dnbinom(round(frac * m), mu = m, size=d))
        )))

    dt[,negLog10pVal:=-log10(pVal)]
    dt[,Fraction:=as.factor(frac)]
    dt[,ExprType:= ifelse(frac<1, 'Downregulation', 'Overexpression')]
    ggplot(dt, aes(mean, negLog10pVal, col=Fraction, linetype=ExprType)) +
        geom_smooth(method=lm, formula = y ~ bs(x, 10), se = FALSE) +
        scale_x_log10(breaks=c(1,5,10,50,100,500,1000,5000,10000)) +
        labs(x="Mean", y='-log10(P-value)',color='Expression level',
                linetype='Expression type') + ylim(0,15)
}


plotEncDimSearch.OUTRIDER <- function(object){
    if(is(object, 'OutriderDataSet')){
        if(!'encDimTable' %in% colnames(metadata(object)) &
                !is(metadata(object)$encDimTable, 'data.table')){
            stop('Please run the estimateBestQ function before ',
                    'plotting the results of it.')
        }
        dt <- metadata(object)$encDimTable
        opt_q <- getBestQ(object)
    } else {
        dt <- object
        dt <- dt[, opt:=
                encodingDimension[which.max(evaluationLoss)[1]], by=zScore]
        opt_q <- dt[opt == encodingDimension, opt]
    }
    
    if ('oht' %in% colnames(dt)){
      # Singular value plot
      opt_data <- dt[oht==TRUE,]
      
      ggplot(dt, aes(q, singular_values)) + 
        geom_line(color="blue") +
        geom_vline(xintercept = opt_data$q, linetype = "dashed", color = "darkgray") +
        geom_text(data=opt_data, aes(x = q+3, y = singular_values, 
                                     label = q), color = "darkgray", size=4.5) +
        xlab('Singular value rank (Estimated q)') +
        ylab('Singular value') + 
        theme_bw(base_size=16) +
        scale_y_log10() +
        ggtitle('Search for best encoding dimension by OHT')

    } else{
      # AUC plot
      if(!is.data.table(dt)){
          stop('Please provide the encDimTable from the OutriderDataSet object.')
      }
      if(!'zScore' %in% colnames(dt)){
          dt[,zScore:='Optimum']
          dt[,opt:=opt_q]
      }
      dtPlot <- dt[,.(enc=encodingDimension, z=as.character(zScore),
              eva=evaluationLoss, opt)]
      ggplot(dtPlot, aes(enc, eva, col=z)) +
          geom_point() +
          scale_x_log10() +
          geom_smooth(method='loess') +
          ggtitle('Search for best encoding dimension') +
          geom_vline(data=dtPlot[opt == enc], show.legend=TRUE,
                  aes(xintercept=enc, col=z, linetype='Optimum')) +
          geom_text(data=dtPlot[opt == enc], aes(y=0.0, enc-0.5, label=enc)) +
          labs(x='Encoding dimension',
                  y='Evaluation loss', col='Z score', linetype='Best Q') +
          scale_linetype_manual(values="dotted")
    }
}

#' @rdname plotFunctions
#' @export
setMethod("plotEncDimSearch", signature="OutriderDataSet",
        plotEncDimSearch.OUTRIDER)

#' @rdname plotFunctions
#' @export
plotExpressedGenes <- function(ods, main='Statistics of expressed genes'){
    # labels and col names
    exp_genes_cols <- c(
        'sampleID'                         = 'sampleID',
        'Expressed\ngenes'                 = 'expressedGenes',
        'Union of\nexpressed genes'        = 'unionExpressedGenes',
        'Intersection of\nexpressed genes' = 'intersectionExpressedGenes',
        'Genes passed\nfiltering'          = 'passedFilterGenes',
        'Rank'                             = 'expressedGenesRank')

    # validate input
    if(!all(exp_genes_cols %in% names(colData(ods)))){
        stop('Compute expressed genes first by executing \n\tods <- ',
                'filterExpression(ods, addExpressedGenes=TRUE)')
    }

    dt <- as.data.table(colData(ods)[, exp_genes_cols])
    colnames(dt) <- names(exp_genes_cols)
    melt_dt <- melt(dt, id.vars = c('sampleID', 'Rank'))

    ggplot(melt_dt, aes(Rank, value)) +
        geom_point(aes(col = variable), size=1) +
        geom_line(aes(col = variable)) +
        theme_bw(base_size = 14) +
        ylim(0, NA) +
        theme(legend.position = 'top', legend.title = element_blank()) +
        labs(y = 'Number of genes', x = 'Sample rank', title = main) +
        scale_color_brewer(palette = 'Set1')
}

#' @rdname plotFunctions
#' @export
plotSizeFactors <- function(ods, basePlot=TRUE){
    checkSizeFactors(ods)
    plotdt <- data.table(sizeFactor=sizeFactors(ods),
            sampleID=colnames(ods))[order(sizeFactor)][,.(
                    sizeFactor, sampleID, rank=.I)]
    g <- ggplot(plotdt, aes(rank, sizeFactor, text=paste0(
        "SampleID: ", sampleID, "<br>",
        "Sizefactor: ", round(sizeFactor, 3), "<br>",
        "Rank: ", rank))) +
        geom_point() +
        theme_bw() +
        xlab("Sample rank") + 
        ggtitle("Size factor plot")
    
    if(isFALSE(basePlot)){
        g <- ggplotly(g, tooltip="text")
    }
    g
}


checkDeprication <- function(names2check, ...){
    lnames <- names(list(...))
    for(i in seq_along(names2check)){
        if(!names2check[i] %in% lnames){
            next
        }
        warning("We changed the API for the given parameter.\n",
                "  Please switch to the new parameter:\n",
                "\t'", names2check[i], "' --> '", names(names2check[i]), "'")
    }
}

plotManhattan.OUTRIDER <- function(object, sampleID, value="pvalue", 
                                   chr=NULL, main=paste0("Sample: ", sampleID),
                                   featureRanges=rowRanges(object), 
                                   subsetName=NULL,
                                   chrColor = c("black", "darkgrey"),
                                   padjCutoff = 0.05,
                                   zScoreCutoff=0,
                                   highlight.label.size = 5
                                  ){
    requireNamespace("ggbio")
    requireNamespace("GenomeInfoDb")
    
    # check user input
    checkOutriderDataSet(object)
    stopifnot("Sample not in ods" = sampleID %in% colnames(object))
    stopifnot("Value should be either pvalue, zscore or l2fc" = 
                  value %in% c('pvalue', 'pValue', 'pv', 'zscore', 'zScore', 
                               'l2fc', 'L2FC', 'log2fc'))
    
    # get granges from rowRanges(ods) or provided ranges, check dimension
    if(is.null(featureRanges)){
        if(is.null(rowRanges(object))){
            stop("No rowRanges(ods) found. Assign them first to use ", 
                    "this function or provide a GRanges object.")
        }
    } else if(length(featureRanges) != nrow(object)){
        stop("The provided feature ranges must be of the same length as the ", 
                "ods object.")
    } else if(is(featureRanges, "GRanges")){
        gr <- featureRanges
    } else if(is(featureRanges, "GRangesList")){
        gr <- unlist(endoapply(featureRanges, range)) 
        # faster than range but gives error for empty GRangesList:
        # gr <- unlist(endoapply(featureRanges, function(rr) rr[1,]))
        if(length(gr) != nrow(object)){
            stop("The provided gene ranges do not contain ranges for all rows ",
                 "of the ods object")
        }
    } else{
        stop("The provided feature_ranges must a a GRanges or GRangesList ",
                "object.")
    }
    
    GenomeInfoDb::seqlevelsStyle(gr) <- 'NCBI'

    # Add values to granges
    if(value %in% c('pvalue', 'pValue', 'pv')){
        gr$value <- -log10(pValue(object)[, sampleID])
        # value <- '-log10(pvalue)'
        value <- expression(paste(-log[10], "(P-value)"))
    }
    if(value %in% c('zscore', 'zScore')){
        gr$value <- zScore(object)[, sampleID]
    }
    if(value %in% c('l2fc', 'L2FC', 'log2fc')){
        if(!"l2fc" %in% assayNames(object)){
            stop("Please compute the log2 fold changes first before ",
                 "retrieving them.")
        }
        gr$value <- assay(object, "l2fc")[, sampleID]
        value <- expression(paste(log[2], "(fold-change)"))
    }
    gr$aberrant <- aberrant(object, subsetName=subsetName,
                            padjCutoff=padjCutoff, zScoreCutoff=zScoreCutoff)[,sampleID]
    
    # Sort granges for plot
    gr <- GenomeInfoDb::sortSeqlevels(gr)
    gr <- sort(gr)
    
    # subset to chromosomes in chrSubset if requested
    if(!is.null(chr)){
        # check input
        if(any(grepl("chr", chr))){
            chr <- gsub("chr", "", chr)
        }
        if(!all(chr %in% unique(GenomeInfoDb::seqnames(gr)))){
            stop("Not all chromosomes selected for subsetting are present ",
                 "in the GRanges object.")
        }
        
        # subset
        gr <- gr[as.character(GenomeInfoDb::seqnames(gr)) %in% chr]
        
        # add chr to plot title if only one chr given
        if(length(chr) == 1){
            main <- paste0(main, "; ", 
                            paste("chr", chr, collapse=", ", sep=""))
        }
    }
    if(is.null(subsetName)){
        subtitle <- NULL
    } else{
        subtitle <- paste0("FDR across genes in the ", subsetName, " group")
    }
    
    p <- plotGrandLinear.adapted(gr, aes(y = value), 
                         color = chrColor, 
                         highlight.gr = gr[which(gr$aberrant == TRUE)], 
                         highlight.col = 'firebrick',
                         highlight.overlap = 'equal',
                         highlight.label.size = highlight.label.size,
                         use.genome.coords=is.null(chr)) +
        labs(x="Chromosome", y = value, title=main, subtitle=subtitle)
    
    return(p)
}

#' @rdname plotFunctions
#' @export
setMethod("plotManhattan", signature="OutriderDataSet", 
          plotManhattan.OUTRIDER)

#'
#' Adapted function from ggbio package to create manhattan plot. 
#' Adapted to allow manhattan plots creation for a subset of chromomes only, 
#' as well as highlighting only ranges that exactly match. Uses functions 
#' from package biovizBase.
#'
#' @noRd
plotGrandLinear.adapted <- function (obj, ..., facets, space.skip = 0.01, 
        geom = NULL, cutoff = NULL, cutoff.color = "red", cutoff.size = 1, 
        legend = FALSE, xlim, ylim, xlab, ylab, main, highlight.gr = NULL, 
        highlight.name = NULL, highlight.col = "red", highlight.label = TRUE, 
        highlight.label.size = 5, highlight.label.offset = 0.05, 
        highlight.label.col = "black", 
        highlight.overlap = c("any", "start", "end", "within", "equal"),
        spaceline = FALSE,
        use.genome.coords=TRUE){
    requireNamespace("biovizBase")
    if (is.null(geom)) 
        geom <- "point"
    args <- list(...)
    args.aes <- biovizBase::parseArgsForAes(args)
    args.non <- biovizBase::parseArgsForNonAes(args)
    two.color <- c("#0080FF", "#4CC4FF")
    .is.seq <- FALSE
    if (!"colour" %in% names(args.aes)) {
        if (!any(c("color", "colour") %in% names(args.non))) {
            .color <- two.color
            args.aes$color <- as.name("seqnames")
            .is.seq <- TRUE
        }
        else {
            if (length(args.non$color) > 1) {
                .color <- args.non$color
                args.aes$color <- as.name("seqnames")
                .is.seq <- TRUE
                args.non <- args.non[!names(args.non) %in% c("colour", 
                                                            "color")]
            }
        }
    }
    else {
        if (quo_name(args.aes$colour) == "seqnames") 
            args.aes$colour <- as.name("seqnames")
    }
    if (!"y" %in% names(args.aes)) 
        stop("need to provide y")
    if(isTRUE(use.genome.coords)){
        args.non$coord <- "genome"
    }
    args.non$space.skip <- space.skip
    args.non$geom <- geom
    args.non$object <- obj
    aes.res <- do.call(aes, args.aes)
    p <- do.call(ggbio::autoplot, c(list(aes.res), args.non))
    if (!legend) 
        p <- p + theme(legend.position = "none")
    if (!missing(ylab)) 
        p <- p + ylab(ylab)
    if (!is.null(cutoff)) 
        p <- p + geom_hline(yintercept = cutoff, color = cutoff.color, 
                            size = cutoff.size)
    chrs <- names(GenomeInfoDb::seqlengths(obj))
    if (.is.seq) {
        N <- length(chrs)
        cols <- rep(.color, round(N/length(.color)) + 1)[1:N]
        names(cols) <- chrs
        p <- p + scale_color_manual(values = cols)
    }
    if (!missing(facets)) {
        args$facets <- facets
        args.facets <- biovizBase::subsetArgsByFormals(args, facet_grid, 
                                                        facet_wrap)
        facet <- ggbio:::.buildFacetsFromArgs(obj, args.facets)
        p <- p + facet
    }
    p <- p + theme(panel.grid.minor = element_blank())
    if (!is.null(highlight.gr)) {
        highlight.overlap <- match.arg(highlight.overlap)
        idx <- findOverlaps(obj, highlight.gr, type=highlight.overlap)
        .h.pos <- lapply(split(queryHits(idx), subjectHits(idx)), function(id) {
            gr <- GRanges(as.character(GenomeInfoDb::seqnames(p@data))[id][1], 
                IRanges(start = min(start(p@data[id])), 
                        end = max(end(p@data[id]))))
                val <- max(as.numeric(values(p@data[id])[, quo_name(args.aes$y)]))
                val <- val * (1 + highlight.label.offset)
                values(gr)$val <- val
                gr
            })
        .h.pos <- suppressWarnings(do.call("c", unname(.h.pos)))
        if (length(.h.pos)) {
            if (is.null(highlight.name)) {
                highlight.name <- names(highlight.gr)
            }
            else {
                highlight.name <- values(highlight.gr)[, highlight.name]
            }
            p <- p + geom_point(data = biovizBase::mold(p@data[queryHits(idx)]), 
                    do.call(aes, list(x = substitute(midpoint), y = args.aes$y)), 
                    color = highlight.col)
            if (!is.null(highlight.name)) {
                GenomeInfoDb::seqlevels(.h.pos, pruning.mode = "coarse") <- 
                    GenomeInfoDb::seqlevels(obj)
                suppressWarnings(GenomeInfoDb::seqinfo(.h.pos) <- 
                                    GenomeInfoDb::seqinfo(obj))
                .trans <- biovizBase::transformToGenome(.h.pos, space.skip = space.skip)
                values(.trans)$mean <- (start(.trans) + end(.trans))/2
                values(.trans)$names <- highlight.name
                p <- p + geom_text(data = biovizBase::mold(.trans), 
                            size = highlight.label.size, 
                            vjust = 0, color = highlight.label.col, 
                            do.call(aes, 
                                list(x = substitute(mean), y = as.name("val"), 
                                label = as.name("names"))))
            }
        }
    }
    if (spaceline) {
        vline.df <- p@ggplot$data
        vline.df <- do.call(rbind, by(vline.df, vline.df$seqnames, 
                function(dd) {
                    data.frame(start = min(dd$start), end = max(dd$end))
                }))
        gap <- (vline.df$start[-1] + vline.df$end[-nrow(vline.df)])/2
        p <- p + geom_vline(xintercept = gap, alpha = 0.5, color = "gray70") + 
            theme(panel.grid = element_blank())
    }
    if (!missing(main)) 
        p <- p + labs(title = main)
    if (!missing(xlim)) 
        p <- p + xlim(xlim)
    if (!missing(ylim)) 
        p <- p + ylim(ylim)
    if (missing(xlab)) 
        xlab <- ""
    p <- p + ggplot2::xlab(xlab)
    p
}

context("Testing plot functions: ")

test_that("plotting", {
    set.seed(42)
    ods <- makeExampleOutriderDataSet(n=40, m=40)
    
    mcols(ods)[['basepairs']] <- rnbinom(nrow(ods), mu=1e4, size=2)
    ods <- filterExpression(ods, filterGenes=FALSE, fpkmCutoff=1e3)
    genesOfInterest <- list("sample_1"=sample(rownames(ods), 10),
                            "sample_3"=sample(rownames(ods), 8),
                            "sample_10"=sample(rownames(ods), 20))
    ods <- OUTRIDER(ods, implementation='pca', q=2, 
                    subsets=list("testSet"=genesOfInterest))
    sex <- sample(c("female", "male"), dim(ods)[2], replace=TRUE)
    colData(ods)$Sex <- sex
    
    
    expect_is(plotAberrantPerSample(ods), "ggplot")
    expect_is(plotAberrantPerSample(ods, subsetName="testSet"), "ggplot")
    
    expect_equal(class(plotVolcano(ods, 30)), c("plotly", "htmlwidget"))
    expect_is(plotVolcano(ods, "sample_10", basePlot=TRUE), "ggplot")
    expect_is(plotVolcano(ods, "sample_10", subsetName="testSet", 
                            basePlot=TRUE), "ggplot")
    expect_is(plotVolcano(ods, "sample_10", label="feature_3", basePlot=TRUE), 
                "ggplot")
    
    
    expect_equal(class(plotExpressionRank(ods, 23)), c("plotly", "htmlwidget"))
    expect_is(plotExpressionRank(ods, "feature_13", normalized=FALSE,
            log=FALSE, basePlot=TRUE), 'ggplot')
    expect_is(plotExpressionRank(ods, "feature_13", normalized=TRUE,
                                 subsetName="testSet", basePlot=TRUE), 'ggplot')
    expect_is(plotExpressionRank(ods, "feature_13", normalized=FALSE,
                                 label=c("sample_1", "sample_5"),
                                 log=FALSE, basePlot=TRUE), 'ggplot')
    
    
    expect_equal(class(plotExpectedVsObservedCounts(ods, 39)), 
            c("plotly", "htmlwidget"))
    expect_is(plotExpectedVsObservedCounts(ods, "feature_32", basePlot=TRUE),
            "ggplot")
    expect_is(plotExpectedVsObservedCounts(ods, "feature_32", 
                                subsetName="testSet", basePlot=TRUE), "ggplot")
    expect_is(plotExpectedVsObservedCounts(ods, "feature_32", label="aberrant",
                                           basePlot=TRUE), "ggplot")
    
    
    expect_is(plotExpressedGenes(ods), "ggplot")
    
    expect_null(plotQQ(ods, 1))
    expect_null(plotQQ(ods, "feature_20"))
    expect_null(plotQQ(ods, "feature_20", subsetName="testSet"))
    expect_null(plotQQ(ods, global=TRUE))
    expect_null(plotQQ(ods, global=TRUE, outlierRatio=0.001))
    expect_null(plotQQ(ods, global=TRUE, outlierRatio=NULL))
    
    
    expect_is(plotCountCorHeatmap(ods, colGroup="Sex", basePlot=FALSE),
            'plotly')
    ods <- plotCountCorHeatmap(ods)
    expect_invisible(plotCountCorHeatmap(ods, colGroup="Sex", normalized=FALSE))
    expect_invisible(plotCountCorHeatmap(ods, rowGroup="sampleID"))
    expect_true("clusterNumber_4" %in% colnames(colData(ods)))
    expect_is(ods, "OutriderDataSet")
    
    
    expect_invisible(
            plotCountGeneSampleHeatmap(ods, normalized=FALSE, bcvQuantile=0.5))
    expect_invisible(plotCountGeneSampleHeatmap(ods, rowGroups="theta", 
            rowColSet=list(c("white", "darkgreen"))))
    
    pass <- mcols(ods)$passedFilter
    # don't use mcols(ods)$XXX <- NULL since this is broken in R < 3.5
    mcols(ods) <- mcols(ods)[,!colnames(mcols(ods)) %in% "passedFilter"]
    expect_message(plotFPKM(ods), "To see the difference .*")
    mcols(ods)[,'passedFilter'] <- pass
    expect_is(plotFPKM(ods), 'ggplot')
    
    
    plotPowerAnalysis(ods)
    
    expect_error(plotManhattan(ods, "sample_1"))
    gr <- GRanges(
            seqnames=sample(paste0("chr", 1:22), nrow(ods), replace=TRUE),
            ranges=IRanges(start=runif(nrow(ods), min=0, max=1e5), width=100))
    expect_is(plotManhattan(ods, "sample_1", featureRanges=gr), "GGbio")
    expect_is(plotManhattan(ods, "sample_1", featureRanges=gr, chr=10), "GGbio")
    expect_is(plotManhattan(ods, "sample_26", featureRanges=gr, 
                            subsetName="testSet"), "GGbio")
    
})

context("Testing filtering: ")

test_that("Expression filtering", {
    library(TxDb.Hsapiens.UCSC.hg19.knownGene)
    library(org.Hs.eg.db)
    txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
    #map <- select(org.Hs.eg.db, keys=keys(txdb, keytype = "GENEID"), 
    #              keytype="ENTREZID", columns=c("SYMBOL"))
    
    ods <- makeExampleOutriderDataSet(dataset='KremerNBader')
    
    expect_error(filterExpression(ods), 
            'rowRanges\\(object\\) has all ranges of.* FPKM values')
    
    expect_warning(filterExpression(ods, gtfFile=txdb), 
            'Some genes \\(n=(770|999|783)\\) are not found')
    
    #expect_warning(filterExpression(ods, gtfFile=txdb, mapping=map, save=TRUE), 
    #        'Some genes \\(n=(17[72]|93|91)\\) are not found')
    
    ods <- filterExpression(ods, gtfFile=txdb, addExpressedGenes=TRUE)
    
    expect_true(all(
        c('expressedGenes', 'unionExpressedGenes', 'intersectionExpressedGenes',
          'passedFilterGenes', 'expressedGenesRank', 'sampleID') 
        %in% colnames(colData(ods))
        )
    )
    # Test plotting
    expect_is(plotExpressedGenes(ods), 'ggplot')    
    
})

#'
#' Checks the count requirements so it has enough counts per gene and sample
#' 
#' @noRd
checkCountRequirements <- function(ods, test=FALSE){
    checkOutriderDataSet(ods)
    if(ncol(ods) == 0){
        stop("Please provide at least one sample.")
    }
    if(nrow(ods) == 0){
        stop("Please provide at least one gene.")
    }
    filterGenes <- rowSums(counts(ods)) == 0
    if(any(filterGenes) & isFALSE(test)){
        stop("There are genes without any read. Please filter first ",
                "the data with: ods <- filterExpression(ods)")
    }
    # Filter out genes that have on average less than 1 count per 100 samples.
    # Ony affects datasets with more than 100 samples.
    filterGenes <- filterGenes | rowSums(counts(ods)) < ncol(ods)/100
    if(any(filterGenes) & isFALSE(test)){
        stop("The model requires for each gene at least 1 read ", 
                "in every 100 sample. Please filter first the data with: ",
                "ods <- filterExpression(ods)")
    }
    return(invisible(filterGenes))
}

#' 
#' Checks that is is an OutriderDataSet object
#' @noRd
checkOutriderDataSet <- function(ods){
    if(!is(ods, 'OutriderDataSet')){
        stop('Please provide an OutriderDataSet.')
    }
    return(invisible(TRUE))
}

#' 
#' Checks that the object contains sizeFactors
#' @noRd
checkSizeFactors <- function(ods, funName=sys.calls()[[1]]){
    checkOutriderDataSet(ods)
    if(is.null(sizeFactors(ods))){
        stop("Please calculate the size factors before calling the '", funName,
                "' function. Please do: ods <- estimateSizeFactors(ods)")
    }
    return(invisible(TRUE))
}

#' 
#' Checks if the final padjust and zscore values are present
#' @noRd
checkFullAnalysis <- function(ods, funName=sys.calls()[[1]]){
    checkSizeFactors(ods)
    if(!'padjust' %in% assayNames(ods)){
        stop("Please calculate the P-values before calling the '", funName,
                "' function. Please do: ods <- computePvalues(ods)")
    }
    if(!'zScore' %in% assayNames(ods)){
        stop("Please calculate the Z-scores before calling the '", funName,
                "' function. Please do: ods <- computeZscores(ods)")
    }
    return(invisible(TRUE))
}

#' 
#' Checks if the provided thetaRange is correct
#' @noRd
checkThetaRange <- function(thetaRange){
    if(length(thetaRange) != 2){
        stop('Please provide a range for thetaRange (eg: `c(0.1, 250)`).')
    }
    if(!all(is.finite(thetaRange))){
        stop('Please provide finite values for the theta range.')
    }
    if(thetaRange[1] > thetaRange[2]){
        stop('The first element of the range has to be smaller', 
                ' than the second one.')
    }
    return(invisible(TRUE))
}

context("Testing helper functions")

test_that("check ODS object", {
    ods <- makeExampleOutriderDataSet(10,10)
    expect_error(checkOutriderDataSet("a"), "Please provide an OutriderData")
    expect_true(checkOutriderDataSet(ods))
    
    expect_error(checkFullAnalysis(ods), "Please calculate the size factors")
    ods <- estimateSizeFactors(ods)
    
    expect_error(checkFullAnalysis(ods), "Please calculate the P-values before")
    padj(ods) <- matrix(runif(ncol(ods)*nrow(ods)), 
            ncol=ncol(ods), dimnames=dimnames(ods))
    
    expect_error(checkFullAnalysis(ods), "Please calculate the Z-scores before")
    zScore(ods) <- matrix(runif(ncol(ods)*nrow(ods)), 
            ncol=ncol(ods), dimnames=dimnames(ods))
    
    expect_true(checkFullAnalysis(ods))
})

test_that("check theta range", {
    expect_error(checkThetaRange("aaa"), "Please provide a range for theta")
    expect_error(checkThetaRange(c(NA,1)), "Please provide finite values")
    expect_error(checkThetaRange(c(2,1)), "The first element of the range")
    expect_true(checkThetaRange(c(1,2)))
})

test_that("check requirements", {
    ods <- makeExampleOutriderDataSet(10, 150)
    expect_error(checkCountRequirements(ods[,FALSE]), "Please pro.*one sample.")
    expect_error(checkCountRequirements(ods[FALSE,]), "Please pro.*one gene.")
    
    counts(ods)[1,] <- 0
    expect_error(checkCountRequirements(ods), "There are genes without any re")
    counts(ods)[1,1] <- 1
    expect_error(checkCountRequirements(ods), "The model requires for each")
    counts(ods)[1,2] <- 1
    expect_true(!any(checkCountRequirements(ods)))
})

test_that("check sample exclusion", {
    ods <- SummarizedExperiment(assays=SimpleList(
            a=matrix(1, nrow=16, ncol=11)))
    expect_false(all(sampleExclusionMask(ods)))
    expect_equal(length(sampleExclusionMask(ods)), 11)
    expect_is(sampleExclusionMask(ods, aeMatrix=TRUE), "matrix")
    expect_equal(dim(sampleExclusionMask(ods, aeMatrix=TRUE)), c(16, 11))
    
    vec <- c(logical(5), TRUE, TRUE, logical(4))
    mat <- do.call(rbind, rep(list((!vec) + 0), 16))
    
    sampleExclusionMask(ods) <- vec
    expect_equal(sampleExclusionMask(ods), vec)
    expect_equal(sampleExclusionMask(ods, aeMatrix=TRUE), mat)
})

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

predictMatY <- function(x, E, D, b) {
    .Call('_OUTRIDER_predictMatY', PACKAGE = 'OUTRIDER', x, E, D, b)
}

predictMatC <- function(x, E, D, b, sf) {
    .Call('_OUTRIDER_predictMatC', PACKAGE = 'OUTRIDER', x, E, D, b, sf)
}

truncLogLiklihoodD <- function(par, H, k, sf, exclusionMask, theta, thetaC) {
    .Call('_OUTRIDER_truncLogLiklihoodD', PACKAGE = 'OUTRIDER', par, H, k, sf, exclusionMask, theta, thetaC)
}

gradientD <- function(par, H, k, sf, exclusionMask, theta, thetaC) {
    .Call('_OUTRIDER_gradientD', PACKAGE = 'OUTRIDER', par, H, k, sf, exclusionMask, theta, thetaC)
}

truncLogLiklihoodE <- function(e, D, k, b, x, sf, theta, exclusionMask, thetaC) {
    .Call('_OUTRIDER_truncLogLiklihoodE', PACKAGE = 'OUTRIDER', e, D, k, b, x, sf, theta, exclusionMask, thetaC)
}

gradientE <- function(e, D, k, b, x, sf, theta, exclusionMask, thetaC) {
    .Call('_OUTRIDER_gradientE', PACKAGE = 'OUTRIDER', e, D, k, b, x, sf, theta, exclusionMask, thetaC)
}

## ----style-knitr, eval=TRUE, echo=FALSE, cache=FALSE, results="asis"-------
BiocStyle::latex()

## ----knitr, echo=FALSE, cache=FALSE, results="hide"------------------------
library(knitr)
opts_chunk$set(
    tidy=FALSE,
    dev="png",
    fig.width=7,
    fig.height=7,
    dpi=300,
    message=FALSE,
    warning=FALSE,
    cache=TRUE
)

## ----include=FALSE---------------------------------------------------------
opts_chunk$set(concordance=TRUE)

## ----hiden_config, echo=FALSE----------------------------------------------
suppressPackageStartupMessages({
    library(OUTRIDER)
    library(beeswarm)
})
if(!is(bpparam(), "SerialParam")){
    bp <- bpparam()
    bpworkers(bp) <- min(4, bpworkers(bp))
    register(bp)
}

## ----deVsOutlier, echo=FALSE, fig.height=5, fig.cap="Scheme of workflow differences. Differences between differential gene expression analysis and outlier detection."----
par.old <- par(no.readonly=TRUE)
par(mfrow=c(1,2), cex=1.2)
ylim <- c(80, 310)
a <- rnorm(10, 250, 10)
b <- rnorm(10, 120, 10)
c <- rnorm(100, 250, 20)
c[1] <- 105
beeswarm(list(A=a, B=b), 
        main="Differential\nexpression analysis\n(DESeq2/edgeR)",
        xlab="Condition", ylab="Expression", ylim=ylim, pch=20, 
        col=c("darkblue", "firebrick"))
beeswarm(c, main="Outlier\ndetection\n(OUTRIDER)", ylim=ylim, pch=20, 
        xlab="Population", ylab="Expression", col="firebrick")

par(par.old)

## ----quick_guide, fig.height=5---------------------------------------------
library(OUTRIDER)

# get data
ctsFile <- system.file('extdata', 'KremerNBaderSmall.tsv', 
        package='OUTRIDER')
ctsTable <- read.table(ctsFile, check.names=FALSE)
ods <- OutriderDataSet(countData=ctsTable)

# filter out non expressed genes
ods <- filterExpression(ods, minCounts=TRUE, filterGenes=TRUE)

# run full OUTRIDER pipeline (control, fit model, calculate P-values)
ods <- OUTRIDER(ods)

# results (only significant)
res <- results(ods)
head(res)

# example of a Q-Q plot for the most significant outlier
plotQQ(ods, res[1, geneID])

## ----GetDataSet------------------------------------------------------------
# small testing data set
odsSmall <- makeExampleOutriderDataSet(dataset="Kremer")

# full data set from Kremer et al.
baseURL <- paste0("https://static-content.springer.com/esm/", 
        "art%3A10.1038%2Fncomms15824/MediaObjects/")
count_URL <- paste0(baseURL, "41467_2017_BFncomms15824_MOESM390_ESM.txt")
anno_URL  <- paste0(baseURL, "41467_2017_BFncomms15824_MOESM397_ESM.txt")

ctsTable <- read.table(count_URL, sep="\t")
annoTable <- read.table(anno_URL, sep="\t", header=TRUE)
annoTable$sampleID <- annoTable$RNA_ID

# create OutriderDataSet object
ods <- OutriderDataSet(countData=ctsTable, colData=annoTable)

## ----Preprocessing, fig.height=5-------------------------------------------
# get annotation
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
map <- select(org.Hs.eg.db, keys=keys(txdb, keytype = "GENEID"), 
        keytype="ENTREZID", columns=c("SYMBOL"))

## ----create txdb, eval=FALSE-----------------------------------------------
# try({
#     library(RMariaDB)
#     library(AnnotationDbi)
#     con <- dbConnect(MariaDB(), host='genome-mysql.cse.ucsc.edu',
#             dbname="hg19", user='genome')
#     map <- dbGetQuery(con, 'select kgId AS TXNAME, geneSymbol from kgXref')
# 
#     txdbUrl <- paste0("https://cmm.in.tum.de/public/",
#             "paper/mitoMultiOmics/ucsc.knownGenes.db")
#     download.file(txdbUrl, "ucsc.knownGenes.db")
#     txdb <- loadDb("ucsc.knownGenes.db")
# 
# })

## ----filtering, fig.height=5-----------------------------------------------
# calculate FPKM values and label not expressed genes
ods <- filterExpression(ods, txdb, mapping=map, 
        filterGenes=FALSE, savefpkm=TRUE)

# display the FPKM distribution of counts.
plotFPKM(ods)

# display gene filter summary statistics 
plotExpressedGenes(ods)

# do the actual subsetting based on the filtering labels
ods <- ods[mcols(ods)$passedFilter,]

## ----plotting_between_sample_correlations----------------------------------

# Heatmap of the sample correlation
# it can also annotate the clusters resulting from the dendrogram
ods <- plotCountCorHeatmap(ods, colGroups=c("SEX", "RNA_HOX_GROUP"),
        normalized=FALSE, nRowCluster=4)

# Heatmap of the gene/sample expression
ods <- plotCountGeneSampleHeatmap(ods, colGroups=c("SEX", "RNA_HOX_GROUP"),
        normalized=FALSE, nRowCluster=4)


## ----controlling_for_confounders-------------------------------------------

# automatically control for confounders
# we use only 3 iterations to make the vignette faster. The default is 15. 
ods <- estimateSizeFactors(ods)
ods <- controlForConfounders(ods, q=21, iterations=3)

# Heatmap of the sample correlation after controlling
ods <- plotCountCorHeatmap(ods, normalized=TRUE, 
        colGroups=c("SEX", "RNA_HOX_GROUP"))


## ----estimateBestQ, eval=FALSE---------------------------------------------
# # Optimal Hard Thresholding (default)
# ods <- estimateBestQ(ods)
# 
# # Hyperparameter Optimization
# ods <- estimateBestQ(ods, useOHT=FALSE)
# 
# # visualize the estimation of the optimal encoding dimension
# plotEncDimSearch(ods)
# 

## ----maskSamples-----------------------------------------------------------

# set exclusion mask
sampleExclusionMask(ods) <- FALSE
sampleExclusionMask(ods[,"MUC1365"]) <- TRUE

# check which samples are excluded from the autoencoder fit
sampleExclusionMask(ods)


## ----fitting, eval=FALSE---------------------------------------------------
# 
# # fit the model when alternative methods where used in the control step
# ods <- fit(ods)
# hist(theta(ods))
# 

## ----pValue_computation----------------------------------------------------
# compute P-values (nominal and adjusted)
ods <- computePvalues(ods, alternative="two.sided", method="BY")

## ----zScore_computation----------------------------------------------------
# compute the Z-scores
ods <- computeZscores(ods)

## ----results fun-----------------------------------------------------------
# get results (default only significant, padj < 0.05)
res <- results(ods)
head(res)
dim(res)

# setting a different significance level and filtering by Z-scores
res <- results(ods, padjCutoff=0.1, zScoreCutoff=2)
head(res)
dim(res)

## ----aberrantperSample, fig.height=5---------------------------------------
# number of aberrant genes per sample
tail(sort(aberrant(ods, by="sample")))
tail(sort(aberrant(ods, by="gene", zScoreCutoff=1)))

# plot the aberrant events per sample
plotAberrantPerSample(ods, padjCutoff=0.05)

## ----volcano, fig.height=5-------------------------------------------------
# MUC1344 is a diagnosed sample from Kremer et al.
plotVolcano(ods, "MUC1344", basePlot=TRUE)

## ----visualization2, fig.height=5------------------------------------------
# expression rank of a gene with outlier events
plotExpressionRank(ods, "TIMMDC1", basePlot=TRUE)

## ----visualization3, fig.height=5------------------------------------------
## QQ-plot for a given gene
plotQQ(ods, "TIMMDC1")

## ----visualization4, fig.height=5------------------------------------------
## Observed versus expected gene expression
plotExpectedVsObservedCounts(ods, "TIMMDC1", basePlot=TRUE)

## ----peer_function, eval=FALSE---------------------------------------------
# #'
# #' PEER implementation
# #'
# peer <- function(ods, maxFactors=NA, maxItr=1000){
# 
#     # check for PEER
#     if(!require(peer)){
#         stop("Please install the 'peer' package from GitHub to use this ",
#                 "functionality.")
#     }
# 
#     # default and recommendation by PEER: min(0.25*n, 100)
#     if(is.na(maxFactors)){
#         maxFactors <- min(as.integer(0.25* ncol(ods)), 100)
#     }
# 
#     # log counts
#     logCts <- log2(t(t(counts(ods)+1)/sizeFactors(ods)))
# 
#     # prepare PEER model
#     model <- PEER()
#     PEER_setNmax_iterations(model, maxItr)
#     PEER_setNk(model, maxFactors)
#     PEER_setPhenoMean(model, logCts)
#     PEER_setAdd_mean(model, TRUE)
# 
#     # run fullpeer pipeline
#     PEER_update(model)
# 
#     # extract PEER data
#     peerResiduals <- PEER_getResiduals(model)
#     peerMean <- t(t(2^(logCts - peerResiduals)) * sizeFactors(ods))
# 
#     # save model in object
#     normalizationFactors(ods) <- pmax(peerMean, 1E-8)
#     metadata(ods)[["PEER_model"]] <- list(
#             alpha     = PEER_getAlpha(model),
#             residuals = PEER_getResiduals(model),
#             W         = PEER_getW(model))
# 
#     return(ods)
# }

## ----how to run peer, eval=FALSE-------------------------------------------
# # Control for confounders with PEER
# ods <- estimateSizeFactors(ods)
# ods <- peer(ods)
# ods <- fit(ods)
# ods <- computeZscores(ods, peerResiduals=TRUE)
# ods <- computePvalues(ods)
# 
# # Heatmap of the sample correlation after controlling
# ods <- plotCountCorHeatmap(ods, normalized=TRUE)

## ----visualizationSigLevels, fig.height=5----------------------------------
## P-values versus Mean Count
plotPowerAnalysis(ods)

## ----sessionInfo, echo=FALSE-----------------------------------------------
sessionInfo()

#' 
#' Method of moments for theta calculations
#' 
#' Have a look for more details at 
#' \code{\link[DESeq2]{robustMethodOfMomentsDisp}}
#'
#
#' This function is adapted from the DESeq2:::trimmedCellVariance
#' to only one factor. This reduces some computation
#'   
#' @noRd
robustMethodOfMomentsOfTheta <- function(cts, maxTheta, minTheta, minMu=0.01){
    
    mue <- apply(cts, 1, mean, trim=1/8)
    mue <- pmax(mue, minMu)
    se <- (cts - mue)^2
    see <- apply(se, 1, mean, trim=1/8)
    ve <- 1.51*see
    
    theta <- mue^2/(ve-mue)
    
    theta[theta < 0] <- maxTheta
    theta <- pmax(minTheta, pmin(maxTheta, theta))
    return(theta)
}

#' 
#' OutriderDataSet class and constructors 
#' 
#' The OutriderDataSet class is designed to store the whole 
#' OUTRIDER data set needed for an analysis. It is a subclass of 
#' \code{RangedSummarizedExperiment}. All calculated values and results are 
#' stored as assays or as annotation in the mcols structure provided by the
#' \code{RangedSummarizedExperiment} class.
#' 
#' @param se A RangedSummarizedExperiment object or any object which inherits
#'             from it and contains a count matrix as the first element in the
#'             assay list.
#' @param countData A simple count matrix. If dim names are provided, they have
#'             to be unique. This is only used if no \code{se} object is
#'             provided.
#' @param colData Additional to the count data a \code{DataFrame} can be 
#'             provided to annotate the samples. 
#' @param ... Further arguments can be passed to
#'             \code{\link[DESeq2]{DESeqDataSet}}, which is used to parse the
#'             user input and create the initial 
#'             \code{RangedSummarizedExperiment} object. 
#' @return An OutriderDataSet object.
#' 
#' @author Christian Mertes \email{mertes@@in.tum.de}, 
#'             Felix Brechtmann \email{brechtma@@in.tum.de}
#' 
#' @rdname OutriderDataSet-class
#' 
#' @examples
#' 
#' ods <- makeExampleOutriderDataSet()
#' ods
#' 
#' ods <- makeExampleOutriderDataSet(dataset="Kremer")
#' ods
#'    
setClass("OutriderDataSet", contains="RangedSummarizedExperiment")

#' check sample annotation within the colData slot of the SE object
#' @noRd
validateCounts <- function(object) {
    if(!"counts" %in% assayNames(object)){
        return("No counts are detected. Please provide a count matrix.")
    }
    if(!is.integer(assay(object, "counts"))){
        return("Please provide an integer count table.")
    }
    NULL
}

checkNames <- function(object){
    n <- rownames(object)
    if(is.null(n) | any(duplicated(n))){
        return("Please provide unique rownames.")
    }
    n <- colnames(object)
    if(is.null(n) | any(duplicated(n))){
        return("Please provide unique colnames.")
    }
    cold <- colData(object) 
    if(!"sampleID" %in% colnames(cold) | any(duplicated(cold[,"sampleID"]))){
        return("Please provide unique sampleIDs in colData.")
    }
}


#' general validate function
#' @noRd
validateOutriderDataSet <- function(object) {
    c(
        checkNames(object),
        validateCounts(object)
    )
}
setValidity("OutriderDataSet", validateOutriderDataSet)


#' show method for OutriderDataSet
#' @noRd
showOutriderDataSet <- function(object) {
    cat("class: OutriderDataSet\n")
    show(as(object, "RangedSummarizedExperiment"))
}

setMethod("show", "OutriderDataSet", function(object) {
    showOutriderDataSet(object)
})

#' @rdname OutriderDataSet-class
#' @export
OutriderDataSet <- function(se, countData, colData, ...) {
    
    # use SummarizedExperiment object
    if(!missing(se)){
        if(!is(se, "SummarizedExperiment")){
            stop("'se' must be a SummarizedExperiment object")
        }
        se <- DESeqDataSet(se, design=~1, ...)
    
    # use raw count data
    } else if(!missing(countData)){
        if(missing(colData)){
            cols <- colnames(countData)
            if(is.null(cols)){
                cols <- paste0("sample", seq_len(ncol(countData)))
            }
            colData <- DataFrame(sampleID=cols)
            rownames(colData) <- colData[['sampleID']]
            colnames(countData) <- colData[['sampleID']]
        }
        se <- DESeqDataSetFromMatrix(countData=countData, 
                colData=colData, design=~1, ...)
        
    # nothing provided
    } else {
        stop("At least one of the se or countData argument has to be defined!")
    }
    
    # set sampleID and colnames 
    if(!"sampleID" %in% colnames(se@colData)){
        warning("No sampleID was specified. We will generate a generic one.")
        if(!is.null(colnames(se)) && !any(duplicated(colnames(se)))){
            se@colData[["sampleID"]] <- colnames(se)
        } else {
            se@colData[["sampleID"]] <- paste0("sample_", seq_col(se))
        }
    }
    colnames(se) <- se@colData[["sampleID"]]
    
    obj <- new("OutriderDataSet", se)
    metadata(obj)[["version"]] <- packageVersion("OUTRIDER")
    validObject(obj)
    
    return(obj)
}

#' 
#' Create example data sets for OUTRIDER
#' 
#' Creates an example data set from a file or simulates a data set based 
#' on random counts following a negative binomial distribution with injected
#' outliers with a fixed z score away from the mean of the gene.
#' 
#' @param dataset If "none", the default, an example data set is simulated. 
#'             One can also use example data set included in the package by
#'             specifying 'GTExSkinSmall' or 'KremerNBaderSmall'
#' @param n Number of simulated genes 
#' @param m Number of simulated samples
#' @param freq Frequency of in-silico outliers
#' @param zScore Absolute z score of in-silico outliers (default 6).
#' @param inj Determines whether counts are injected with the strategy 
#'            ('both', 'low', 'high'), default is 'both'.
#' @param sf Artificial Size Factors
#' @param q number of simulated latend variables.
#' 
#' @return An OutriderDataSet containing an example dataset. Depending on the
#'            parameters it is based on a real data set or it is simulated
#' 
#' @examples
#' # A generic dataset 
#' ods1 <- makeExampleOutriderDataSet()
#' ods1
#' 
#' # A generic dataset with specificed sample size and injection method
#' ods2 <- makeExampleOutriderDataSet(n=200, m=50, inj='low')
#' ods2
#' 
#' # A subset of a real world dataset from GTEx 
#' ods3 <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
#' ods3
#' 
#' @export
makeExampleOutriderDataSet <- function(n=200, m=80, q=10, freq=1E-3, zScore=6,
                    inj=c('both', 'low', 'high'), sf=rnorm(m, mean=1, sd=0.1),
                    dataset=c('none', 'GTExSkinSmall', 'KremerNBaderSmall')){
    # load example data set 
    dataset <- match.arg(dataset)
    if(dataset != 'none'){
        file <- system.file("extdata", paste0(dataset, ".tsv"), 
                package="OUTRIDER", mustWork=TRUE)
        countData <- read.table(file)
        return(OutriderDataSet(countData=countData))
    }
    
    theta <- rlnorm(n, meanlog=log(180), sdlog=2)  # dispersion
    logMean <- 5                                   # log offset for mean expres
    sdVec <- rep(0.5, m)                           # sd for H matrix
    
    #
    # Simulate covariates.
    #
    H_true <- matrix(rnorm(m*q), nrow=m, ncol=q)
    D_true <- matrix(rnorm(n*q, sd=sdVec), nrow=n, ncol=q)
    y_true <- D_true %*% t(cbind(H_true))
    mu     <- t(t(exp(rnorm(n, logMean) + y_true))*sf)
    
    # scale it up to overcome the estimation error
    true_sd <- sdLogScale(rowMeans(mu), theta)
    
    #
    # Simulate count Matrix with specified means.
    #
    k <- matrix(rnbinom(m*n, mu=mu, size=theta), nrow=n, ncol=m)
    mode(k) <- 'integer'
    
    #
    # Create Outrider data set
    #
    countData <- DataFrame(k, row.names=paste0("feature_", seq_len(n)))
    colnames(countData) <- paste0("sample_", seq_len(m))
    ods <- OutriderDataSet(countData=countData)
    
    assay(ods, "trueMean", withDimnames=FALSE) <- mu
    assay(ods, "trueSd", withDimnames=FALSE) <- matrix(true_sd, nrow=n, ncol=m)
    mcols(ods)[,"trueTheta"]                 <- theta
    colData(ods)[['trueSizeFactor']]         <- sf
    metadata(ods)[['optimalEncDim']]         <- q
    metadata(ods)[['encDimTable']]           <- data.table(
        encodingDimension=q, evaluationLoss=1, evalMethod='simulation')
    
    #
    # inject outliers
    #
    indexOut <- matrix(nrow=n, ncol=m,
        sample(c(-1,1,0), m*n, replace=TRUE, prob=c(freq/2, freq/2, 1-freq)))
    indexOut <- switch(match.arg(inj),
        low  = -abs(indexOut),
        high =  abs(indexOut),
        indexOut
    )
    normtable <- t(t(k)/sf)
    datasd <- assay(ods, "trueSd")
    lmu <- log2(assay(ods, "trueMean"))
    
    # inject outliers
    max_out <- 1E2 * min(max(k), .Machine$integer.max/1E3)
    n_rejected <- 0
    list_index <- which(indexOut != 0, arr.ind = TRUE)
    for(i in seq_len(nrow(list_index))){
        row <- list_index[i,'row']
        col <- list_index[i,'col']
        fc <- zScore * datasd[row,col]
        clcount <- indexOut[row,col] * fc + lmu[row,col]
        
        #multiply size factor again
        art_out <- round(sf[col]*2^clcount)
        if(art_out < max_out){
            k[row,col] <- art_out
        }else{
            #remove super large outliers
            indexOut[row,col] <- 0 
            n_rejected <- n_rejected + 1
        }
    }
    mode(k) <- "integer"
    
    assay(ods, 'trueCounts', withDimnames=FALSE) <- counts(ods)
    counts(ods, withDimnames=FALSE) <- k
    assay(ods, "trueOutliers", withDimnames=FALSE) <- indexOut
    
    return(ods)
}

#' 
#' Aproximates standard deviation of counts in log2 space.
#' 
#' @noRd
sdLogScale <- function(mu, theta){
    sqrt(mu*(1 + mu/theta)) / ((mu + 1)*log(2)) * 2
}

context("Testing generic functions")

test_that("setter and getter function", {
    ord <- makeExampleOutriderDataSet(30, 30)
    sf <- runif(dim(ord)[2], 0.8, 1.2)
    sizeFactors(ord) <- sf
    
    expect_equal(sizeFactors(ord), sf, check.names=FALSE)
    expect_equal(t(t(counts(ord))/sf), counts(ord, normalized=TRUE))
})

test_that("sizefactor estimation", {
    cts <- getCountDataWithNames(matrix(rep(c(1:10),4), nrow=10) + 1:40)
    ord <- OutriderDataSet(countData=cts)
    exp_sf <- c(0.471, 0.905, 1.333, 1.763)
    sf <- sizeFactors(estimateSizeFactors(ord))
    
    expect_equal(sf, exp_sf, tolerance=.001, check.names=FALSE)
})

test_that("normalization function", {
    n <- 30
    m <- 4
    ord <- makeExampleOutriderDataSet(n=n, m=m)
    
    normF <- matrix(c(1:m)/m, nrow=n, ncol=m)
    normalizationFactors(ord) <- normF
    
    expect_equivalent(normF, normalizationFactors(ord))
    E <- t(apply(normF, 1, pmax, 0.5))
    expect_equal(counts(ord)/E * exp(rowMeans(log(E))), 
            counts(ord, normalized=TRUE))
    
    # check if subsetting affects the computation of the log geom mean
    expect_equal((counts(ord)/E * exp(rowMeans(log(E))))[1:10,1:3], 
            counts(ord[1:10,1:3], normalized=TRUE))
    
    normalizationFactors(ord) <- NULL
    expect_null(normalizationFactors(ord))
    
    ord <- OutriderDataSet(countData=getCountDataWithNames(
            matrix(c(1,1,3,3), ncol=2)))
    colData(ord)[['sizeFactor']] <- c(.5, 1.5)
    expect_true(all(
            counts(ord, normalized = TRUE) == matrix(c(2,2,2,2), ncol = 2)))
    
    ord <- OutriderDataSet(countData=getCountDataWithNames(
            matrix(c(1,1,3,3), ncol=2)))
    normalizationFactors(ord) <- matrix(c(.5, .5, 1.5, 1.5), ncol=2)
    expect_true(all(round(counts(ord, normalized=TRUE), 4) == 
            matrix(1.7321, ncol=2, nrow=2)))
})

test_that("counts_function", {
    ord <- makeExampleOutriderDataSet(30, 30)
    cts <- counts(ord)
    counts(ord) <- cts+1L
    
    expect_equal(assays(ord)[['counts']], cts+1L)
    expect_equal(counts(ord), assays(ord)[['counts']])
})

context("Testing OutriderDataSet-class")

test_that("create test data set", {
    ods <- makeExampleOutriderDataSet(20,20)
    expect_is(ods, "OutriderDataSet")
    expect_equal(dim(ods), c(20,20))
    expect_equal(dim(assay(ods, 'trueOutliers')), c(20,20))
})

test_that("constructur for OutriderDataSet", {
    se <- as(DESeq2::makeExampleDESeqDataSet(), "SummarizedExperiment")
    rownames(se) <- paste0("gene", seq_row(se))
    colData(se)[["sampleID"]] <- colnames(se)
    expect_is(OutriderDataSet(se=se), "OutriderDataSet")
    expect_is(OutriderDataSet(countData=assay(se, 'counts')),
            "OutriderDataSet")
    expect_is(OutriderDataSet(countData=assay(se, 'counts'), 
            colData=colData(se)), "OutriderDataSet")
    
    ods <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
    expect_is(ods, "OutriderDataSet")
    expect_null(show(ods))
    expect_true(validObject(ods))
    
})

#'
#' Update D function
#' 
#' @noRd
updateD <- function(ods, control, BPPARAM, verbose){
    D <- D(ods)
    b <- b(ods)
    H <- H(ods)
    k <- t(counts(ods))
    sf <- sizeFactors(ods)
    sMask <- sampleExclusionMask(ods, aeMatrix=TRUE)
    theta <- theta(ods)
    thetaC <- thetaCorrection(ods)
    
    # run fits
    fitls <- bplapply(seq_len(nrow(ods)), singleDFit, D=D, b=b, k=k, sf=sf, H=H,
            theta=theta, mask=sMask, control=control, thetaC=thetaC, 
            BPPARAM=BPPARAM)
    
    # extract infos
    parMat <- vapply(fitls, '[[', double(ncol(D) + 1), 'par')
    mcols(ods)['FitDMessage'] <- vapply(fitls, '[[', 'text', 'message')
    mcols(ods)[,'NumConvergedD'] <- mcols(ods)[,'NumConvergedD'] + grepl(
            "CONVERGENCE: REL_REDUCTION_OF_F .. FACTR.EPSMCH", 
            mcols(ods)[,'FitDMessage'])
    
    if(isTRUE(verbose)){
        print(table(mcols(ods)[,'FitDMessage']))
    }
    
    # update b and D 
    b(ods) <- parMat[1,]
    D(ods) <- t(parMat)[,-1]
    metadata(ods)[['Dfits']] <- fitls
    
    return(ods)
}


singleDFit <- function(i, D, b, k, theta, mask, control, ...){
    pari <- c(b[i], D[i,])
    ki <- k[,i]
    thetai <- theta[i]
    maski <- mask[i,]
    
    fit <- optim(pari, fn=truncLogLiklihoodD, gr=gradientD, 
            k=ki, theta=thetai, exclusionMask=maski, ..., control=control,
            lower=-100, upper=100, method='L-BFGS')

    return(fit)
}

#'
#' the PCA implementation
#' 
#' @noRd
autoCorrectPCA <- function(ods, q, trim=0){
    
    k <- t(counts(ods, normalized=FALSE))
    s <- sizeFactors(ods)
    
    # compute log of per gene centered counts 
    x0 <- log((1+k)/s)
    xbar <- apply(x0, 2, mean, trim)
    x <- t(t(x0) - xbar)
    
    # initialize W using PCA and bias as zeros.
    pca <- pca(x, nPcs=q) 
    pc  <- loadings(pca)
    
    # set the matrices
    E(ods) <- as.vector(pc)
    D(ods) <- as.vector(pc)
    b(ods) <- xbar
    
    # add correction factor to object
    correctionFactors <- t(predictC(ods))
    stopifnot(identical(dim(counts(ods)), dim(correctionFactors)))
    normalizationFactors(ods) <- correctionFactors
    
    # add it to the object
    metadata(ods)[['dim']] <- dim(ods)
    
    validObject(ods)
    return(ods)
}

#' @rdname aberrant
#' @export
setGeneric("aberrant", function(object, ...) standardGeneric("aberrant"))

#' @importFrom DESeq2 dispersions
#' @noRd
#' @export
DESeq2::dispersions

#' @rdname filterExpression
#' @export
setGeneric("filterExpression", function(object, ...)
        standardGeneric("filterExpression"))

#' @importFrom generics fit
#' @noRd
#' @export
generics::fit

#' @rdname plotFunctions
#' @export
setGeneric("plotAberrantPerSample", function(object, ...)
        standardGeneric("plotAberrantPerSample"))

#' @rdname plotFunctions
#' @export
setGeneric("plotCountCorHeatmap", function(object, ...) 
        standardGeneric("plotCountCorHeatmap"))

#' @rdname plotFunctions
#' @export
setGeneric("plotManhattan", function(object, ...) 
    standardGeneric("plotManhattan"))

#' @importFrom DESeq2 plotDispEsts
#' @noRd
#' @export
DESeq2::plotDispEsts

#' @rdname plotFunctions
#' @export
setGeneric("plotEncDimSearch", function(object, ...)
        standardGeneric("plotEncDimSearch"))

#' @rdname plotFunctions
#' @export
setGeneric("plotQQ", function(object, ...) standardGeneric("plotQQ"))

#' @rdname plotFunctions
#' @export
setGeneric("plotVolcano", function(object, ...) standardGeneric("plotVolcano"))

#' @rdname results
#' @export
setGeneric("results", function(object, ...) standardGeneric("results"))

#' Low Rank Simulation
#'
#' This function simulates a data set as a low-rank signal corrupted by 
#' Gaussian noise. This function is copied from 
#' https://github.com/julierennes/denoiseR/blob/master/R/LRsim.R as it was 
#' removed from CRAN due to lack of maintenance.
#'  
#' @param n integer, number of rows
#' @param p integer, number of columns
#' @param k integer, rank of the signal
#' @param SNR numeric, signal to noise ratio
#' @return X the simulated data 
#' @return mu the true signal 
#' @return sigma the standard deviation of the noise added to the signal
#' @details A data set of size n*p and of rank k is simulated. More precisely, 
#'   it is simulated as follows: A SVD is performed on a n*p matrix generated
#'   from a standard multivariate normal distribution. Then, the signal is 
#'   computed using the first k singular vectors and singular values 
#'   U_q D_q V_q'. The signal is scaled in such a way that the variance of each
#'   column is 1 and then a Gaussian noise with variance sigma^2 is added.
#'   The SNR is calculated as 1/ sigma sqrt(np). 
#' @examples  
#' Xsim= LRsim(100, 30, 2, 2)
#' 

.LRsim <- function(n, p, k, SNR){
  noisesd <- 1/(SNR*sqrt(n*p)) 
  if(k == 0){
    MU <- matrix(0, n, p)  
  } else {
    SIGNAL <- replicate(p, rnorm(n, 0, 1))
    SIGNAL <- scale(SIGNAL, scale = FALSE)
    svdSIGNAL <- svd(SIGNAL) 
    MU <- (
      svdSIGNAL$u[, 1:k,drop=F] 
      %*% diag(svdSIGNAL$d[1:k], k, k) 
      %*% t(svdSIGNAL$v[, 1:k, drop=F]) 
      / sqrt(sum(svdSIGNAL$d[1:k]^2))
    )
  }
  X <- MU + noisesd*replicate(p, rnorm(n, 0, 1))
  return(list(X = X, mu = MU, sigma = noisesd))
}

context("Test loss and gradient functions: ")

if(FALSE){
    # w : weights
    # k : read counts matrix (sample x genes)
    # s : size factor (scalar for now)
    # xbar: mean gene expression levels
    
    ## simulation of data
    n = 100 # samples
    p = 20 # genes
    q = 5 # latent space dimension
    s=rnorm(n,mean=1, sd = 0.1)
    theta = 25
    
    h_true <- matrix(rnorm(n*q), nrow=n, ncol=q)
    Wd_true <- matrix(rnorm(p*(q+1)), nrow=p, ncol=q+1)
    y_true <- Wd_true%*%t(cbind(rep(1,n),h_true))
    k <- apply(
        y_true,
        1,
        function(yi)
            rnbinom(n, mu=s*exp(yi), size=theta)
    )
    
    # compute x
    x0 <- log((1+k)/s)
    xbar <- colMeans(x0)
    x <- t(t(x0)-xbar)
    
    # ## value for random weight init
    w <- c(rnorm(p*q, sd=1/p*q), rep(0,p))
    
    # expect a real positiv number.
    test_that("loss is real number", {
        l <- loss(w, k, x, s, xbar, theta)
        expect_that(l ,is.numeric)
        expect_equal(length(l), 1)
    })
    
    # numeric Gradient
    numericLossGrad <- function(fn, epsilon, w,...){
        grad <- numeric(length(w))
        for(i in seq_along(w)){
            eps <- integer(length(w))
            eps[i] <- epsilon
            grad[i] <- (fn(w + eps, ...) - fn(w -eps, ...))/(2*epsilon)
        }
        return(grad)
    }
    
    # testing the gradient
    #plot(numericLossGrad(loss, 1E-8, w, k=k, x=x, s=s, xbar=xbar, theta=25),
    #     lossGrad(w, k, x, s, xbar, theta));abline(0,1)
    
    test_that("Analytic gradient ~= numeric gradient", {
        for(i in 1:5){
            w <- c(rnorm(p*q, sd=1/p*q), rep(0,p))
            expect_equal(lossGrad(w, k, x, s, xbar, theta), 
                matrix(numericLossGrad(
                        loss, 1E-8, w, k=k, x=x, s=s, xbar=xbar, theta=theta
                            ), ncol=q+1), tol=0.0001)
        }
    })
}    

context("Autoencoder: ")

if(FALSE){
    set.seed(42)
    
    ## simulation of data
    n = 30 # samples
    p = 20 # genes
    q = 6 # latent space dimension
    s=rnorm(n,mean=1, sd = 0.1)
    theta = 25
    
    h_true <- matrix(rnorm(n*q), nrow=n, ncol=q)
    Wd_true <- matrix(rnorm(p*(q+1)), nrow=p, ncol=q+1)
    y_true <- Wd_true%*%t(cbind(rep(1,n),h_true))
    k <- apply(
        y_true,
        1,
        function(yi)
            rnbinom(n, mu=s*exp(yi), size=theta)
    )
    
    ## check that the simulated counts seem to make sense
    # hist(log10(1+k))
    
    # compute x
    x0 <- log((1+k)/s)
    xbar <- colMeans(x0)
    x <- t(t(x0)-xbar)
    
    # ## value for random weight init
    w <- c(rnorm(p*q, sd=1/p*q), rep(0,p))
    # expect a real positiv number.
    randLoss <- loss(w, k, x, s, xbar, theta)
    
    ## init with pca on centered log counts
    library(pcaMethods)
    x  <- t(t(x0)- xbar)
    pca <- pca(x, nPcs = q) ## could also use ppca
    pc  <- loadings(pca)
    w_guess <- as.vector(pc)
    ## indeed much better guess
    pcaLoss <- loss(c(w_guess, rep(0,p)), k, x, s, xbar, theta)
    
    ## init with pca on centered log counts
    ## we'd need the gradient for this one to go fast
    ## It might be a good idea to restrict to Wd = t(We).
    ## I feel this is too much over-fitted otherwise
    
    fit <- optim(c(w_guess, rep(0,p)), loss, k=k, s=s, x=x, xbar=xbar, theta=theta, 
            method="L-BFGS-B", control = list(maxit=300))
    fitLoss <- loss(fit$par, k, x, s, xbar, theta)
    fit2 <- optim(c(w_guess, rep(0,p)), loss, gr = lossGrad, k=k, x=x, s=s, 
            xbar=xbar, theta=25, method="L-BFGS-B", control = list(maxit=300))
    fitGradLoss <- loss(fit2$par, k, x, s, xbar, theta)
    
    test_that("Dimensions match.", {
        expect_equal(length(w_guess), p*q)
        expect_equal(length(fit$par), p*(q+1))
        expect_equal(length(lossGrad(fit$par, k, x, s, xbar, theta)), p*(q+1))
    })
    
    test_that("Losses match (fitLoss ~= fitGradLoss)",{
        expect_equal(fitLoss, fitGradLoss, tol=0.1)
    })
    
    test_that("randLoss > pcaLoss > fitGradLoss",{ 
        expect(randLoss >= pcaLoss)
        expect(pcaLoss >= fitGradLoss)
    })
}

%\VignetteIndexEntry{OUTRIDER: OUTlier in RNA-seq fInDER}
%\VignettePackage{OUTRIDER}
%\VignetteEngine{knitr::knitr}
%\VignetteEncoding{UTF-8}

\documentclass[11pt]{article}
\usepackage{xcolor}
\definecolor{fgcolor}{rgb}{0,0,0}

<<style-knitr, eval=TRUE, echo=FALSE, cache=FALSE, results="asis">>=
BiocStyle::latex()
@

<<knitr, echo=FALSE, cache=FALSE, results="hide">>=
library(knitr)
opts_chunk$set(
    tidy=FALSE,
    dev="png",
    fig.width=7,
    fig.height=7,
    dpi=300,
    message=FALSE,
    warning=FALSE,
    cache=TRUE
)
@

\usepackage{amsmath}
\usepackage{verbatim}
\usepackage[nottoc]{tocbibind}

\newcommand{\outrider}{\Biocpkg{OUTRIDER}}
\newcommand{\rna}{RNA-seq}
\newcommand{\deseq}{\Biocpkg{DESeq2}}
\newcommand{\ods}{\Rclass{OutriderDataSet}}

\title{OUTRIDER - OUTlier in RNA-Seq fInDER}

\author{
    Felix Brechtmann$^{1}$, Christian Mertes$^{1}$, Agne Matuseviciute$^{1}$, 
        Vicente Yepez$^{1,2}$, Julien Gagneur$^{1,2}$ \\
    \small{$^{1}$ Technical University Munich, Department of 
        Informatics, Munich, Germany}\\
    \small{$^{2}$ Quantitative Biosciences Munich, Gene Center, 
        Ludwig-Maximilians Universit\"at M\"unchen, Munich, Germany}
}

\begin{document}

<<include=FALSE>>=
opts_chunk$set(concordance=TRUE)
@

\maketitle

\begin{abstract}

In the field of diagnostics of rare diseases, \rna{} is emerging as an 
important and complementary tool for whole exome and whole genome sequencing. 
\outrider{} is a framework that detects aberrant gene expression within a 
group of samples. It uses the negative binomial distribution which is fitted 
for each gene over all samples. We additionally provide an autoencoder, 
which automatically controls for co-variation before fitting. After fitting,
each sample can be tested for aberrantly expressed genes. Furthermore,
\outrider{} provides functionality to easily filter unexpressed genes, to 
analyse the data as well as to visualize the results.

\vspace{3em}

\begin{center}
\begin{tabular}{ | l | }
\hline
If you use \outrider{} in published research, please cite:  \\
\\
Brechtmann F*, Mertes C*, Matuseviciute A*, Yepez V, Avsec Z, Herzog M, \\
Bader D M, Prokisch H, Gagneur J; \textbf{OUTRIDER: A statistical method} \\
\textbf{for detecting aberrantly expressed genes in RNA sequencing data}; \\
\emph{AJHG}; 2018; DOI: \url{https://doi.org/10.1016/j.ajhg.2018.10.025}
\\
\hline
\end{tabular}
\end{center}

\end{abstract}

\newpage

\tableofcontents

\newpage


<<hiden_config, echo=FALSE>>=
suppressPackageStartupMessages({
    library(OUTRIDER)
    library(beeswarm)
})
if(!is(bpparam(), "SerialParam")){
    bp <- bpparam()
    bpworkers(bp) <- min(4, bpworkers(bp))
    register(bp)
}
@

\section{Introduction}
\outrider{} (OUTlier in RNA-seq fInDER) is a tool for finding aberrantly 
expressed
genes in RNA-seq samples. It does so by fitting a negative binomial model 
to RNA-seq read counts, correcting for variations in sequencing depth and 
apparent co-variations across samples. Read counts that significantly deviate 
from the distribution are detected as outliers. \outrider{} makes use of an
autoencoder to control automatically for confounders within the data. A scheme
of this approach is given in Figure \ref{autoencoder_sketch}.

\incfig{autoencoder_sketch}{1\textwidth}{Context-dependent outlier detection.}{
The algorithm identifies 
gene expression outliers whose read counts are significantly aberrant given the
co-variations typically observed across genes in an RNA sequencing data set.
This is illustrated by a read count (left panel, fifth column, second row from
the bottom) that is exceptionally high in the context of correlated samples
(left six samples) but not in absolute terms for this given gene. To capture
commonly seen biological and technical contexts, an autoencoder models
co-variations in an unsupervised fashion and predicts read count expectations.
By comparing the earlier mentioned read count with these context-dependent
expectations, it is revealed as exceptionally high (right panel). The lower
panels illustrate the distribution of read counts before and after applying
the correction for the relevant gene. The red dotted lines depict significance
cutoffs.}

Differential gene expression analysis from RNA-seq data is well-established.
The packages \deseq{}\cite{Love2014} or \Biocpkg{edgeR}\cite{Robinson2010} 
provide effective workflows and preprocessing steps to perform differential gene
expression analysis. However, these methods aim at detecting significant 
differences between groups of samples. In contrast, \outrider{} aims at 
detecting outliers within a given population. A scheme of this difference is 
given in figure \ref{fig:deVsOutlier}.

<<deVsOutlier, echo=FALSE, fig.height=5, fig.cap="Scheme of workflow differences. Differences between differential gene expression analysis and outlier detection.">>=
par.old <- par(no.readonly=TRUE)
par(mfrow=c(1,2), cex=1.2)
ylim <- c(80, 310)
a <- rnorm(10, 250, 10)
b <- rnorm(10, 120, 10)
c <- rnorm(100, 250, 20)
c[1] <- 105
beeswarm(list(A=a, B=b), 
        main="Differential\nexpression analysis\n(DESeq2/edgeR)",
        xlab="Condition", ylab="Expression", ylim=ylim, pch=20, 
        col=c("darkblue", "firebrick"))
beeswarm(c, main="Outlier\ndetection\n(OUTRIDER)", ylim=ylim, pch=20, 
        xlab="Population", ylab="Expression", col="firebrick")

par(par.old)
@

\section{Prerequisites}
To get started on the preprocessing step, we recommend to read the 
introductions of \deseq{}\cite{Love2014}, \Biocpkg{edgeR}\cite{Robinson2010}
or the RNA-seq workflow from
Bioconductor: \Biocpkg{rnaseqGene}. In brief, one usually starts with the raw
FASTQ files from
the RNA sequencing run. Those are then aligned to a given reference genome. 
At the time of writing
(October 2018), we recommend the STAR aligner\cite{Dobin2013}. After 
obtaining the aligned BAM files, one can map the reads to exons or genes of a 
GTF annotation file using HT-seq or by using \Rfunction{summarizedOverlaps} from
\Biocpkg{GenomicAlignments}. The resulting count table can then be loaded 
into the \outrider{} package as we will describe below.

\section{A quick tour}

Here we assume that we already have a count table and no additional 
preprocessing needs to be done. We can start and obtain results with 
3 commands. First, create an \ods{} from a count table or a Summarized 
Experiment object. Second, run the full 
pipeline using the command \Rfunction{OUTRIDER}. In the third and last step the 
results table is extracted from the \ods{} with the \Rfunction{results} 
function. Furthermore, analysis plots that are described in section 
\ref{sec:Results} can be directly created from the \ods{} object.

<<quick_guide, fig.height=5>>=
library(OUTRIDER)

# get data
ctsFile <- system.file('extdata', 'KremerNBaderSmall.tsv', 
        package='OUTRIDER')
ctsTable <- read.table(ctsFile, check.names=FALSE)
ods <- OutriderDataSet(countData=ctsTable)

# filter out non expressed genes
ods <- filterExpression(ods, minCounts=TRUE, filterGenes=TRUE)

# run full OUTRIDER pipeline (control, fit model, calculate P-values)
ods <- OUTRIDER(ods)

# results (only significant)
res <- results(ods)
head(res)

# example of a Q-Q plot for the most significant outlier
plotQQ(ods, res[1, geneID])
@

\section{An \outrider{} analysis in detail}

Apart from running the full pipeline using the single wrapper function 
\Rfunction{OUTRIDER}, 
the analysis can also be run step by step. The wrapper function does
not include any preprocessing functions. Discarding non expressed genes or 
samples failing quality measurements should be done manually before running the 
\Rfunction{OUTRIDER} function or starting the analysis pipeline.

In this section we will explain the analysis functions step by step.

For this tutorial we will use the rare disease data set from Kremer 
\textit{et al}.\cite{Kremer2017}. For testing purposes, this package 
contains a small subset of it.

\subsection{OutriderDataSet}
To use \outrider{} create an \ods, which derives from a 
RangedSummarizedExperiment
object. The \ods can be created by supplying a count matrix and optional sample 
annotation matrices. Alternatively, an existing Summarized experiment object
from other Biocnductor backages can be used.

<<GetDataSet>>=
# small testing data set
odsSmall <- makeExampleOutriderDataSet(dataset="Kremer")

# full data set from Kremer et al.
baseURL <- paste0("https://static-content.springer.com/esm/", 
        "art%3A10.1038%2Fncomms15824/MediaObjects/")
count_URL <- paste0(baseURL, "41467_2017_BFncomms15824_MOESM390_ESM.txt")
anno_URL  <- paste0(baseURL, "41467_2017_BFncomms15824_MOESM397_ESM.txt")

ctsTable <- read.table(count_URL, sep="\t")
annoTable <- read.table(anno_URL, sep="\t", header=TRUE)
annoTable$sampleID <- annoTable$RNA_ID

# create OutriderDataSet object
ods <- OutriderDataSet(countData=ctsTable, colData=annoTable)
@

\subsection{Preprocessing}

It is recommended to preprocess the data before fitting. Our model 
requires that for every gene at least one sample has a non-zero count and 
that we observe at least one read for every 100 samples. Therefore, 
all genes that are not expressed must be discarded.

We provide the function \Rfunction{filterExpression} to remove genes that have 
low FPKM (Fragments Per Kilobase of transcript per Million mapped reads) 
expression values. The needed annotation to estimate FPKM values 
from the counts should be the same as for the counting. Here, we normalize 
by the total exon length of a gene.
To do so the joint lenght of all exons needs to be provided. When providing a 
gtf, gff or TxDb object to the \Rfunction{filterExpression}, we extract this 
information automatically. But therfore the geneID's of the count table and the 
gtf need to match.

By default the cutoff is set to an FPKM value of one and only the filtered
\ods{} object is returned. If required, the FPKM values can be stored in the
\ods{} object and the full object can be returned to visualize the 
distribution of reads before and after filtering. 


<<Preprocessing, fig.height=5>>=
# get annotation
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(org.Hs.eg.db)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
map <- select(org.Hs.eg.db, keys=keys(txdb, keytype = "GENEID"), 
        keytype="ENTREZID", columns=c("SYMBOL"))
@

However, the \Robject{TxDb.Hsapiens.UCSC.hg19.knownGene} contains only 
well annotated 
genes. This annotation will miss a lot of genes captured by RNA-seq. To include 
all predicted annotations as well as non-coding RNAs please download the txdb 
object from our homepage\footnote{\url{https://cmm.in.tum.de/public/paper/mitoMultiOmics/ucsc.knownGenes.db}}
or create it yourself from the UCSC website\footnote{\url{https://genome.ucsc.edu/cgi-bin/hgTables}}$^,$\footnote{\url{http://genomewiki.ucsc.edu/index.php/Genes_in_gtf_or_gff_format}}.

<<create txdb, eval=FALSE>>=
try({
    library(RMariaDB)
    library(AnnotationDbi)
    con <- dbConnect(MariaDB(), host='genome-mysql.cse.ucsc.edu', 
            dbname="hg19", user='genome')
    map <- dbGetQuery(con, 'select kgId AS TXNAME, geneSymbol from kgXref')
    
    txdbUrl <- paste0("https://cmm.in.tum.de/public/",
            "paper/mitoMultiOmics/ucsc.knownGenes.db")
    download.file(txdbUrl, "ucsc.knownGenes.db")
    txdb <- loadDb("ucsc.knownGenes.db")
    
})
@

<<filtering, fig.height=5>>=
# calculate FPKM values and label not expressed genes
ods <- filterExpression(ods, txdb, mapping=map, 
        filterGenes=FALSE, savefpkm=TRUE)

# display the FPKM distribution of counts.
plotFPKM(ods)

# display gene filter summary statistics 
plotExpressedGenes(ods)

# do the actual subsetting based on the filtering labels
ods <- ods[mcols(ods)$passedFilter,]
@

\subsection{Controlling for Confounders}

The next step in any analysis workflow is to visualize the correlations
between samples. In most RNA-seq experiments correlations between the samples 
can be observed. These are often due to technical confounders 
(e.g. sequencing batch) 
or biological confounders (e.g. sex, age). These confounders can adversely
affect the 
detection of aberrant features. Therefore, we provide options to control for 
them.

<<plotting_between_sample_correlations>>=

# Heatmap of the sample correlation
# it can also annotate the clusters resulting from the dendrogram
ods <- plotCountCorHeatmap(ods, colGroups=c("SEX", "RNA_HOX_GROUP"),
        normalized=FALSE, nRowCluster=4)

# Heatmap of the gene/sample expression
ods <- plotCountGeneSampleHeatmap(ods, colGroups=c("SEX", "RNA_HOX_GROUP"),
        normalized=FALSE, nRowCluster=4)

@

We have different ways to control for confounders present in the data.
The first and standard way is to calculate the \Rfunction{sizeFactors} 
as done in \deseq{}\cite{Love2014}.

Additionally, the \Rfunction{controlForConfounders} function calls a denoising autoencoder that controls for confounders by exploiting correlations in the data to reconstruct corrupted read-counts. The encoding dimension \textit{q} can be set manually or can be calculated with the \Rfunction{estimateBestQ} function using the Optimal Hard Thresholding (OHT) procedure established by Gavish and Donoho\cite{Gavish2013}. Alternatively, the optimal value of \textit{q} can be determined by testing different values for \textit{q} and calculating the one that recalls the highest number of injected outliers. The deterministic approach using OHT is much faster than the iterative procedure.
After controlling for confounders, the heatmap should be plotted again.
If it worked, no batches should be present and the correlations between 
samples should be reduced and close to zero.

<<controlling_for_confounders>>=

# automatically control for confounders
# we use only 3 iterations to make the vignette faster. The default is 15. 
ods <- estimateSizeFactors(ods)
ods <- controlForConfounders(ods, q=21, iterations=3)

# Heatmap of the sample correlation after controlling
ods <- plotCountCorHeatmap(ods, normalized=TRUE, 
        colGroups=c("SEX", "RNA_HOX_GROUP"))

@

Alternatively, other methods can be used to control for confounders. In addition
to the \textit{autoencoder}, we implemented a PCA based approach. The PCA 
implementation can be utilized by setting \Robject{implementation="pca"}. 
Also PEER can be used together with the OUTRIDER framework. A detailed 
description on how to do this can be found in section \ref{sec:PEER}.
Furthermore, any other method can be used by providing the 
\Rfunction{normalizationFactor} matrix. 
This matrix must be computed beforehand using the appropriate method. 
Its purpose is to normalize for technical effects or control for additional
expression patterns. 


\subsection{Finding the right encoding dimension \textit{q}}

In the previous section, we fixed the encoding dimension $q=21$. However, having 
the right encoding dimension is crucial in finding outliers in the data. 
On the one hand, if \textit{q} is too big the autoencoder will learn the 
identity matrix and will overfit the data. On the other hand, if \textit{q}
is too small the autoencoder cannot learn the necessary covariates existing
in the data. Therefore, it is recommended for any new dataset to estimate the
optimal encoding dimension to gain the best performance. 
With the function \Rfunction{estimateBestQ} one can find the optimal encoding 
dimension using Optimal Hard Thresholding\cite{Gavish2013}. Alternatively, the 
function can perform a hyperparameter optimization based on a grid-search. To 
this end, we artificially introduce corrupted counts randomly into the dataset 
and monitor the performance calling those corrupted counts. The optimal dimension 
\textit{q} is then selected as the dimension maximizing the area under the 
precision-recall curve for identifying corrupted counts. Since this method runs a 
full OUTRIDER fit for a variety of encoding dimensions, it is quite CPU-intensive. 
Thus, it is recommended to use the faster default method relying on OHT.


<<estimateBestQ, eval=FALSE>>=
# Optimal Hard Thresholding (default)
ods <- estimateBestQ(ods)

# Hyperparameter Optimization
ods <- estimateBestQ(ods, useOHT=FALSE)

# visualize the estimation of the optimal encoding dimension
plotEncDimSearch(ods)

@


\subsubsection{Excluding samples from the autoencoder fit}

Since OUTRIDER expects that each sample within the population is independent 
of all others, replicates could mask effects specific to this sample. This is 
also true if trios are present in the data, where the parents can be seen as
biological replicates. Here, we recommend to exclude the sample of interest or 
the replicates from the fitting. Later on, for all samples P-values 
are calculated. 

In this rare disease data set we know that two samples (MUC1344 and MUC1365)
have the same defect. To exclude one or both of them, we can use
the \Rfunction{sampleExclusionMask} function.

<<maskSamples>>=

# set exclusion mask
sampleExclusionMask(ods) <- FALSE
sampleExclusionMask(ods[,"MUC1365"]) <- TRUE

# check which samples are excluded from the autoencoder fit
sampleExclusionMask(ods)

@

\subsection{Fitting the negative binomial model}

The fit of the negative binomial model is done during the autoencoder fitting.
This step is only needed if alternative methods to control the data are used.
To fit the dispersion and the mean, the \Rfunction{fit} function is applied
to the \ods{}.

<<fitting, eval=FALSE>>=

# fit the model when alternative methods where used in the control step
ods <- fit(ods)
hist(theta(ods))

@

\subsection{P-value calculation}

After determining the fit parameters, two-sided P-values are computed using 
the following equation:

\begin{equation}
    p_{ij} = 2 \cdot min \left\{\frac{1}{2}, \sum_{0}^{k_{ij}} 
        NB(\mu_{ij} ,\theta_i), 1 - \sum_{0}^{k_{ij-1}} 
        NB(\mu_{ij} ,\theta_i) \right\},
\end{equation}

where the $\frac{1}{2}$ term handles the case of both terms exceeding 0.5, 
which can happen due to the discrete nature of counts. Here $\mu_{ij}$ are 
computed as the product of the fitted correction values from the autoencoder and
the fitted mean adjustements. If required a one-sided test can be performed 
using the argument \Robject{alternative} and specifying 'less' or 'greater' 
depending on the research question. Multiple testing correction is done across 
all genes in a per-sample fashion using Benjamini-Yekutieli's false discovery 
rate method\cite{Benjamini2001}. Alternatively, all adjustment methods supported
by \Rfunction{p.adjust} can be used via the \Robject{method} 
argument.

<<pValue_computation>>=
# compute P-values (nominal and adjusted)
ods <- computePvalues(ods, alternative="two.sided", method="BY")
@

\subsection{Z-score calculation}
The Z-scores on the log transformed counts can be used for visualization,
filtering, and ranking of samples. By running the \Rfunction{computeZscores}
function, the Z-scores are computed and stored in the \ods{} object.
The Z-scores are calculated using:

\begin{equation}
    z_{ij} = \frac{l_{ij} - \mu_j^l}{\sigma_j^l}
\end{equation}
\begin{equation*}
    l_{ij} = \log_2{(\frac{k_{ij} + 1}{c_{ij} + 1})},
\end{equation*}

where $\mu_j^l$ is the mean and $\sigma_j^l$ the 
standard deviation of gene $j$ and $l_{ij}$ is the log 
transformed count after correction for confounders.

<<zScore_computation>>=
# compute the Z-scores
ods <- computeZscores(ods)
@

\section{Results}
\label{sec:Results}
The \outrider{} package offers multiple ways to display the results. It 
creates a results table containing all the values computed during the analysis.
Furthermore, it offers various plot functions that guide the user 
through the analysis.

\subsection{Results table}

The \Rfunction{results} function gathers all the previously computed values
and combines them into one table.

<<results fun>>=
# get results (default only significant, padj < 0.05)
res <- results(ods)
head(res)
dim(res)

# setting a different significance level and filtering by Z-scores
res <- results(ods, padjCutoff=0.1, zScoreCutoff=2)
head(res)
dim(res)
@

In details the table contains: 
\itemize{
    \item{sampleID / geneID: }{The gene or sample ID as provided by the 
          user, e.g. rowData(ods) and colData(ods) respectively.}
    \item{pValue / padjust: }{The nominal P-value and the FDR corrected
          P-value indicating the outlier status. Find more details at 
          computePvalues.}
    \item{zScore / l2fc: }{The z score and $\log_{2}$ fold change 
        as computed by computeZscores.}
    \item{rawcounts: }{The observed read counts.}
    \item{normcounts: }{The expected count given the fitted 
          autoencoder model for the given gene-sample combination.}
    \item{meanRawcounts / meanCorrected: }{For this gene, the mean of the 
         observed or expected counts, respectively, given the fitted 
         autoencoder model.}
    \item{theta: }{The dispersion parameter of the NB distribution 
          for the given gene.}
    \item{aberrant: }{The outlier status of this event: TRUE or FALSE.}
    \item{AberrantBySample / AberrantByGene: }{Number of outliers for the 
          given sample or gene, respectively.}
    \item{padj rank: }{Rank of this outlier event within the given sample.}
    \item{FDR set: }{The subset-name used for the P-value computation.}
}



\subsection{Number of aberrant genes per sample}

One quantity of interest is the number of aberrantly expressed genes 
per sample. This can be displayed using the plotting function 
\Rfunction{plotAberrantPerSample}. Alternatively, the function 
\Rfunction{aberrant} can be used to identify aberrant events, which can be 
summed by sample or gene using the paramter \Robject{by}. These numbers depend 
on the cutoffs, which can be specified in both functions (\Robject{padjCutoff} 
and \Robject{zScoreCutoff}).

<<aberrantperSample, fig.height=5>>=
# number of aberrant genes per sample
tail(sort(aberrant(ods, by="sample")))
tail(sort(aberrant(ods, by="gene", zScoreCutoff=1)))

# plot the aberrant events per sample
plotAberrantPerSample(ods, padjCutoff=0.05)
@

\subsection{Volcano plots}

To view the distribution of P-values on a sample level, volcano plots can 
be displayed. Most of the plots make use of the \CRANpkg{plotly} 
framework to create interactive plots. To only use basic R functionality 
from \CRANpkg{graphics} the \Rcode{basePlot} argument can be set to 
\Rcode{TRUE}.

<<volcano, fig.height=5>>=
# MUC1344 is a diagnosed sample from Kremer et al.
plotVolcano(ods, "MUC1344", basePlot=TRUE)
@


\subsection{Gene level plots}

Additionally, we include two plots at the gene level. 
\Rfunction{plotExpressionRank} plots the counts in ascending order. 
By default, the controlled counts are plotted. To plot raw counts, the argument 
\Robject{normalized} can be set to \Rcode{FALSE}. 

When using the \CRANpkg{plotly} framework for plotting, all computed values 
are displayed for each data point. The user can access this information 
by hovering over each data point with the mouse.

<<visualization2, fig.height=5>>=
# expression rank of a gene with outlier events
plotExpressionRank(ods, "TIMMDC1", basePlot=TRUE)
@

The quantile-quantile plot can be used to see whether the fit converged well.
In presence of an outlier, it can happen that most of the points end up below 
the confidence band. This is fine and indicates that we have conservative 
P-values for the other points. Here is an example with two outliers:

<<visualization3, fig.height=5>>=
## QQ-plot for a given gene
plotQQ(ods, "TIMMDC1")
@

Since we do test how fare the observed count is away from the exprected 
expression level, it is also helpful to visualize the predictions against the 
observed counts. 

<<visualization4, fig.height=5>>=
## Observed versus expected gene expression
plotExpectedVsObservedCounts(ods, "TIMMDC1", basePlot=TRUE)
@

\section{Additional features}

\subsection{Using PEER to control for confounders}
\label{sec:PEER}

PEER\cite{Stegle2012} is a well known tool to control for unknown effects in
RNA-seq data. PEER is only available through the \Githubpkg{PMBio/peer} 
GitHub repository. The R source code can be downloaded form here: 
\url{https://github.com/downloads/PMBio/peer/R_peer_source_1.3.tgz}. The 
installation of the package has to be done manually by the user. 
After the installation one can use the following function to control for 
confounders with PEER. 

<<peer_function, eval=FALSE>>=
#'
#' PEER implementation
#'
peer <- function(ods, maxFactors=NA, maxItr=1000){
    
    # check for PEER
    if(!require(peer)){
        stop("Please install the 'peer' package from GitHub to use this ",
                "functionality.")
    }
    
    # default and recommendation by PEER: min(0.25*n, 100)
    if(is.na(maxFactors)){
        maxFactors <- min(as.integer(0.25* ncol(ods)), 100)
    }
    
    # log counts
    logCts <- log2(t(t(counts(ods)+1)/sizeFactors(ods)))
    
    # prepare PEER model
    model <- PEER()
    PEER_setNmax_iterations(model, maxItr)
    PEER_setNk(model, maxFactors)
    PEER_setPhenoMean(model, logCts)
    PEER_setAdd_mean(model, TRUE)
    
    # run fullpeer pipeline
    PEER_update(model)
    
    # extract PEER data
    peerResiduals <- PEER_getResiduals(model)
    peerMean <- t(t(2^(logCts - peerResiduals)) * sizeFactors(ods))
    
    # save model in object
    normalizationFactors(ods) <- pmax(peerMean, 1E-8)
    metadata(ods)[["PEER_model"]] <- list(
            alpha     = PEER_getAlpha(model),
            residuals = PEER_getResiduals(model),
            W         = PEER_getW(model))
    
    return(ods)
}
@ 

With the function above we can run the full OUTRIDER pipeline as follows:

<<how to run peer, eval=FALSE>>=
# Control for confounders with PEER
ods <- estimateSizeFactors(ods)
ods <- peer(ods)
ods <- fit(ods)
ods <- computeZscores(ods, peerResiduals=TRUE)
ods <- computePvalues(ods)

# Heatmap of the sample correlation after controlling
ods <- plotCountCorHeatmap(ods, normalized=TRUE)
@


\subsection{Power anaylsis}

We provide the \Rfunction{plotPowerAnalysis} function to show, what kind of 
changes can be significant depending on the mean count.
<<visualizationSigLevels, fig.height=5>>=
## P-values versus Mean Count
plotPowerAnalysis(ods)
@
Here, we see that it is only for sufficiently high expressed genes possible, to 
obtain significant P-values, especially for the downregulation cases.

\bibliography{bibliography}

\section*{Session info}

Here is the output of \Rfunction{sessionInfo()} on the system on which 
this document was compiled:

<<sessionInfo, echo=FALSE>>=
sessionInfo()
@

\end{document}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/helperFunctions.R, R/getNSetterFuns.R
\name{getBestQ}
\alias{getBestQ}
\alias{getter_setter_functions}
\alias{zScore,}
\alias{pValue,}
\alias{padj,}
\alias{theta,}
\alias{dispersion,}
\alias{zScore}
\alias{pValue}
\alias{padj}
\alias{dispersions,OutriderDataSet-method}
\alias{dispersions}
\alias{theta}
\title{Getter/Setter functions}
\usage{
getBestQ(ods)

zScore(ods)

pValue(ods)

padj(ods, subsetName = NULL)

\S4method{dispersions}{OutriderDataSet}(object, ...)

theta(ods)
}
\arguments{
\item{ods, object}{An OutriderDataSet object.}

\item{subsetName}{Name of a gene subset for which to store or retrieve 
FDR corrected p values}

\item{...}{Further arguments passed on to the underlying assay function.}
}
\value{
A matrix or vector dependent on the type of data retrieved.
}
\description{
This is a collection of small accessor/setter functions for easy access to
the values within the OUTRIDER model.
}
\examples{
ods <- makeExampleOutriderDataSet(10, 10)
ods <- OUTRIDER(ods)

zScore(ods)
pValue(ods)
padj(ods)
theta(ods)
theta(ods) == 1/dispersions(ods)
getBestQ(ods)

}
\seealso{
\code{\link[DESeq2]{estimateDispersions}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-estimateBestQ.R
\name{estimateBestQ}
\alias{estimateBestQ}
\alias{estimateBestQ,}
\alias{findInjectZscore}
\title{Find the optimal encoding dimension}
\usage{
estimateBestQ(
  ods = NULL,
  zScoresOHT = NULL,
  useOHT = TRUE,
  params = seq(2, min(100, ncol(ods) - 1, nrow(ods) - 1), 2),
  freq = 0.01,
  zScore = 3,
  sdlog = log(1.6),
  lnorm = TRUE,
  inj = "both",
  ...,
  BPPARAM = bpparam()
)

findInjectZscore(
  ods,
  freq = 0.01,
  zScoreParams = c(seq(1.5, 4, 0.5), "lnorm"),
  encDimParams = c(seq(3, 40, 3), seq(45, 70, 5), 100, 130, 160),
  inj = "both",
  ...,
  BPPARAM = bpparam()
)
}
\arguments{
\item{ods}{An OutriderDataSet object}

\item{zScoresOHT}{A z-score matrix}

\item{useOHT}{If \code{TRUE} (default), Optimal Hard Thresholding is 
used to estimate the optimal encoding dimension.}

\item{params, encDimParams}{Set of possible q values.}

\item{freq}{Frequency of outlier, defaults to 1E-2}

\item{zScore, zScoreParams}{Set of possible injection Z-score, defaults to 3.}

\item{sdlog}{Standard deviation of the sitribution on the log scale.}

\item{lnorm}{If TRUE, the default, Z-scores are drawn from a log normal 
distribution with a mean of \code{log(zScore)} in log-scale.}

\item{inj}{Injection strategy, by default 'both'.}

\item{...}{Further arguments passed on to the \code{controlForConfounders}
function.}

\item{BPPARAM}{BPPARAM object by default bpparam().}
}
\value{
The OutriderDataSet object with the optimal encoding dimension saved 
       in the metadata
}
\description{
Finds the optimal encoding dimension by either Optimal Hard Thresholding 
or injecting artificial splicing outlier ratios while maximizing the 
precision-recall curve.
}
\examples{
ods <- makeExampleOutriderDataSet()

# run OHT (default)
estimateBestQ(ods)

# run hyperparameter optimization (grid-search)
encDimSearchParams <- c(5, 8, 10, 12, 15)
zScoreParams <- c(2, 3, 5, 'lnorm')
implementation <- 'autoencoder'
register(MulticoreParam(4))
\dontshow{
    ods <- ods[1:12,1:12]
    encDimSearchParams <- c(2)
    zScoreParams <- c('lnorm')
    register(SerialParam())
    implementation <- 'pca'
}
ods1 <- estimateBestQ(ods, useOHT=FALSE, params=encDimSearchParams, 
        implementation=implementation)
plotEncDimSearch(ods1)

ods2 <- findInjectZscore(ods, zScoreParams=zScoreParams,
        encDimParams=encDimSearchParams, implementation=implementation)
plotEncDimSearch(ods2) 

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fitNB.R
\name{fit}
\alias{fit}
\alias{fit.OutriderDataSet}
\title{Fit the negative binomial distribution}
\usage{
\method{fit}{OutriderDataSet}(object, BPPARAM = bpparam(), ...)
}
\arguments{
\item{object}{An OutriderDataSet}

\item{BPPARAM}{by default bpparam()}

\item{...}{Currently not used.}
}
\value{
An OutriderDataSet object with the fitted model. Accessible through:
            \code{mcols(ods)[,c('mu', 'theta')]}.
}
\description{
Fit a negative binomial (NB) distribution to the counts per gene
over all samples using, if available, the precomputed control factors.
If no normalization factors are provided only the sizeFactors are used.
}
\examples{
ods <- makeExampleOutriderDataSet()
ods <- estimateSizeFactors(ods)
ods <- fit(ods)

mcols(ods)[1:10,c('mu', 'theta')]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterExpression.R
\name{fpkm}
\alias{fpkm}
\alias{fpm}
\title{Calculate FPM and FPKM values}
\description{
This is the fpm and fpkm function from DESeq2. For more details see: 
\code{\link[DESeq2]{fpkm}} and \code{\link[DESeq2]{fpm}}
}
\examples{
ods <- makeExampleOutriderDataSet()
mcols(ods)['basepairs'] <- round(rnorm(nrow(ods), 1000, 500))

mcols(ods)['basepairs']
fpkm(ods)[1:10,1:10]
fpm(ods)[1:10,1:10]

}
\seealso{
\code{\link[DESeq2]{fpkm}} \code{\link[DESeq2]{fpm}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/method-evaluation.R
\name{aberrant}
\alias{aberrant}
\alias{aberrant,OutriderDataSet-method}
\title{Number of aberrant events}
\usage{
aberrant(object, ...)

\S4method{aberrant}{OutriderDataSet}(
  object,
  padjCutoff = 0.05,
  zScoreCutoff = 0,
  by = c("none", "sample", "gene"),
  subsetName = NULL,
  ...
)
}
\arguments{
\item{object}{An OutriderDataSet object}

\item{...}{Currently not in use.}

\item{padjCutoff}{The padjust cutoff}

\item{zScoreCutoff}{The absolute Z-score cutoff, 
if NA or NULL no Z-score cutoff is used}

\item{by}{if the results should be summarized by 'sample', 
'gene' or not at all (default).}

\item{subsetName}{The name of a subset of genes of interest for which FDR 
corected pvalues were previously computed. Those FDR values 
on the subset will then be used to determine aberrant status. 
Default is NULL (using transcriptome-wide FDR corrected pvalues).}
}
\value{
The number of aberrent events by gene or sample or a TRUE/FALSE 
            matrix of the size sample x gene of aberrent events.
}
\description{
Identifies the aberrant events and returns the number of aberrant counts per
gene or sample or returns a matrix indicating aberrant events.
}
\examples{
ods <- makeExampleOutriderDataSet()
ods <- OUTRIDER(ods, implementation='pca')

aberrant(ods)[1:10,1:10]
tail(sort(aberrant(ods, by="sample")))
tail(sort(aberrant(ods, by="gene")))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/controlForConfounders.R
\name{controlForConfounders}
\alias{controlForConfounders}
\title{Autoencoder function to correct for confounders.}
\usage{
controlForConfounders(
  ods,
  q,
  implementation = c("autoencoder", "pca"),
  BPPARAM = bpparam(),
  ...
)
}
\arguments{
\item{ods}{An OutriderDataSet object}

\item{q}{The encoding dimensions}

\item{implementation}{"autoencoder", the default, will use the autoencoder
implementation. Also 'pca' and 'peer' can be used to control
for confounding effects}

\item{BPPARAM}{A 
\code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}}
        instance to be used for parallel computing.}

\item{...}{Further arguments passed on to the specific implementation method.}
}
\value{
An ods object including the control factors
}
\description{
This is the wrapper function for the autoencoder implementation. 
It can be used to call the standard R implementation or the experimental
Python implementation.
}
\examples{
ods <- makeExampleOutriderDataSet()
implementation <- 'autoencoder'
\dontshow{
    ods <- ods[1:10,1:10]
    implementation <- 'pca'
}
ods <- estimateSizeFactors(ods)
ods <- controlForConfounders(ods, implementation=implementation)

plotCountCorHeatmap(ods, normalized=FALSE)
plotCountCorHeatmap(ods, normalized=TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/method-plot.R
\name{plotAberrantPerSample}
\alias{plotAberrantPerSample}
\alias{plotCountCorHeatmap}
\alias{plotManhattan}
\alias{plotEncDimSearch}
\alias{plotQQ}
\alias{plotVolcano}
\alias{plotFunction}
\alias{plotFunctions}
\alias{plotExpectedVsObservedCounts}
\alias{plotExpressionRank}
\alias{plotCountGeneSampleHeatmap}
\alias{plotFPKM}
\alias{plotDispEsts}
\alias{plotPowerAnalysis}
\alias{plotExpressedGenes}
\alias{plotSizeFactors}
\alias{plotVolcano,OutriderDataSet-method}
\alias{plotQQ,OutriderDataSet-method}
\alias{plotCountCorHeatmap,OutriderDataSet-method}
\alias{plotAberrantPerSample,OutriderDataSet-method}
\alias{plotDispEsts,OutriderDataSet-method}
\alias{plotEncDimSearch,OutriderDataSet-method}
\alias{plotManhattan,OutriderDataSet-method}
\title{Visualization functions for OUTRIDER}
\usage{
plotAberrantPerSample(object, ...)

plotCountCorHeatmap(object, ...)

plotManhattan(object, ...)

plotEncDimSearch(object, ...)

plotQQ(object, ...)

plotVolcano(object, ...)

\S4method{plotVolcano}{OutriderDataSet}(
  object,
  sampleID,
  main,
  padjCutoff = 0.05,
  zScoreCutoff = 0,
  label = "aberrant",
  xaxis = c("zscore", "log2fc", "fc"),
  pch = 16,
  basePlot = FALSE,
  col = c("gray", "firebrick"),
  subsetName = NULL
)

\S4method{plotQQ}{OutriderDataSet}(
  object,
  geneID,
  main,
  global = FALSE,
  padjCutoff = 0.05,
  zScoreCutoff = 0,
  samplePoints = TRUE,
  legendPos = "topleft",
  outlierRatio = 0.001,
  conf.alpha = 0.05,
  subsetName = NULL,
  pch = 16,
  xlim = NULL,
  ylim = NULL,
  col = NULL
)

plotExpectedVsObservedCounts(
  ods,
  geneID,
  main,
  basePlot = FALSE,
  log = TRUE,
  groups = c(),
  groupColSet = "Set1",
  label = "aberrant",
  subsetName = NULL,
  ...
)

plotExpressionRank(
  ods,
  geneID,
  main,
  padjCutoff = 0.05,
  zScoreCutoff = 0,
  normalized = TRUE,
  basePlot = FALSE,
  log = TRUE,
  col = c("gray", "firebrick"),
  groups = c(),
  groupColSet = "Accent",
  label = "aberrant",
  subsetName = NULL
)

\S4method{plotCountCorHeatmap}{OutriderDataSet}(
  object,
  normalized = TRUE,
  rowCentered = TRUE,
  rowGroups = NA,
  rowColSet = NA,
  colGroups = NA,
  colColSet = NA,
  nRowCluster = 4,
  nColCluster = 4,
  main = "Count correlation heatmap",
  basePlot = TRUE,
  nBreaks = 50,
  show_names = c("none", "row", "col", "both"),
  ...
)

plotCountGeneSampleHeatmap(
  ods,
  normalized = TRUE,
  rowCentered = TRUE,
  rowGroups = NA,
  rowColSet = NA,
  colGroups = NA,
  colColSet = NA,
  nRowCluster = 4,
  nColCluster = 4,
  main = "Count Gene vs Sample Heatmap",
  bcvQuantile = 0.9,
  show_names = c("none", "col", "row", "both"),
  nGenes = 500,
  nBreaks = 50,
  ...
)

\S4method{plotAberrantPerSample}{OutriderDataSet}(
  object,
  main = "Aberrant Genes per Sample",
  outlierRatio = 0.001,
  col = "Dark2",
  yadjust = 1.2,
  ylab = "Aberrantly expressed genes",
  subsetName = NULL,
  ...
)

plotFPKM(ods, bins = 100)

\S4method{plotDispEsts}{OutriderDataSet}(
  object,
  compareDisp,
  xlim,
  ylim,
  main = "Dispersion estimates versus mean expression",
  ...
)

plotPowerAnalysis(ods)

\S4method{plotEncDimSearch}{OutriderDataSet}(object)

plotExpressedGenes(ods, main = "Statistics of expressed genes")

plotSizeFactors(ods, basePlot = TRUE)

\S4method{plotManhattan}{OutriderDataSet}(
  object,
  sampleID,
  value = "pvalue",
  chr = NULL,
  main = paste0("Sample: ", sampleID),
  featureRanges = rowRanges(object),
  subsetName = NULL,
  chrColor = c("black", "darkgrey"),
  padjCutoff = 0.05,
  zScoreCutoff = 0,
  highlight.label.size = 5
)
}
\arguments{
\item{...}{Additional parameters passed to plot() or plot_ly() if not stated
otherwise in the details for each plot function}

\item{sampleID, geneID}{A sample or gene ID, which should be plotted.
Can also be a vector. Integers are treated as indices.}

\item{main}{Title for the plot, if missing a default title will be used.}

\item{padjCutoff, zScoreCutoff}{Significance or Z-score cutoff
to mark outliers}

\item{label}{Indicates which genes or samples should be labeled. By default 
all aberrant genes/samples are labelled. Can be set to NULL for 
no labels. Provide a vector of geneIDs/sampleIDs to label 
specific genes/samples.}

\item{xaxis}{Indicates which assay should be shown on the x-axis of the 
volcano plot. Defaults to 'zscore'. Other options are 'fc' and 
'log2fc' for the fold-change or log2 fold-change.}

\item{pch}{Integer or character to be used for plotting the points}

\item{basePlot}{if \code{TRUE}, use the R base plot version, else use the
plotly framework, which is the default}

\item{col}{Set color for the points. If set, it must be a character vector
of length 2. (1. normal point; 2. outlier point) or a single 
character referring to a color palette from \code{RColorBrewer}.}

\item{subsetName}{The name of a subset of genes of interest for which FDR 
corrected pvalues were previously computed. Those FDR values 
on the subset will then be used to determine aberrant status. 
Default is NULL (using transcriptome-wide FDR corrected pvalues).}

\item{global}{Flag to plot a global Q-Q plot, default FALSE}

\item{samplePoints}{Sample points for Q-Q plot, defaults to max 30k points}

\item{legendPos}{Set legendpos, by default topleft.}

\item{outlierRatio}{The fraction to be used for the outlier sample filtering}

\item{conf.alpha}{If set, a confidence interval is plotted, defaults to 0.05}

\item{xlim, ylim}{The x/y limits for the plot or NULL to use
the full data range}

\item{ods, object}{An OutriderDataSet object.}

\item{log}{If TRUE, the default, counts are plotted in log10.}

\item{groups}{A character vector containing either group assignments of
samples or sample IDs. Is empty by default. If group assignments
are given, the vector must have the same length as the number of
samples. If sample IDs are provided the assignment will result
in a binary group assignemt.}

\item{groupColSet}{A color set from RColorBrewer or a manual vector of
colors, which length must match the number of categories
from groups.}

\item{normalized}{If TRUE, the normalized counts are used, the default,
otherwise the raw counts}

\item{rowCentered}{If TRUE, the counts are row-wise (gene-wise) centered}

\item{rowGroups, colGroups}{A vector of co-factors (colnames of colData)
for color coding the rows. It also accepts a data.frame of
dim = (#samples, #groups). Must have more than 2 groups.}

\item{rowColSet, colColSet}{A color set from RColorBrewer/colorRampPalette}

\item{nRowCluster, nColCluster}{Number of clusters to show in the row and
column dendrograms. If this argument is set the resulting
cluster assignments are added to the OutriderDataSet.}

\item{nBreaks}{number of breaks for the heatmap color scheme. Default to 50.}

\item{show_names}{character string indicating whether to show 'none', 'row',
'col', or 'both' names on the heatmap axes.}

\item{bcvQuantile}{quantile for choosing the cutoff for the biological 
coefficient of variation (BCV)}

\item{nGenes}{upper limit of number of genes (defaults to 500). Subsets the
top n genes based on the BCV.}

\item{yadjust}{Option to adjust position of Median and 90 percentile labels.}

\item{ylab}{The y axis label}

\item{bins}{Number of bins used in the histogram. Defaults to 100.}

\item{compareDisp}{If TRUE, the default, and if the autoCorrect normalization
was used it computes the dispersion without autoCorrect and
plots it for comparison.}

\item{value}{Indicates which assay is shown in the manhattan plot. Defaults 
to 'pvalue'. Other options are 'zScore' and 'log2fc'.}

\item{chr}{The chromosomes to be displayed in the \code{plotManhattan} 
function. Default is \code{NULL}, i.e. all chromosomes are shown.}

\item{featureRanges}{A GRanges object of the same length as the 
OutriderDataSet object that contains the genomic positions of 
features that are shown in the manhattan plot.}

\item{chrColor}{A vector of length 2 giving the two colors used for 
coloring alternating chromosomes in the manhattan plot. Default 
colors are 'black' and 'darkgrey'.}

\item{highlight.label.size}{Size of the label of the highlighted genes to be 
displayed in the \code{plotManhattan}. Default value is 5.}
}
\value{
If base R graphics are used nothing is returned else the plotly or
            the gplot object is returned.
}
\description{
The OUTRIDER package provides mutliple functions to visualize
the data and the results of a full data set analysis.

This is the list of all plotting function provided by OUTRIDER:
\itemize{
  \item plotAberrantPerSample()
  \item plotVolcano()
  \item plotExpressionRank()
  \item plotQQ()
  \item plotExpectedVsObservedCounts()
  \item plotCountCorHeatmap()
  \item plotCountGeneSampleHeatmap()
  \item plotSizeFactors()
  \item plotFPKM()
  \item plotExpressedGenes()
  \item plotDispEsts()
  \item plotPowerAnalysis()
  \item plotEncDimSearch()
}

For a detailed description of each plot function please see the details.
Most of the functions share the same parameters.
}
\details{
\code{plotAberrantPerSample}: The number of aberrant events per sample are
plotted sorted by rank. The ... parameters are passed on to the
\code{\link{aberrant}} function.

\code{plotVolcano}: the volcano plot is sample-centric. It plots for a given
sample the negative log10 nominal P-values against the Z-scores for all
genes.

\code{plotExpressionRank}: This function plots for a given gene the
expression level against the expression rank for all samples. This can
be used with normalized and unnormalized expression values.

\code{plotQQ}: the quantile-quantile plot for a given gene or if
\code{global} is set to \code{TRUE} over the full data set. Here the
observed P-values are plotted against the expected ones in the negative
log10 space.

\code{plotExpectedVsObservedCounts}: A scatter plot of the observed counts
against the predicted expression for a given gene. 
 
\code{plotCountCorHeatmap}: The correlation heatmap of the count data
of the full data set. Default the values are log transformed and
row centered. This function returns an OutriderDataSet with annotated
clusters if requested. The ... arguments are passed to the
\code{\link[pheatmap]{pheatmap}} function.

\code{plotCountGeneSampleHeatmap}: A gene x sample heatmap of the raw or
normalized counts. By default they are log transformed and row centered.
Only the top 500 viable genes based on the BCV (biological coefficient 
of variation) is used by default. 

\code{plotSizeFactors}: The sizefactor distribution within the dataset. 

\code{plotFPKM}: The distribution of FPKM values. If the OutriderDataSet
object contains the \code{passedFilter} column, it will plot both FPKM
distributions for the expressed genes and for the filtered genes.

\code{plotExpressedGenes}: A summary statistic plot on the number of genes
expressed within this dataset. It plots the sample rank (based on the 
number of expressed genes) against the accumulated statistics up to the 
given sample. 

\code{plotDispEsts}: Plots the dispersion of the OutriderDataSet
model against the normalized mean count. If autoCorrect is used it will also
estimate the dispersion without normalization for comparison.

\code{plotPowerAnalysis}: The power analysis plot should give the user a
ruff estimate of the events one can be detected with OUTRIDER. Based on
the dispersion of the provided OUTRIDER data set the theoretical P-value
over the mean expression is plotted. This is done for different expression
levels. The curves are smooths to make the reading of the plot easier.

\code{plotEncDimSearch}: Visualization of the estimation of the optimal
encoding dimension. If Optimal Hard Thresholding was used, the singular values
are plotted against their rank. If a hyperparameter optimization was performed, 
the encoding dimension against the achieved loss (area under the 
precision-recall curve) is plotted. 

\code{plotManhattan}: Visualizes different metrics for each gene (pvalue, 
log2 fold-change, z-score) along with the genomic coordinates of the 
respective gene as a manhattan plot. Detected outlier genes are highlighted 
in red.
}
\examples{
ods <- makeExampleOutriderDataSet(dataset="Kremer")
implementation <- 'autoencoder'
\dontshow{
    # reduce the object size to speed up the calculations
    ods <- ods[1:400,1:80]
    implementation <- 'pca'
}

mcols(ods)$basepairs <- 300 # assign pseudo gene length for filtering
ods <- filterExpression(ods)
# restrict FDR correction to set of genes of interest per sample
genesOfInterest <- list(MUC1372 = c("ATPIF1", "UROD", "YBX1", 
                                     sample(rownames(ods), 25)),
                        MUC1360 = sample(rownames(ods), 50),
                        MUC1350 = sample(rownames(ods), 75),
                        X76619 = sample(rownames(ods), 20),
                        X74172 = sample(rownames(ods), 150))
ods <- OUTRIDER(ods, implementation=implementation, subsets=list("exampleGenes"=genesOfInterest))

plotAberrantPerSample(ods)
plotAberrantPerSample(ods, subsetName="exampleGenes")

plotVolcano(ods, 49)
plotVolcano(ods, 'MUC1365', basePlot=TRUE)
plotVolcano(ods, 'MUC1351', basePlot=TRUE, xaxis="log2fc", label=c("NBPF16"))
plotVolcano(ods, 'MUC1372', basePlot=TRUE, subsetName="exampleGenes")

plotExpressionRank(ods, 35)
plotExpressionRank(ods, 35, subsetName="exampleGenes")
plotExpressionRank(ods, "NDUFS5", normalized=FALSE, label="MUC1372",
    log=FALSE, main="Over expression outlier", basePlot=TRUE)

plotQQ(ods, 149)
plotQQ(ods, 149, subsetName="exampleGenes")
plotQQ(ods, global=TRUE, outlierRatio=0.001)

plotExpectedVsObservedCounts(ods, 149)
plotExpectedVsObservedCounts(ods, "ATAD3C", basePlot=TRUE)
plotExpectedVsObservedCounts(ods, "UROD", subsetName="exampleGenes")

plotExpressedGenes(ods)

sex <- sample(c("female", "male"), dim(ods)[2], replace=TRUE)
colData(ods)$Sex <- sex
ods <- plotCountCorHeatmap(ods, nColCluster=4, normalized=FALSE)
ods <- plotCountCorHeatmap(ods, colGroup="Sex", colColSet="Set1")
table(colData(ods)$clusterNumber_4)

plotCountGeneSampleHeatmap(ods, normalized=FALSE)
plotCountGeneSampleHeatmap(ods, rowGroups="theta", 
        rowColSet=list(c("white", "darkgreen")))

plotSizeFactors(ods)

mcols(ods)$basepairs <- 1
mcols(ods)$passedFilter <- rowMeans(counts(ods)) > 10
plotFPKM(ods)

plotDispEsts(ods, compareDisp=FALSE)

plotPowerAnalysis(ods)

\dontrun{
# for speed reasons we only search for 5 different dimensions
ods <- estimateBestQ(ods, useOHT=FALSE, params=c(3, 10, 20, 35, 50), 
        implementation=implementation)
plotEncDimSearch(ods)
}

# To show the pvalues of a sample in a manhattan plot, rowRanges(ods) must 
# contain the genomic position of each feature or a GRanges object must 
# be provided 
\dontrun{
# in case rowRanges(ods) is a GRangesList, run this first once to speed up:
rowRanges(ods) <- unlist(endoapply(rowRanges(ods), range))
}
gr <- GRanges(
         seqnames=sample(paste0("chr", 1:22), nrow(ods), replace=TRUE),
         ranges=IRanges(start=runif(nrow(ods), min=0, max=1e5), width=100))
plotManhattan(ods, "MUC1350", value="pvalue", featureRanges=gr)
plotManhattan(ods, "MUC1350", value="l2fc", featureRanges=gr)
plotManhattan(ods, "MUC1372", featureRanges=gr, subsetName="exampleGenes")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/filterExpression.R
\name{computeGeneLength}
\alias{computeGeneLength}
\title{Extracting the gene length from annotations}
\usage{
computeGeneLength(ods, gtfFile, format = "gtf", mapping = NULL, ...)
}
\arguments{
\item{ods}{An OutriderDataSet for which the gene length should be computed.}

\item{gtfFile}{Can be a GTF file or an txDb object with annotation.}

\item{format}{The format parameter from \code{makeTxDbFromGFF}}

\item{mapping}{If set, it is used to map gene names between the GFT and the
ods object. This should be a 2 column data.frame: 
1. column GTF names and 2. column ods names.}

\item{...}{further arguments to \code{makeTxDbFromGFF}}
}
\value{
An OutriderDataSet containing a \code{basepairs} column with the 
            calculated gene length. Accessable through 
            \code{mcols(ods)['baisepairs']}
}
\description{
Computes the length for each gene based on the given GTF file or annotation.
Here the length of a gene is defind by the total number of bases covered
by exons.
}
\examples{

ods <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
annotationFile <- system.file("extdata", "gencode.v19.genes.small.gtf.gz",
        package="OUTRIDER")
ods <- computeGeneLength(ods, annotationFile)

mcols(ods)['basepairs']
fpkm(ods)[1:10,1:10]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-counts.R
\docType{methods}
\name{normalizationFactors}
\alias{normalizationFactors}
\alias{normalizationFactors,OutriderDataSet-method}
\alias{normalizationFactors<-,OutriderDataSet,matrix-method}
\alias{normalizationFactors<-,OutriderDataSet,DataFrame-method}
\alias{normalizationFactors<-,OutriderDataSet,NULL-method}
\alias{normalizationFactors<-,OutriderDataSet,data.frame-method}
\title{Accessor functions for the normalization factors in an OutriderDataSet
object.}
\usage{
\S4method{normalizationFactors}{OutriderDataSet}(object, ...)

\S4method{normalizationFactors}{OutriderDataSet,matrix}(object, minE = 0.5, ...) <- value

\S4method{normalizationFactors}{OutriderDataSet,DataFrame}(object, minE = 0.5, ...) <- value

\S4method{normalizationFactors}{OutriderDataSet,data.frame}(object, minE = 0.5, ...) <- value

\S4method{normalizationFactors}{OutriderDataSet,NULL}(object) <- value
}
\arguments{
\item{object}{An \code{\link{OutriderDataSet}} object}

\item{...}{Further arguments are passed on to the underlying assay function}

\item{minE}{The minimal expected count, defaults to 0.5, to be used in 
computing the expected log geom mean.}

\item{value}{The matrix of normalization factors}
}
\value{
A numeric matrix containing the normalization factors or the 
            OutriderDataSet object with an updated 
            \code{normalizationFactors} assay.
}
\description{
To normalize raw count data normalization factors can be provided as
a matrix. When running \code{\link{controlForConfounders}} the normalization 
factors are stored within the OutriderDataset object. This normalization 
factors are then used to compute the normalized counts.
}
\examples{

ods <- makeExampleOutriderDataSet()

normFactors <- matrix(runif(nrow(ods)*ncol(ods),0.5,1.5),
    ncol=ncol(ods),nrow=nrow(ods))

# the normalization factors matrix should not have 0's in it
# it should have geometric mean near 1 for each row
normFactorsRM <- normFactors / exp(rowMeans(log(normFactors)))
normalizationFactors(ods) <- normFactorsRM
normalizationFactors(ods)[1:10,1:10]

normalizationFactors(ods) <- NULL
ods <- estimateSizeFactors(ods)
normalizationFactors(ods) <- normFactors
all(normalizationFactors(ods) == t(sizeFactors(ods) * t(normFactors)))

}
\seealso{
\code{\link{sizeFactors}} 
         \code{\link[DESeq2]{normalizationFactors}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/controlForConfounders.R
\name{computeLatentSpace}
\alias{computeLatentSpace}
\title{Extracting the latent space}
\usage{
computeLatentSpace(ods)
}
\arguments{
\item{ods}{An OutriderDataSet}
}
\value{
A matrix containing the latent space determined by the autoencoder.
}
\description{
Extracts the latent space from the OutriderDataSet object 
determined by the autoencoder.
}
\examples{
ods <- makeExampleOutriderDataSet()
\dontshow{
    ods <- ods[1:10, 1:10]
}
ods <- estimateSizeFactors(ods)
ods <- controlForConfounders(ods, implementation="pca")
computeLatentSpace(ods)[,1:6]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class-OutriderDataSet.R
\docType{class}
\name{OutriderDataSet-class}
\alias{OutriderDataSet-class}
\alias{OutriderDataSet}
\title{OutriderDataSet class and constructors}
\usage{
OutriderDataSet(se, countData, colData, ...)
}
\arguments{
\item{se}{A RangedSummarizedExperiment object or any object which inherits
from it and contains a count matrix as the first element in the
assay list.}

\item{countData}{A simple count matrix. If dim names are provided, they have
to be unique. This is only used if no \code{se} object is
provided.}

\item{colData}{Additional to the count data a \code{DataFrame} can be 
provided to annotate the samples.}

\item{...}{Further arguments can be passed to
\code{\link[DESeq2]{DESeqDataSet}}, which is used to parse the
user input and create the initial 
\code{RangedSummarizedExperiment} object.}
}
\value{
An OutriderDataSet object.
}
\description{
The OutriderDataSet class is designed to store the whole 
OUTRIDER data set needed for an analysis. It is a subclass of 
\code{RangedSummarizedExperiment}. All calculated values and results are 
stored as assays or as annotation in the mcols structure provided by the
\code{RangedSummarizedExperiment} class.
}
\examples{

ods <- makeExampleOutriderDataSet()
ods

ods <- makeExampleOutriderDataSet(dataset="Kremer")
ods
   
}
\author{
Christian Mertes \email{mertes@in.tum.de}, 
            Felix Brechtmann \email{brechtma@in.tum.de}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/sizeFactor.R
\docType{methods}
\name{sizeFactors}
\alias{sizeFactors}
\alias{sizeFactors,OutriderDataSet-method}
\alias{sizeFactors<-}
\alias{sizeFactors<-,OutriderDataSet,numeric-method}
\alias{estimateSizeFactors}
\alias{estimateSizeFactors,OutriderDataSet-method}
\alias{sizeFactors<-,OutriderDataSet,NULL-method}
\title{SizeFactors accessor and estimation function}
\usage{
\S4method{sizeFactors}{OutriderDataSet}(object)

\S4method{sizeFactors}{OutriderDataSet,numeric}(object) <- value

\S4method{sizeFactors}{OutriderDataSet,NULL}(object) <- value

\S4method{estimateSizeFactors}{OutriderDataSet}(object)
}
\arguments{
\item{object}{OutriderDataSet}

\item{value}{A numberic vector of sizeFactors}
}
\value{
An OutriderDatasSet with the estimated sizeFactors, or with the 
            getter function it returns a numeric vector containing the 
            sizeFactors.
}
\description{
Accessor functions for the 'sizeFactors' information in a OutriderDataSet
object.
}
\details{
The estimation of the size factors can also make use of the existing 
log geometric means in the object. Those can be loaded from an 
existing model.
}
\examples{

ods <- makeExampleOutriderDataSet()
ods <- estimateSizeFactors(ods)
head(sizeFactors(ods))

sizeFactors(ods) <- runif(dim(ods)[2], 0.5, 1.5)
sizeFactors(ods)
counts(ods, normalized=TRUE)[1:10,1:10]
        
}
\seealso{
\code{\link[DESeq2]{estimateSizeFactors}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/method-results.R
\name{results}
\alias{results}
\alias{results,OutriderDataSet-method}
\title{Accessor function for the 'results' object in an OutriderDataSet object.}
\usage{
results(object, ...)

\S4method{results}{OutriderDataSet}(
  object,
  padjCutoff = 0.05,
  zScoreCutoff = 0,
  round = 2,
  all = FALSE,
  returnTranscriptomewideResults = TRUE,
  ...
)
}
\arguments{
\item{object}{An OutriderDataSet object}

\item{...}{Additional arguments, currently not used}

\item{padjCutoff}{The significant threshold to be applied}

\item{zScoreCutoff}{If provided additionally a z score threshold is applied}

\item{round}{Can be TRUE, defaults to 2, or an integer used for rounding
with \code{\link[base]{round}} to make the output
more user friendly}

\item{all}{By default FALSE, only significant read counts are listed in the 
results. If TRUE all results are assembled resulting in a 
data.table of length samples x genes.}

\item{returnTranscriptomewideResults}{If FDR corrected pvalues for subsets 
of genes of interest have been calculated, this parameter 
indicates whether additionally the transcriptome-wide results 
should be returned as well (default), or whether only results 
for those subsets should be retrieved.}
}
\value{
A data.table where each row is an outlier event and the columns
   contain additional information about this event. In details the 
   table contains: 
   \item{sampleID/geneID}{The gene or sample ID as provided by the 
         user, e.g. \code{rowData(ods)} and \code{colData(ods)},
         respectively.}
   \item{pValue/padjust}{The nominal P-value and the FDR corrected
         P-value (transcriptome-wide) indicating the outlier status.}
   \item{zScore/l2fc}{The z score and log\eqn{_2}{[2]} fold change 
       as computed by \code{\link[OUTRIDER]{computeZscores}}.}
   \item{rawcounts}{The observed read counts.}
   \item{normcounts}{The expected count given the fitted 
         autoencoder model for the given gene-sample combination.}
   \item{meanRawcounts/meanCorrected}{For this gene, the mean of the 
        observed or expected counts, respectively, given the fitted 
        autoencoder model.}
   \item{theta}{The dispersion parameter of the NB distribution 
         for the given gene.}
   \item{aberrant}{The transcriptome-wide outlier status of this event: 
         \code{TRUE} or \code{FALSE}.}
   \item{AberrantBySample/AberrantByGene}{Number of outliers for the 
         given sample or gene (transcriptome-wide), respectively.}
   \item{padj_rank}{Rank of this outlier event within the given sample.}
   \item{padjust_FDRset}{The FDR corrected P-value with respect to the 
         gene subset called 'FDRset', if gene subsets were specified 
         during the P-value computation. Find more details at 
         \code{\link[OUTRIDER]{computePvalues}}.}
}
\description{
This function assembles a results table of significant outlier events based
on the given filter criteria. The table contains various information 
accumulated over the analysis pipeline.
}
\examples{

ods <- makeExampleOutriderDataSet()
\dontshow{
    ods <- ods[1:10,1:10]
}
ods <- OUTRIDER(ods)

res <- results(ods, all=TRUE)
res

# example of retrieving results with FDR correction limited to a 
# set of genes of interest
genesOfInterest <- list("sample_1"=sample(rownames(ods), 3), 
                         "sample_2"=sample(rownames(ods), 8), 
                         "sample_6"=sample(rownames(ods), 5))
genesOfInterest
ods <- computePvalues(ods, subsets=list("exampleSubset"=genesOfInterest))
res <- results(ods, all=TRUE, returnTranscriptomewideResults=FALSE)
res

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method-counts.R
\docType{methods}
\name{counts}
\alias{counts}
\alias{counts,OutriderDataSet-method}
\alias{counts<-,OutriderDataSet,matrix-method}
\title{Accessors for the 'counts' slot of an OutriderDataSet object.}
\usage{
\S4method{counts}{OutriderDataSet}(object, normalized = FALSE, minE = 0.5, ...)

\S4method{counts}{OutriderDataSet,matrix}(object, ...) <- value
}
\arguments{
\item{object}{An \code{\link{OutriderDataSet}} object}

\item{normalized}{TRUE/FALSE whether counts should be normalized}

\item{minE}{The minimal expected count, defaults to 0.5, to be used in 
computing the expected log geom mean.}

\item{...}{Further arguments are passed on to the underlying assay function}

\item{value}{An integer matrix containing the counts}
}
\value{
A matrix containing the counts
}
\description{
The counts slot holds the count data as a matrix of non-negative integer
count values, one row for each observational unit (eg.: gene), and one
column for each sample.
}
\details{
By default this function returns the raw counts. If conrol factors are
computed or provided the normalized counts can be returned using 
normalized = TRUE. The offset parameter can be used to add a pseudocount
to the count before dividing by the normalization. This can be usefull 
when the log(counts) are computed and in case the controll values are in 
the same oder of magnited as the counts.
}
\examples{

ods <- makeExampleOutriderDataSet()
counts(ods)[1:10,1:10]

ods <- estimateSizeFactors(ods)
counts(ods, normalized=TRUE)[1:10,1:10]

}
\seealso{
\code{\link{sizeFactors}}, \code{\link{normalizationFactors}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ZscoreMatrix.R
\docType{methods}
\name{computeZscores}
\alias{computeZscores}
\alias{computeZscores,OutriderDataSet-method}
\title{Z score computation}
\usage{
computeZscores(ods, ...)

\S4method{computeZscores}{OutriderDataSet}(ods, peerResiduals = FALSE, ...)
}
\arguments{
\item{ods}{OutriderDataSet}

\item{...}{Further arguments passed on to \code{ZscoreMatrix}.}

\item{peerResiduals}{If TRUE, PEER residuals are used to compute Z scores}
}
\value{
An OutriderDataSet containing the Z score matrix "zScore" and
    the log2 fold changes "l2fc" as asasys.
}
\description{
Computes the z scores for every count in the matrix.
The z score is defined in the log\eqn{_2}{[2]} space as follows:
\eqn{z_{ij} = \frac{l_{ij} - \mu_j^l}{
     \sigma_j^l}}{z_ij = (l[ij] - mu[j]^l)/sigma[ij]}
where \code{l} is the log\eqn{_2}{[2]} transformed normalized count and 
\eqn{\mu}{mu} and \eqn{\sigma}{sigma} the mean and standard deviation 
for gene \code{j} and sample \code{i}, respectively.
}
\examples{
ods <- makeExampleOutriderDataSet()
ods <- estimateSizeFactors(ods)

ods <- controlForConfounders(ods, implementation="pca")
ods <- computeZscores(ods)

zScore(ods)[1:10,1:10]
assay(ods, "l2fc")[1:10,1:10]

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/OUTRIDER.R
\name{OUTRIDER}
\alias{OUTRIDER}
\title{OUTRIDER - Finding expression outlier events}
\usage{
OUTRIDER(
  ods,
  q,
  controlData = TRUE,
  implementation = "autoencoder",
  subsets = NULL,
  BPPARAM = bpparam(),
  ...
)
}
\arguments{
\item{ods}{An OutriderDataSet object}

\item{q}{The encoding dimensions}

\item{controlData}{If TRUE, the default, the raw counts are controled 
for confounders by the autoencoder}

\item{implementation}{"autoencoder", the default, will use the autoencoder
implementation. Also 'pca' and 'peer' can be used to control
for confounding effects}

\item{subsets}{A named list of named lists specifying any number of gene 
subsets (can differ per sample). For each subset, FDR correction
will be limited to genes in the subset, and the FDR corrected 
pvalues stored as an assay in the ods object in addition to the 
transcriptome-wide FDR corrected pvalues. See the examples for 
how to use this argument.}

\item{BPPARAM}{A 
\code{\link[BiocParallel:BiocParallelParam-class]{BiocParallelParam}}
        instance to be used for parallel computing.}

\item{...}{Further arguments passed on to \code{controlForConfounders}}
}
\value{
OutriderDataSet with all the computed values. The values are stored
            as assays and can be accessed by: \code{assay(ods, 'value')}.
            To get a full list of calculated values run:
            \code{assayNames(ods)}
}
\description{
The OUTRIDER function runs the default OUTRIDER pipeline 
combinig the fit, the computation of Z scores and P-values.
All computed values are returned as an OutriderDataSet object.

To have more control over each analysis step, one can call each 
function separately.

\enumerate{
    \item \code{\link{estimateSizeFactors}} to calculate the sizeFactors
    \item \code{\link{controlForConfounders}} to control for 
              confounding effects
    \item \code{\link{fit}} to fit the negative binomial model 
              (only needed if the autoencoder is not used)
    \item \code{\link{computePvalues}} to calculate the nominal and 
              adjusted P-values
    \item \code{\link{computeZscores}} to calculate the Z scores
}
}
\examples{
ods <- makeExampleOutriderDataSet()
implementation <- 'autoencoder'
\dontshow{
    ods <- ods[1:10,1:10]
    implementation <- 'pca'
}
ods <- OUTRIDER(ods, implementation=implementation)

pValue(ods)[1:10,1:10]
res <- results(ods, all=TRUE)
res

plotAberrantPerSample(ods)
plotVolcano(ods, 1)

# example of restricting FDR correction to subsets of genes of interest 
genesOfInterest <- list("sample_1"=sample(rownames(ods), 3), 
                         "sample_2"=sample(rownames(ods), 8), 
                         "sample_6"=sample(rownames(ods), 5))
genesOfInterest
ods <- OUTRIDER(ods, subsets=list("exampleSubset"=genesOfInterest))
padj(ods, subsetName="exampleSubset")[1:10,1:10]
res <- results(ods, all=TRUE)
res

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getNSetterFunsInternal.R
\name{sampleExclusionMask}
\alias{sampleExclusionMask}
\alias{sampleExclusionMask,}
\alias{`sampleExclusionMask<-`}
\alias{sampleExclusionMask<-}
\title{Sample exclusion}
\usage{
sampleExclusionMask(ods, aeMatrix = FALSE)

sampleExclusionMask(ods) <- value
}
\arguments{
\item{ods}{An OutriderDataSet object}

\item{aeMatrix}{If \code{TRUE}, it returns a 0/1 matrix for the 
internal autoencoder functions in the form of feature x sample}

\item{value}{A logical vector of the length of the samples. If \code{TRUE},
the corresponding sample will be excluded from the autoencoder
fit.}
}
\value{
The exclusion vector/matrix.
}
\description{
To exclude a sample from the fit process, one can use this function to mask 
specific samples. This can be used if replicates are present.
}
\examples{
ods <- makeExampleOutriderDataSet()
sampleExclusionMask(ods) <- sample(c(FALSE, TRUE), ncol(ods), replace=TRUE)

sampleExclusionMask(ods)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pValMatrix.R
\docType{methods}
\name{computePvalues}
\alias{computePvalues}
\alias{computePvalues,OutriderDataSet-method}
\title{Calculate P-values}
\usage{
computePvalues(object, ...)

\S4method{computePvalues}{OutriderDataSet}(
  object,
  alternative = c("two.sided", "greater", "less"),
  method = "BY",
  subsets = NULL,
  BPPARAM = bpparam()
)
}
\arguments{
\item{object}{An OutriderDataSet}

\item{...}{additional params, currently not used.}

\item{alternative}{Can be one of "two.sided", "greater" or "less" to specify
the alternative hypothesis used to calculate the P-values,
defaults to "two.sided"}

\item{method}{Method used for multiple testing}

\item{subsets}{A named list of named lists specifying any number of gene 
subsets (can differ per sample). For each subset, FDR correction
will be limited to genes in the subset, and the FDR corrected 
pvalues stored as an assay in the ods object in addition to the 
transcriptome-wide FDR corrected pvalues. See the examples for 
how to use this argument.}

\item{BPPARAM}{Can be used to parallelize the computation, defaults to
bpparam()}
}
\value{
An OutriderDataSet object with computed nominal and adjusted P-values
}
\description{
This function computes the P-values based on the fitted negative binomial
model being an outlier for the given sample gene combination. It computes
two matrices with the same dimension as the count matrix (samples x genes),
which contain the corresponding P-values and adjusted P-values of every 
count. The adjusted P-values are computed across all genes per sample.
}
\examples{
ods <- makeExampleOutriderDataSet()
\dontshow{
    ods <- ods[1:10,1:10]
}
ods <- estimateSizeFactors(ods)
ods <- fit(ods)

ods <- computePvalues(ods)

assays(ods)[['pValue']][1:10,1:10]

# example of restricting FDR correction to subsets of genes of interest
genesOfInterest <- list("sample_1"=sample(rownames(ods), 3), 
                         "sample_2"=sample(rownames(ods), 8), 
                         "sample_6"=sample(rownames(ods), 5))
ods <- computePvalues(ods, subsets=list("exampleSubset"=genesOfInterest))
padj(ods, subsetName="exampleSubset")[1:10,1:10]
ods <- computePvalues(ods, 
                 subsets=list("anotherExampleSubset"=rownames(ods)[1:5]))
padj(ods, subsetName="anotherExampleSubset")[1:10,1:10]

}
\seealso{
p.adjust
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/AllGenerics.R, R/filterExpression.R
\name{filterExpression}
\alias{filterExpression}
\alias{filterExpression,OutriderDataSet-method}
\title{Filter expression}
\usage{
filterExpression(object, ...)

\S4method{filterExpression}{OutriderDataSet}(
  object,
  gtfFile,
  fpkmCutoff = 1,
  percentile = 0.95,
  filterGenes = TRUE,
  savefpkm = FALSE,
  minCounts = FALSE,
  addExpressedGenes = TRUE,
  ...
)
}
\arguments{
\item{object}{An OutriderDataSet object}

\item{...}{Additional arguments passed to \code{computeGeneLength}}

\item{gtfFile}{A txDb object or a GTF/GFF file to be used as annotation}

\item{fpkmCutoff}{The threshold for filtering based on the FPKM value}

\item{percentile}{a numeric indicating the percentile FPKM value to compare
against the \code{fpkmCutoff}}

\item{filterGenes}{If TRUE, the default, the object is subseted.}

\item{savefpkm}{If TRUE, the FPKM values are saved as assay}

\item{minCounts}{If TRUE, only genes with 0 counts in all samples are 
filtered}

\item{addExpressedGenes}{If TRUE (default), adds 5 columns to the
\code{colData} with information regarding the number of 
expressed genes per sample}
}
\value{
An OutriderDataSet containing the \code{passedFilter} column, which
            indicates if the given gene passed the filtering threshold. If
            \code{filterGenes} is TRUE the object is already subsetted.
}
\description{
To filter out non expressed genes this method uses the FPKM values to 
get a comparable value over genes. For each gene, if the pth-
\code{percentile} is greater than the \code{fpkmCutoff} value, it passes the
filter. To calcute the FPKM values the user needs to provide a GTF file or 
the basepair parameter as described in \code{\link[DESeq2]{fpkm}}.
}
\examples{
ods <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
annotationFile <- system.file("extdata", 
    "gencode.v19.genes.small.gtf.gz", package="OUTRIDER")
ods <- filterExpression(ods, annotationFile, filterGenes=FALSE)

mcols(ods)['passedFilter']
fpkm(ods)[1:10,1:10]
dim(ods)

ods <- ods[mcols(ods)[['passedFilter']]]
dim(ods)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/class-OutriderDataSet.R
\name{makeExampleOutriderDataSet}
\alias{makeExampleOutriderDataSet}
\title{Create example data sets for OUTRIDER}
\usage{
makeExampleOutriderDataSet(
  n = 200,
  m = 80,
  q = 10,
  freq = 0.001,
  zScore = 6,
  inj = c("both", "low", "high"),
  sf = rnorm(m, mean = 1, sd = 0.1),
  dataset = c("none", "GTExSkinSmall", "KremerNBaderSmall")
)
}
\arguments{
\item{n}{Number of simulated genes}

\item{m}{Number of simulated samples}

\item{q}{number of simulated latend variables.}

\item{freq}{Frequency of in-silico outliers}

\item{zScore}{Absolute z score of in-silico outliers (default 6).}

\item{inj}{Determines whether counts are injected with the strategy 
('both', 'low', 'high'), default is 'both'.}

\item{sf}{Artificial Size Factors}

\item{dataset}{If "none", the default, an example data set is simulated. 
One can also use example data set included in the package by
specifying 'GTExSkinSmall' or 'KremerNBaderSmall'}
}
\value{
An OutriderDataSet containing an example dataset. Depending on the
           parameters it is based on a real data set or it is simulated
}
\description{
Creates an example data set from a file or simulates a data set based 
on random counts following a negative binomial distribution with injected
outliers with a fixed z score away from the mean of the gene.
}
\examples{
# A generic dataset 
ods1 <- makeExampleOutriderDataSet()
ods1

# A generic dataset with specificed sample size and injection method
ods2 <- makeExampleOutriderDataSet(n=200, m=50, inj='low')
ods2

# A subset of a real world dataset from GTEx 
ods3 <- makeExampleOutriderDataSet(dataset="GTExSkinSmall")
ods3

}
